/* $Copyright$
 *  Copyright (C) Fujitsu Technology Solutions 2009, 2011
 *  All rights reserved
 */
/* $Copyright$
 *  Copyright (C) Fujitsu Siemens Computers GmbH 2001, 2002, 2004, 2005, 2006, 2007, 2008, 2009
 *  All rights reserved
 */
#ident "$Header$"
#ifndef WITHOUT_SYSTEM_INCLUDES_ON_PRECOMPILE
#ifndef _SMBUS_INCLUDE_H
	#define _SMBUS_INCLUDE_H
	#ifndef LINUX_VERSION_CODE
		#include <linux/version.h>
	#endif	// LINUX_VERSION_CODE
	#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,00)
		#ifndef		KERNEL26
			#define	KERNEL26		 1
		#endif		// KERNEL26
		#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,16)
			#ifndef		KERNEL2616
				#define	KERNEL2616		 1
			#endif		// KERNEL2616
		#endif	// LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,16)
		#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,27)
			#ifndef		KERNEL2627
				#define KERNEL2627
			#endif		// KERNEL2627
		#endif // LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,27)
		#if LINUX_VERSION_CODE >= KERNEL_VERSION(3,0,0)
			#ifndef		KERNEL30
				#define	KERNEL30		 1
			#endif		// KERNEL30
		#endif	// LINUX_VERSION_CODE >= KERNEL_VERSION(3,0,0)
	#else
		// Since, we do not support kernel versions less than 2.4.00, so
		// we assume here kernel version 2.4.xx
		#ifndef		KERNEL24
			#define	KERNEL24		 1
		#endif		// KERNEL24
		#ifndef		__KERNEL__
			#define	__KERNEL__		 1
		#endif		// __KERNEL__
		#ifndef MODULE_SUB
			#define MODULE
		#endif
		#include <linux/modversions.h>
	#endif		// LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,00)
	#include <linux/module.h>
	#include <linux/vmalloc.h>
	#include <linux/types.h>
	#include <linux/kernel.h>
	#include <linux/sched.h>
	#include <linux/slab.h>
	#include <linux/mm.h>
	#include <linux/string.h>
	#include <linux/errno.h>
	#include <linux/ioctl.h>
	#include <linux/delay.h>
	#include <linux/pci.h>
	#include <linux/pm.h>
	#include <asm/io.h>					// inb_p
	#include <asm/uaccess.h>			// put_user
	#ifdef	KERNEL2627
		#include <linux/fs.h>
	#endif	// KERNEL2627
	#ifdef	KERNEL24
		#include <linux/wrapper.h>
		#include <linux/pc_keyb.h>
	#endif	// KERNEL24
	#if defined(__x86_64__) && !defined(KERNEL2616)
		#include <asm/ioctl32.h>
	#endif	// defined(__x86_64__) && !defined(KERNEL2616)
	#include <linux/spinlock.h>
	#ifndef	KERNEL2627
		#include <asm/semaphore.h>
	#endif	// KERNEL2627
	#include <linux/smp.h>
	// -------------------------------------------------------------------------
	// On kernel version 2.6 and kernel version from 2.6.16 (e.g.SLES10),
	// we have to adjust some defines
	#ifdef KERNEL26
		#define mem_map_reserve(p)		set_bit(PG_reserved, &((p)->flags))
		#define mem_map_unreserve(p)	clear_bit(PG_reserved, &((p)->flags))
		#define KBD_CNTL_REG			0x64	// Controller command register (W)
	#endif  // KERNEL26
	#ifdef	KERNEL2616
		#ifndef		USE_SYMBOL_IF_FOR_MODULE_INTERACTION
			#define	USE_SYMBOL_IF_FOR_MODULE_INTERACTION	 1
		#endif		// USE_SYMBOL_IF_FOR_MODULE_INTERACTION
		#ifndef		USE_REMAP_PFN_RANGE
			#define	USE_REMAP_PFN_RANGE						 1
		#endif		// USE_REMAP_PFN_RANGE
	#endif	// KERNEL2616
	#ifdef	KERNEL2616
		#define DRIVER_PARAMETER(param,str,type,perm)	module_param(param, type, perm)
	#else
		#define DRIVER_PARAMETER(param,str,type,perm)	MODULE_PARM(param, str)
	#endif	// KERNEL2616
	#if defined(__x86_64__)
		#ifdef KERNEL2616
			#ifndef		USE_COMPAT_IOCTL
				#define	USE_COMPAT_IOCTL						 1
			#endif		// USE_COMPAT_IOCTL
		#else
			#ifndef		USE_REGISTER_IOCTL32_CONVERSION
				#define	USE_REGISTER_IOCTL32_CONVERSION			 1
			#endif		// USE_REGISTER_IOCTL32_CONVERSION
		#endif // KERNEL2616
	#endif // defined(__x86_64__)
	// Avoid compiler problems on SLES10 SP2 with xen kernel
	// undef the macro VOID from hypercall.h
	#ifdef VOID
	#undef VOID
	#endif // VOID
	// -------------------------------------------------------------------------
	#ifndef MODULE_INFO
		#define	MODULE_INFO(tag, string)			// dummy on kernel 2.4.xx
	#endif // MODULE_INFO
	MODULE_LICENSE("GPL");
	MODULE_AUTHOR("Fujitsu Technology Solutions");
	MODULE_INFO(supported, "yes");
	MODULE_DESCRIPTION("allow access to BIOS, SMBUS, and cpuid / msr registers");
	MODULE_INFO(device, "/dev/pci/smbus");
	MODULE_SUPPORTED_DEVICE("/dev/pci/smbus");
#endif // _SMBUS_INCLUDE_H
#endif  // WITHOUT_SYSTEM_INCLUDES_ON_PRECOMPILE
#ident "$Header: $"
#ifndef MYMOD_ISKMPMODULE
#define MYMOD_ISKMPMODULE "yes"
#endif
#ifndef MYMOD_OBJDATE
#define MYMOD_OBJDATE "unknown"
#endif
#ifndef MYMOD_COMPILERVERSRION
#define MYMOD_COMPILERVERSRION "unknown"
#endif
#ifndef MYMOD_KERNELVERSION
#define MYMOD_KERNELVERSION "unknown"
#endif
#ifndef MYMOD_OSARCHITECTURE
#define MYMOD_OSARCHITECTURE "unknown"
#endif
#ifndef MYMOD_OSVERSION
#define MYMOD_OSVERSION "unknown"
#endif
#ident "$Header$"
#ident "$Header: $"
typedef char CHAR;
typedef short SHORT;
typedef int BOOL;
typedef int INT;
typedef int LONG32;
typedef long LONG;
typedef float FLOAT;
typedef double DOUBLE;
typedef long long LONGLONG;
typedef long long LONG64;
typedef unsigned char BYTE;
typedef unsigned char UCHAR;
typedef unsigned char UINT8;
typedef unsigned short WORD;
typedef unsigned short USHORT;
typedef unsigned short UINT16;
typedef unsigned int DWORD;
typedef unsigned int UINT;
typedef int INT32;
typedef unsigned int UINT32;
typedef long long int INT64;
typedef unsigned long long int UINT64;
typedef unsigned long ULONG;
typedef unsigned long long DWORDLONG;
typedef unsigned long long QWORD;
typedef unsigned long long DWORD64;
typedef unsigned long long ULONG64;
typedef unsigned long long ULONGLONG;
typedef size_t SIZE_T;
typedef ssize_t SSIZE_T;
typedef void VOID;
typedef signed int INT_PTR, *PINT_PTR;
typedef unsigned int UINT_PTR, *PUINT_PTR;
typedef signed long LONG_PTR, *PLONG_PTR;
typedef unsigned long ULONG_PTR, *PULONG_PTR;
typedef ULONG_PTR DWORD_PTR, *PDWORD_PTR;
typedef CHAR *PCHAR;
typedef SHORT *PSHORT;
typedef FLOAT *PFLOAT;
typedef DOUBLE *PDOUBLE;
typedef UCHAR *PUCHAR;
typedef USHORT *PUSHORT;
typedef UINT *PUINT;
typedef ULONG *PULONG;
typedef CHAR *PSTR;
typedef const CHAR *PCSTR;
typedef CHAR *PTSTR;
typedef CHAR *PSZ;
typedef CHAR *LPSZ;
typedef CHAR *LPSTR;
typedef CHAR *LPTSTR;
typedef const CHAR *LPCSTR;
typedef const CHAR *LPCTSTR;
typedef const BYTE *LPCBYTE;
typedef BOOL *PBOOL;
typedef BOOL *LPBOOL;
typedef BYTE *PBYTE;
typedef BYTE *LPBYTE;
typedef INT *PINT;
typedef INT *LPINT;
typedef WORD *PWORD;
typedef WORD *LPWORD;
typedef LONG *PLONG;
typedef LONG *LPLONG;
typedef DWORD *PDWORD;
typedef DWORD *LPDWORD;
typedef DWORDLONG *PDWORDLONG;
typedef DWORDLONG *LPDWORDLONG;
typedef VOID *PVOID;
typedef VOID *LPVOID;
typedef const VOID *LPCVOID;
typedef WORD WCHAR;
typedef WORD *LPWSTR;
typedef const WORD *LPCWSTR;
typedef unsigned char BOOLEAN;
#pragma pack (1)
typedef union _LARGE_INTEGER {
 struct {
  DWORD LowPart;
  DWORD HighPart;
 } u;
 DWORD64 QuadPart;
} LARGE_INTEGER;
#pragma pack ()
#pragma pack (1)
typedef struct _LA_Driver_IoCtrl_ {
 DWORD64 pInBuffer;
 DWORD64 pOutBuffer;
 DWORD InBufferSize;
 DWORD OutBufferSize;
 DWORD ReturnedBytes;
 BOOL Success;
} LA_DRIVER_IOCTRL;
#pragma pack ()
#pragma pack (1)
typedef struct _SmbiHeader
{
 DWORD sig0;
 DWORD sig1;
 BYTE version;
 BYTE revision;
 DWORD CMD_Pointer;
 WORD CMD_size;
 DWORD Result_Pointer;
 WORD Result_size;
 DWORD SMB_command32;
 DWORD SMB_command32near;
 DWORD SMB_command16;
} SMBI_HEADER, *P_SMBI_HEADER;
typedef struct _SmbiHeader_64
{
 DWORD sig0;
 DWORD sig1;
 BYTE version;
 BYTE revision;
 DWORD CMD_Pointer;
 WORD CMD_size;
 DWORD Result_Pointer;
 WORD Result_size;
 DWORD SMB_command32;
 DWORD SMB_command32near;
 DWORD SMB_command16;
 DWORDLONG SMB_command64;
 DWORDLONG SMB_command64near;
} SMBI_HEADER_64, *P_SMBI_HEADER_64;
typedef union _SmbiSignature
{
 DWORD Signature;
 BYTE SigChar[4];
} SMBI_USIG, *P_SMBI_USIG;
typedef struct
{
 BYTE Second;
 BYTE Minute;
 BYTE Hour;
 BYTE DayOfMonth;
 BYTE Month;
 BYTE Year;
 BYTE Century;
} AUTOPOWER, *P_AUTOPOWER;
typedef struct
{
 BYTE Channel;
 BYTE Address;
 BYTE Offset;
 union
 {
  BYTE Data_Byte;
  WORD Data_Word;
 } u;
} SMBUS, *P_SMBUS;
typedef struct
{
 BYTE Day;
 BYTE Month;
 BYTE Year;
 BYTE Century;
} BATTINST, *P_BATTINST;
typedef struct
{
 BYTE Generic_Index;
 BYTE FanCtrlBytes[3];
} GENIFV2, *P_GENIFV2;
typedef struct
{
 BYTE Version;
 BYTE NrOfMaxEntries;
 BYTE NrOfEntries;
} EVENTLOGHDR, *P_EVENTLOGHDR;
typedef struct
{
 WORD row_address;
 BYTE row_number;
 WORD column_address;
 BYTE ECC_Syndrome;
} SBEDETAILS, *P_SBEDETAILS;
typedef struct
{
 BYTE device_id;
 BYTE reg_offset;
} SMBUSERROR, *P_SMBUSERROR;
typedef struct
{
 BYTE Type;
 BYTE SubType;
 BYTE _Century;
 BYTE _Year;
 BYTE _Month;
 BYTE _Day;
 BYTE _Hour;
 BYTE _Minute;
 BYTE _Second;
 union
 {
  SBEDETAILS SBE;
  SMBUSERROR SMBusError;
 } details;
} EVENTRECORDV1, *P_EVENTRECORDV1;
typedef struct
{
 WORD RecordId;
 BYTE RecodType;
 BYTE _Year;
 BYTE _Month;
 BYTE _Day;
 BYTE _Hour;
 BYTE _Minute;
 BYTE _Second;
 BYTE EvMRev;
 BYTE SensorType;
 BYTE SensorNr;
 BYTE EventDir;
 BYTE EventData_1;
 BYTE EventData_2;
 BYTE EventData_3;
} EVENTRECORDV2, *P_EVENTRECORDV2;
typedef struct
{
 BYTE Time;
 BYTE Active;
} WATCHDOG, *P_WATCHDOG;
typedef struct
{
 BYTE MaxNumber;
 BYTE Status[4];
} CPU, *P_CPU;
typedef struct
{
 BYTE InformationMap;
 WORD Voltage;
 WORD Temperature;
 WORD FanSpeed;
} CPUINFO, *P_CPUINFO;
typedef struct
{
 BYTE NrSupported;
 WORD Type[1];
} QUERYFAN, *P_QUERYFAN;
typedef struct
{
 BYTE NrSupported;
 BYTE Type[1];
} QUERYTYPE, *P_QUERYTYPE;
typedef struct
{
 BYTE _Y;
 BYTE _X;
} VOLTAGES, *P_VOLTAGES;
typedef struct
{
 BYTE low_Y;
 BYTE low_X;
 BYTE high_Y;
 BYTE high_X;
} VOLTTHRESHOLDS, *P_VOLTTHRESHOLDS;
typedef struct
{
 union
 {
  BYTE NrMaxSupported;
  BYTE Generic_Index;
  BYTE SensorReading[2];
  VOLTAGES voltages;
  VOLTTHRESHOLDS voltThresholds;
  BYTE Intrusion[2];
  BYTE QueryBytes[4];
  WORD QueryWords[2];
  DWORD QueryDWord[1];
 } g;
} SMBIV2, *P_SMBIV2;
typedef struct CMD_PACKET {
 BYTE OpCode;
 BYTE SubOpCode;
 union
 {
  BYTE SetBoot_Boot_Device;
  BYTE SetBoot_Diagnostic_Device;
  AUTOPOWER AutoPower;
  BYTE Set_ACLR;
  BYTE WatchDog_Time;
  BYTE Retry_Counter;
  BYTE Critical_Flag;
  BYTE Delay_Time;
  BYTE Voltage_No;
  SMBUS SMBus;
  BYTE CPU_Instance;
  BYTE FAN_Instance;
  BYTE DevInstance;
  BATTINST BattInstallDate;
  GENIFV2 V2InterFace;
  BYTE Data[254];
 } u;
} COMMAND_PACKET, *P_COMMAND_PACKET;
typedef struct RESULT_PACKET {
 BYTE Status;
 BYTE Len;
 union{
  EVENTLOGHDR EventLogHdr;
  EVENTRECORDV1 EventLogEntry;
  EVENTRECORDV2 EventRecord;
  WATCHDOG WatchDog;
  BYTE Get_ACLR;
  BYTE Retry_Counter;
  BYTE Delay_Time;
  BYTE SMBus_Data_Byte;
  WORD SMBus_Data_Word;
  BYTE GetBoot_Boot_Device;
  BYTE GetBoot_Diagnostic_Device;
  BYTE Critical_Flag;
  CPU Cpu;
  CPUINFO CpuInfo;
  QUERYFAN QueryFan;
  QUERYTYPE QueryType;
  BATTINST BattInstallDate;
  WORD Voltage;
  SMBIV2 SmbiV2;
  BYTE Data[254];
 } u;
} RESLT_PACKET, *P_RESLT_PACKET;
#pragma pack ()
typedef DWORD BAPI_SIGNUM;
typedef VOID ( *BIOSAPI)(ULONG InBuffer, ULONG OutBuffer, ULONG ControlBuffer);
#pragma pack (1)
typedef union _BAPI_SIGN
{
 BYTE SignByte[sizeof(DWORD)];
 DWORD SignDword;
} BAPI_SIGN, *PBAPI_SIGN;
typedef struct _BIOS_API_HEADER
{
 DWORD Signature;
 BYTE Length;
 BYTE Checksum;
 BYTE Version;
 BYTE Reserved;
 WORD BIOS_16_Offset;
 DWORD BIOS_16_Base;
 WORD BIOS_32_Offset;
 DWORD BIOS_32_Base;
} BIOS_API_HEADER, *P_BIOS_API_HEADER;
typedef struct _BIOS_API_HEADER_64
{
 DWORD Signature;
 BYTE Length;
 BYTE Checksum;
 BYTE Version;
 BYTE Reserved;
 WORD BIOS_16_Offset;
 DWORD BIOS_16_Base;
 WORD BIOS_32_Offset;
 DWORD BIOS_32_Base;
 WORD BIOS_64_Offset;
 DWORD BIOS_64_Base;
} BIOS_API_HEADER_64, *P_BIOS_API_HEADER_64;
typedef struct _BAPI_CTRL_IN
{
 WORD Length;
 DWORD Signature;
 DWORD ServiceCode;
 BYTE Reserved[6];
 BYTE ScratchPad[1008];
} BAPI_CTRL_IN, *P_BAPI_CTRL_IN;
typedef struct _BAPI_CTRL_OUT
{
 WORD Length;
 DWORD Signature;
 DWORD ActionCode;
 BYTE GeneralStatus;
 WORD ErrorCode;
 BYTE Reserved[3];
 BYTE ScratchPad[1008];
} BAPI_CTRL_OUT, *P_BAPI_CTRL_OUT;
typedef struct _NV_FUNC_CTRL
{
 WORD FunctionControl;
 BYTE Reserved[4];
} NV_FUNC_CTRL, *P_NV_FUNC_CTRL;
typedef struct _NV_IDPROM_CTRL
{
 BYTE Class;
 BYTE Device;
 WORD StartAddress;
 WORD NrOfBytes;
} NV_IDPROM_CTRL, *P_NV_IDPROM_CTRL;
typedef struct _BAPI_CTRL_NV_IN
{
 WORD Length;
 DWORD Signature;
 DWORD ServiceCode;
 union
 {
  NV_FUNC_CTRL NvFuncCtrl;
  NV_IDPROM_CTRL NvIdpromCtrl;
 };
 BYTE ScratchPad[1008];
} BAPI_CTRL_NV_IN, *P_BAPI_CTRL_NV_IN;
typedef union _BIOS_API_CONTROL
{
 BAPI_CTRL_IN In;
 BAPI_CTRL_NV_IN NvIn;
 BAPI_CTRL_OUT Out;
} BIOS_API_CONTROL, *PBIOS_API_CONTROL;
typedef struct _BAPI_BUF_SNIBS_IN
{
 DWORD Reserved;
} BAPI_BUF_SNIBS_IN, *P_BAPI_BUF_SNIBS_IN;
typedef struct _BAPI_BUF_SNIFU_IN
{
 WORD Reserved;
 struct
 {
  DWORD Address;
  DWORD Length;
 }Segment;
}BAPI_BUF_SNIFU_IN, *P_BAPI_BUF_SNIFU_IN;
typedef struct _BAPI_BUF_SNIFA_IN
{
 DWORD Empty;
}BAPI_BUF_SNIFA_IN, *P_BAPI_BUF_SNIFA_IN;
typedef struct _BAPI_BUF_SNISM_IN
{
 DWORD Parameter;
}BAPI_BUF_SNISM_IN, *P_BAPI_BUF_SNISM_IN;
typedef struct _BAPI_BUF_SNI0W_DEVICEINFO_OUT
{
 DWORD SerialNo;
 BYTE FwRevision;
 BYTE Build;
 BYTE Capabilities;
 BYTE BTL_Revision;
} BAPI_BUF_SNI0W_DEVICEINFO_OUT, *P_BAPI_BUF_SNI0W_DEVICEINFO_OUT;
typedef struct _BAPI_BUF_SNI0W_IN
{
 BYTE Feature;
 BYTE DisaStart_Seconds;
 BYTE DisaStart_Minutes;
 BYTE DisaStart_Hours;
 BYTE DisaEnd_Seconds;
 BYTE DisaEnd_Minutes;
 BYTE DisaEnd_Hours;
} BAPI_BUF_SNI0W_IN, *P_BAPI_BUF_SNI0W_IN;
typedef struct _BAPI_BUF_SNION_IN
{
 BYTE Seconds;
 BYTE Minutes;
 BYTE Hours;
 BYTE Day;
 BYTE Month;
 BYTE Year;
 BYTE Century;
 BYTE DayOfWeek;
}BAPI_BUF_SNION_IN, *P_BAPI_BUF_SNION_IN;
typedef struct _BAPI_BUF_SNIME_IN
{
 DWORD Signature;
 WORD NrOfModules;
 WORD TotalErrors;
 WORD ErrorModule[6];
 BYTE Reserved[26];
}BAPI_BUF_SNIME_IN, *P_BAPI_BUF_SNIME_IN;
typedef struct _SNINV_TOKEN_IN
{
 union
 {
  WORD Value;
  BYTE Data[46];
 };
}SNINV_TOKEN_IN, *P_SNINV_TOKEN_IN;
typedef struct _SNINV_IDPROM_IN
{
 BYTE Data[46];
}SNINV_IDPROM_IN, *P_SNINV_IDPROM_IN;
typedef struct _BAPI_BUF_SNINV_IN
{
 union
 {
  SNINV_TOKEN_IN Token;
  SNINV_IDPROM_IN IdProm;
 };
}BAPI_BUF_SNINV_IN, *P_BAPI_BUF_SNINV_IN;
typedef struct _BAPI_BUF_SNIBS_OUT
{
 DWORD BufSize;
 BYTE Reserved[26];
}BAPI_BUF_SNIBS_OUT, *P_BAPI_BUF_SNIBS_OUT;
typedef struct _BAPI_BUF_SNIFU_OUT
{
 DWORD Empty;
}BAPI_BUF_SNIFU_OUT, *P_BAPI_BUF_SNIFU_OUT;
typedef struct _BAPI_BUF_SNIFA_OUT
{
 WORD Reserved;
 struct
 {
  DWORD Address;
  DWORD Length;
 }Segment[1];
}BAPI_BUF_SNIFA_OUT, *P_BAPI_BUF_SNIFA_OUT;
typedef struct _BAPI_BUF_SNISM_OUT
{
 DWORD Parameter;
}BAPI_BUF_SNISM_OUT, *P_BAPI_BUF_SNISM_OUT;
typedef struct _BAPI_BUF_SNI0W_OUT
{
 BYTE Feature;
 BYTE DisaStart_Seconds;
 BYTE DisaStart_Minutes;
 BYTE DisaStart_Hours;
 BYTE DisaEnd_Seconds;
 BYTE DisaEnd_Minutes;
 BYTE DisaEnd_Hours;
} BAPI_BUF_SNI0W_OUT, *P_BAPI_BUF_SNI0W_OUT;
typedef struct _BAPI_BUF_SNION_OUT
{
 BYTE Seconds;
 BYTE Minutes;
 BYTE Hours;
 BYTE Day;
 BYTE Month;
 BYTE Year;
 BYTE Century;
 BYTE DayOfWeek;
}BAPI_BUF_SNION_OUT, *P_BAPI_BUF_SNION_OUT;
typedef struct _BAPI_BUF_SNIME_OUT
{
 DWORD Signature;
 WORD NrOfModules;
 WORD TotalErrors;
 WORD ErrorModule[6];
 BYTE Reserved[26];
}BAPI_BUF_SNIME_OUT, *P_BAPI_BUF_SNIME_OUT;
typedef struct _SNINV_TOKEN_OUT
{
 union
 {
  WORD Value;
  BYTE Data[46];
 };
}SNINV_TOKEN_OUT, *P_SNINV_TOKEN_OUT;
typedef struct _SNINV_TOKEN_PROPERTIES_OUT
{
 BYTE Media;
 BYTE BitArray;
 BYTE BuildCheckSum;
 BYTE CheckSum;
 WORD StartPos;
 BYTE Size;
}SNINV_TOKEN_PROP_OUT, *P_SNINV_TOKEN_PROP_OUT;
typedef struct _SNINV_SERVICE_CAP_OUT
{
 WORD Version;
 WORD Media;
 WORD Access;
}SNINV_SERVICE_CAP_OUT, *P_SNINV_SERVICE_CAP_OUT;
typedef struct _SNINV_MEDIA_PROP_OUT
{
 WORD MediaSize;
 BYTE MediaClass;
}SNINV_MEDIA_PROP_OUT, *P_SNINV_MEDIA_PROP_OUT;
typedef struct _SNINV_IDPROM_OUT
{
 BYTE Data[46];
}SNINV_IDPROM_OUT, *P_SNINV_IDPROM_OUT;
typedef struct _IDPROM_CLS_INFO
{
 BYTE IdPromCls;
 BYTE NrOfDevices;
 WORD IdPromSize;
}IDPROM_CLS_INFO, *P_IDPROM_CLS_INFO;
typedef struct _SNINV_IDPROM_CLS_OUT
{
 WORD NrOfClasses;
 BYTE SizeOfInfo;
 IDPROM_CLS_INFO IdPromInfo[1];
}SNINV_IDPROM_CLS_OUT, *P_SNINV_IDPROM_CLS_OUT;
typedef struct _BAPI_BUF_SNINV_OUT
{
 union
 {
  SNINV_TOKEN_OUT Token;
  SNINV_TOKEN_PROP_OUT TokenProperties;
  SNINV_SERVICE_CAP_OUT Capabilities;
  SNINV_MEDIA_PROP_OUT MediaProperties;
  SNINV_IDPROM_OUT IdProm;
  SNINV_IDPROM_CLS_OUT IdPromCls;
 };
}BAPI_BUF_SNINV_OUT, *P_BAPI_BUF_SNINV_OUT;
typedef union _BIOS_API_BUFFER
{
 struct
 {
  WORD Length;
  union
  {
   BAPI_BUF_SNIBS_IN Snibs;
   BAPI_BUF_SNIFU_IN Snifu;
   BAPI_BUF_SNIFA_IN Snifa;
   BAPI_BUF_SNISM_IN Snism;
   BAPI_BUF_SNION_IN Snion;
   BAPI_BUF_SNIME_IN Snime;
   BAPI_BUF_SNINV_IN Sninv;
   BAPI_BUF_SNI0W_IN Sni0w;
  }Svc;
 }In;
 struct
 {
  WORD Length;
  union
  {
   BAPI_BUF_SNIBS_OUT Snibs;
   BAPI_BUF_SNIFU_OUT Snifu;
   BAPI_BUF_SNIFA_OUT Snifa;
   BAPI_BUF_SNISM_OUT Snism;
   BAPI_BUF_SNION_OUT Snion;
   BAPI_BUF_SNIME_OUT Snime;
   BAPI_BUF_SNINV_OUT Sninv;
   BAPI_BUF_SNI0W_OUT Sni0w;
  }Svc;
 } Out;
} BIOS_API_BUFFER, *PBIOS_API_BUFFER;
typedef struct _BAPI_QWORD
{
 DWORD LowPart;
 DWORD HighPart;
} BAPI_QWORD, *PBAPI_QWORD;
typedef struct _BAPI_EVENTS
{
 union
 {
  struct
  {
   WORD Length;
   DWORD Signature;
   BAPI_QWORD Features;
   BAPI_QWORD Events;
  }AsStruct;
  BYTE AsBytes[32];
 }Ev;
} BIOS_API_EVENTS, *P_BIOS_API_EVENTS;
typedef struct _BAPI_EVENTS_STRUCT
{
 P_BIOS_API_EVENTS pEventsIn;
 P_BIOS_API_EVENTS pEventsOut;
}BAPI_EVENTS_STRUCT, *PBAPI_EVENTS_STRUCT;
typedef struct _BAPI_MEMORY_ERRORS
{
 union
 {
  struct
  {
   WORD Length;
   DWORD Signature;
   WORD NrOfModules;
   WORD TotalErrors;
   WORD ErrorModule[16];
   BYTE Reserved[2];
   DWORD Flags;
   DWORD NrErrorDescriptors;
   BAPI_QWORD ErrorDescriptors[12];
  }AsStruct;
  BYTE AsBytes[256];
 }Mem;
} BIOS_API_MEMERRS, *P_BIOS_API_MEMERRS;
typedef struct _BIOS_API
{
 BIOS_API_CONTROL Control;
 BIOS_API_BUFFER Buffer;
} BIOS_API, *PBIOS_API;
typedef struct _BAPI_STATIC_BUFFERS
{
 BIOS_API_CONTROL Control;
 BIOS_API_BUFFER Data;
 BIOS_API_EVENTS EventsIn;
 BIOS_API_EVENTS EventsOut;
 BIOS_API_MEMERRS MemoryErrors;
} BAPI_STATIC_BUF, *P_BAPI_STATIC_BUF;
#pragma pack ()
#pragma pack (1)
typedef struct _IoctlData_ReadSmbus
{
 DWORD DeviceAddress;
 DWORD StartOffset;
} IOCTLDATA_READ_SMBUS, *P_IOCTLDATA_READ_SMBUS;
typedef struct _IoctlData_WriteSmbus
{
 DWORD DeviceAddress;
 DWORD StartOffset;
 DWORD BytesToWrite;
 BYTE WriteData[256];
} IOCTLDATA_WRITE_SMBUS, *P_IOCTLDATA_WRITE_SMBUS;
typedef struct _Smbus_MuxDeviceAddess
{
 BYTE Address;
 BYTE Offset;
 BYTE Protocol;
 BYTE AndMask;
 BYTE OrMask;
    BYTE Reserved[3];
} SMBUS_MUX_ADDR, *P_SMBUS_MUX_ADDR;
typedef struct _IoctlData_Smbus_OpenDevice
{
 BYTE DeviceAddress;
 SMBUS_MUX_ADDR MuxAddr[1];
} IOCTLDATA_SMBUS_OPEN_DEVICE, *P_IOCTLDATA_SMBUS_OPEN_DEVICE;
typedef struct _IoctlData_Smbus_ReadDevice
{
 DWORD DeviceHandle;
 DWORD StartOffset;
} IOCTLDATA_SMBUS_READ_DEVICE, *P_IOCTLDATA_SMBUS_READ_DEVICE;
typedef struct _IoctlData_Smbus_WriteDevice
{
 DWORD DeviceHandle;
 DWORD StartOffset;
 DWORD BytesToWrite;
 BYTE WriteData[1];
} IOCTLDATA_SMBUS_WRITE_DEVICE, *P_IOCTLDATA_SMBUS_WRITE_DEVICE;
typedef struct _IoctlData_Smbus_MasterInfo
{
 WORD VendorId;
 WORD DeviceId;
 DWORD BaseAddress;
} IOCTLDATA_SMBUS_MASTER_INFO, *P_IOCTLDATA_SMBUS_MASTER_INFO;
enum ChipsetType
{
 CS_UNKNOWN,
 CS_INTEL_PIIX4,
 CS_INTEL_ICH,
 CS_RCC_OSB4,
 CS_RCC_CSB5,
 CS_RCC_CSB6,
 CS_VIA_686A,
 CS_VIA_8233,
 CS_VIA_8237,
 CS_INTEL_PCH
};
typedef struct _IoctlData_Smbus_Chip
{
 DWORD BaseAddress;
 WORD VendorId;
 WORD DeviceId;
 BYTE Chipset;
 BYTE BusNo;
 BYTE DeviceNo;
 BYTE FunctionNo;
} IOCTLDATA_SMBUS_CHIP, *P_IOCTLDATA_SMBUS_CHIP;
typedef struct _SmbiAddress
{
 DWORD OSType;
 DWORDLONG CmdBufAddr;
 DWORDLONG RespBufAddr;
 DWORDLONG SmbiCall;
} SMBI_ADDRESS, *P_SMBI_ADDRESS;
typedef struct _SmbiRwBuffer
{
 BYTE BufType;
 WORD NrOfBytes;
 BYTE Data[256];
} SMBI_RW_BUF, *P_SMBI_RW_BUF;
typedef struct _IoctlData_GabiDetected
{
 DWORD EntryPointPhysicalAddress;
 DWORD EntryPointMapAddress;
 DWORD EntryPointMapSize;
} IOCTLDATA_GABI_DETECTED, *P_IOCTLDATA_GABI_DETECTED;
typedef struct _IoctlData_MapPhysicalMemory
{
 DWORD PhysicalAddressLow;
 DWORD PhysicalAddressHigh;
 DWORD Size;
} IOCTLDATA_MAP_PHYS_MEM, *P_IOCTLDATA_MAP_PHYS_MEM;
typedef struct _IoctlData_SmmiCmd
{
 WORD CmdResultCode;
 WORD Data;
} IOCTLDATA_SMMI_CMD, *P_IOCTLDATA_SMMI_CMD;
typedef struct _IoctlData_indexed_port_io
{
    BYTE IndexPort;
    BYTE IndexData;
    BYTE DataPort;
    BYTE DataData;
} IOCTLDATA_INDEXED_PORT_IO, *P_IOCTLDATA_INDEXED_PORT_IO;
typedef struct _IoctlData_generic_io
{
    DWORD Address;
 DWORD DataWidth;
    DWORD WriteData;
} IOCTLDATA_GEN_IO, *P_IOCTLDATA_GEN_IO;
typedef struct _IoctlData_multiport_io_struct
{
    DWORD Address;
 DWORD Mode;
    DWORD Data;
} IOCTLDATA_MULTIPORT_IO_ELEM, *P_IOCTLDATA_MULTIPORT_IO_ELEM;
typedef struct _IoctlData_multiport_io
{
    DWORD NumberElements;
 IOCTLDATA_MULTIPORT_IO_ELEM Element[1];
} IOCTLDATA_MULTIPORT_IO, *P_IOCTLDATA_MULTIPORT_IO;
typedef struct _IoctlData_PCI_get_conf_from_id
{
 WORD VendorId;
 WORD DeviceId;
 DWORD StartOffset;
} IOCTLDATA_PCI_GET_CONF_FROM_ID, *P_IOCTLDATA_PCI_GET_CONF_FROM_ID;
typedef struct _IoctlData_PCI_get_conf_from_loc
{
 DWORD Bus;
 DWORD Device;
 DWORD Function;
 DWORD StartOffset;
} IOCTLDATA_PCI_GET_CONF_FROM_LOC, *P_IOCTLDATA_PCI_GET_CONF_FROM_LOC;
typedef struct _IoctlData_PCI_return_conf_from_loc
{
 DWORD Bus;
 DWORD Device;
 DWORD Function;
 BYTE ConfigData[4];
} IOCTLDATA_PCI_RETURN_CONF_FROM_LOC, *P_IOCTLDATA_PCI_RETURN_CONF_FROM_LOC;
enum CPUERR_ERROR_TYPE
{
 CPUERR_TYPE_NO_ERROR,
 CPUERR_TYPE_UNCLASSIFIED,
 CPUERR_TYPE_MICROCODE_PARITY,
 CPUERR_TYPE_EXTERNAL,
 CPUERR_TYPE_FRC_ERROR,
 CPUERR_TYPE_INT_UNCLASSIFIED,
 CPUERR_TYPE_TLB_ERROR,
 CPUERR_TYPE_CACHE_ERROR,
 CPUERR_TYPE_BUS_ERROR
};
enum CPUERR_TRANSACTION_TYPE
{
 CPUERR_XTYPE_INSTRUCTION,
 CPUERR_XTYPE_DATA,
 CPUERR_XTYPE_GENERIC
};
enum CPUERR_CACHE_LEVEL
{
 CPUERR_CACHELEVEL_0,
 CPUERR_CACHELEVEL_1,
 CPUERR_CACHELEVEL_2,
 CPUERR_CACHELEVEL_GENERIC
};
enum CPUERR_REQUEST_TYPE
{
 CPUERR_REQTYPE_GENERIC_ERR,
 CPUERR_REQTYPE_GENERIC_RD,
 CPUERR_REQTYPE_GENERIC_WR,
 CPUERR_REQTYPE_DATA_RD,
 CPUERR_REQTYPE_DATA_WR,
 CPUERR_REQTYPE_FETCH,
 CPUERR_REQTYPE_PREFETCH,
 CPUERR_REQTYPE_EVICTION,
 CPUERR_REQTYPE_SNOOP
};
typedef struct _IoctlData_CorrCpuError
{
 BYTE ErrorType;
 BYTE Overflow;
 BYTE Uncorrectable;
 BYTE Bank;
 WORD ErrorCode;
 WORD Align1;
 DWORD AddressLow;
 DWORD AddressHigh;
 DWORD64 IA32MCiStatus;
 BYTE CacheLevel;
 BYTE RequestType;
 BYTE TransactionType;
 BYTE ParticipationLevel;
 BYTE Timeout;
 BYTE MemIo;
 WORD LogicalCpuNumber;
} IOCTLDATA_CORR_CPU_ERROR, *P_IOCTLDATA_CORR_CPU_ERROR;
typedef struct _IoctlData_CpuApicId_BootCpu
{
 BYTE LocalApicId;
 BYTE IsBootCpu;
 BYTE LogicalCpuNumber;
 BYTE Align;
} IOCTLDATA_CPU_APICID_BOOT_CPU, *P_IOCTLDATA_CPU_APICID_BOOT_CPU;
typedef struct _IoctlData_CpuApicId_Ex
{
 DWORD LogicalCpuNumber;
 DWORD LocalApicId;
 DWORD Reserved1;
 BYTE IsBootCpu;
 BYTE xApicGlobalEnable;
 BYTE x2ApicMode;
 BYTE Reserved2;
} IOCTLDATA_CPU_APICID_EX, *P_IOCTLDATA_CPU_APICID_EX;
#pragma pack ()
#pragma pack (1)
typedef struct _GABI_ENTRY_POINT
{
 BYTE ucSignature[8];
 BYTE ucLength;
 BYTE ucCheckSum;
 BYTE ucVersion;
 BYTE reserved1[5];
 WORD usApi16Ofs;
 DWORD ulApi16Seg;
 DWORD ulEntryPoint32;
 QWORD paEntryPoint64;
 BYTE VendorSpecific[1];
} GABI_ENTRY_POINT, *P_GABI_ENTRY_POINT;
typedef struct _GABI_CONTROL_BUFFER
{
 WORD AllocatedBufferSize;
 WORD ServiceCategoryCode;
 WORD ServiceCode;
 WORD GeneralStatus;
 WORD ErrorCode;
 WORD ActionCode;
 WORD SubFunction;
 WORD ExtraStatus;
 BYTE Reserved[16];
 BYTE BiosScratchBuffer[992];
} GABI_CONTROL_BUFFER, *P_GABI_CONTROL_BUFFER;
typedef struct _GABI_DATA_BUFFER_COMMON_HEADER
{
 WORD AllocatedBufferSize;
 BYTE Data[1];
} GABI_DATA_BUFFER_COMMON_HEADER, *P_GABI_DATA_BUFFER_COMMON_HEADER;
typedef struct _GABI_DATA_BUFFER_HEADER
{
 WORD AllocatedBufferSize;
 WORD StructureVersion;
 DWORD TransactionHandle;
 BYTE Data[1];
} GABI_DATA_BUFFER_HEADER, *P_GABI_DATA_BUFFER_HEADER;
typedef struct _GABI_DATA_BUFFER_DESCR_HEADER
{
 WORD AllocatedBufferSize;
 WORD StructureVersion;
 DWORD TransactionHandle;
 QWORD DataSize;
 BYTE Data[1];
} GABI_DATA_BUFFER_DESCR_HEADER, *P_GABI_DATA_BUFFER_DESCR_HEADER;
typedef VOID ( *GABI_CALL)(ULONG InBuffer, ULONG OutBuffer, ULONG ControlBuffer);
typedef struct _GabiServiceInformation
{
 WORD Length;
 DWORD ResponseBufferSize;
 WORD VendorId;
 BYTE MajorVersion;
 BYTE MinorVersion;
 WORD ServiceCategoryCharacteristics;
 BYTE SpecificInfoLength;
 WORD SpecificInformation;
} GABI_SERVICE_INFORMATION, *P_GABI_SERVICE_INFORMATION;
typedef struct _GABI_BIOS_SETUP_STRING_LENGTH_VALUE
{
 WORD Length;
 WCHAR String[1];
} GABI_BIOS_SETUP_STRING_LENGTH_VALUE, *P_GABI_BIOS_SETUP_STRING_LENGTH_VALUE;
typedef struct _GABI_BIOS_SETTINGS_ENTER_REQUEST_V1
{
 WORD AllocatedBufferSize;
 WORD StructureVersion;
 DWORD TransactionHandle;
 WORD SetupRights;
 WORD PasswordLength;
 WCHAR Password[1];
} GABI_BIOS_SETTINGS_ENTER_REQUEST_V1, *P_GABI_BIOS_SETTINGS_ENTER_REQUEST_V1;
typedef struct _GABI_BIOS_SETTINGS_ENTER_REQUEST_V2
{
 WORD AllocatedBufferSize;
 WORD StructureVersion;
 DWORD TransactionHandle;
 WORD SetupRights;
 BYTE PasswordEncoding;
 WORD PasswordLength;
 WCHAR Password[1];
} GABI_BIOS_SETTINGS_ENTER_REQUEST_V2, *P_GABI_BIOS_SETTINGS_ENTER_REQUEST_V2;
typedef struct _GABI_BIOS_SETTINGS_ENTER_RESPONSE_V2
{
 WORD AllocatedBufferSize;
 WORD StructureVersion;
 DWORD TransactionHandle;
 WORD SetupRights;
 BYTE PasswordEncoding;
} GABI_BIOS_SETTINGS_ENTER_RESPONSE_V2, *P_GABI_BIOS_SETTINGS_ENTER_RESPONSE_V2;
enum SetupEnterPasswordEncoding
{
 SetupEnterPasswordEncUndefined = 0,
 SetupEnterPasswordEncScancode = 1,
 SetupEnterPasswordEncUnicodeUTF16 = 2
};
enum SetupEnterRights
{
 SetupEnterRightsUndefined = 0,
 SetupEnterRightsRead = 1,
 SetupEnterRightsUser = 2,
 SetupEnterRightsSetup = 3
};
enum SetupValueType
{
 SetupValueTypeUndefined = 0,
 SetupValueTypeEnum = 1,
 SetupValueTypeNumber = 2,
 SetupValueTypeString = 3,
};
enum SetupItemValueType
{
 SetupItemValueTypeUndefined = 0,
 SetupItemValueTypeCurrent = 1,
 SetupItemValueTypeStdDefault = 2,
 SetupItemValueTypeFactoryDefault = 3,
 SetupItemValueTypeUserDefault = 4,
};
enum SetupItemStoringPolicy
{
 SetupItemStoreImmediately = (1<<0),
 SetupItemStoreOnExit = (1<<1),
 SetupItemStoreOnNextReboot = (1<<2),
};
typedef struct _GABI_BIOS_SETUP_ITEM_LENGTH_VALUE
{
 WORD ValueLength;
 union
 {
  WORD AsNumber;
  WCHAR AsString[1];
 } Value;
} GABI_BIOS_SETUP_ITEM_LENGTH_VALUE, *P_GABI_BIOS_SETUP_ITEM_LENGTH_VALUE;
typedef struct _GABI_BIOS_SETUP_ITEM_POSSIBLE_ENUMS
{
 WORD Length;
 WORD PossibleEnums[1];
} *P_GABI_BIOS_SETUP_ITEM_POSSIBLE_ENUMS;
typedef struct _GABI_GET_BIOS_SETUP_ITEM_RESPONSE_V1
{
 WORD AllocatedBufferSize;
 WORD StructureVersion;
 DWORD TransactionHandle;
 WORD StoringPolicy;
 WORD ValueProperties;
 WORD ValueType;
 WORD ChangeActive;
 DWORD ValidityRange;
 GABI_BIOS_SETUP_ITEM_LENGTH_VALUE Default;
} GABI_GET_BIOS_SETUP_ITEM_RESPONSE_V1, *P_GABI_GET_BIOS_SETUP_ITEM_RESPONSE_V1;
typedef struct _GABI_GET_BIOS_SETUP_ITEM_RESPONSE_V3
{
 WORD AllocatedBufferSize;
 WORD StructureVersion;
 DWORD TransactionHandle;
 WORD StoringPolicy;
 WORD ValueProperties;
 WORD ValueType;
 WORD ChangeActive;
 DWORD ValidityRange;
 BYTE Value[1];
} GABI_GET_BIOS_SETUP_ITEM_RESPONSE_V3, *P_GABI_GET_BIOS_SETUP_ITEM_RESPONSE_V3;
typedef struct _GABI_BIOS_SETUP_ITEM_REQUEST_V1
{
 WORD AllocatedBufferSize;
 WORD StructureVersion;
 DWORD TransactionHandle;
 WORD ItemId;
 WORD StoringPolicy;
 GABI_BIOS_SETUP_ITEM_LENGTH_VALUE SetValue;
} GABI_BIOS_SETUP_ITEM_REQUEST_V1, *P_GABI_BIOS_SETUP_ITEM_REQUEST_V1;
typedef struct _GABI_BIOS_SETUP_ITEM_REQUEST_V3
{
 WORD AllocatedBufferSize;
 WORD StructureVersion;
 DWORD TransactionHandle;
 WORD ItemId;
 BYTE ItemValueType;
 WORD StoringPolicy;
 GABI_BIOS_SETUP_ITEM_LENGTH_VALUE SetValue;
} GABI_BIOS_SETUP_ITEM_REQUEST_V3, *P_GABI_BIOS_SETUP_ITEM_REQUEST_V3;
typedef struct _GABI_BIOS_PASSWORD_PROPERTY_REQUEST_V3
{
 WORD AllocatedBufferSize;
 WORD StructureVersion;
 DWORD TransactionHandle;
 WORD RequestType;
 WORD DriveNumber;
} GABI_BIOS_PASSWORD_PROPERTY_REQUEST_V3, *P_GABI_BIOS_PASSWORD_PROPERTY_REQUEST_V3;
enum GabiPasswdPropertyType
{
 GabiPasswdPropertyTypeUndef = 0,
 GabiPasswdPropertyTypeReserved = 1,
 GabiPasswdPropertyTypeUserPasswd = 2,
 GabiPasswdPropertyTypeSetupPasswd = 3,
 GabiPasswdPropertyTypeHddUserPasswd = 4,
 GabiPasswdPropertyTypeHddMasterPasswd = 5
};
typedef struct _GABI_BIOS_PASSWORD_PROPERTY_RESPONSE_V3
{
 WORD AllocatedBufferSize;
 WORD StructureVersion;
 DWORD TransactionHandle;
 WORD StoringPolicy;
 WORD Properties;
 BYTE MinPasswordLength;
 BYTE MaxPasswordLength;
 BYTE PasswordEncoding;
 GABI_BIOS_SETUP_STRING_LENGTH_VALUE KeyboardLayoutList;
} GABI_BIOS_PASSWORD_PROPERTY_RESPONSE_V3, *P_GABI_BIOS_PASSWORD_PROPERTY_RESPONSE_V3;
enum GabiPasswdProperties
{
 GabiPasswdPropertyDependent = (1<<0),
 GabiPasswdPropertyReadonly = (1<<1),
 GabiPasswdPropertyNotDisplay = (1<<2),
 GabiPasswdPropertyNotSelect = (1<<3),
 GabiPasswdPropertyClearable = (1<<4),
 GabiPasswdPropertyRejectS4OS = (1<<5),
 GabiPasswdPropertyPasswdSet = (1<<6),
 GabiPasswdPropertyPasswdNone = (1<<7),
 GabiPasswdPropertyPasswdUnknown = (1<<8)
};
typedef struct _SYSTEM_PRODUCT_INFORMATION {
 DWORD BoardID ;
 WORD BIOSFlag ;
 DWORD BIOSVersion;
} SYSTEM_PRODUCT_INFORMATION, *P_SYSTEM_PRODUCT_INFORMATION;
typedef struct _GET_RTC_WAKEUP_TIMER {
 WORD Status;
 WORD Property;
 WORD CallerID;
 BYTE Day;
 BYTE Hour;
 BYTE Minute;
 BYTE Second;
} GET_RTC_WAKEUP_TIMER, *P_GET_RTC_WAKEUP_TIMER;
typedef struct _SET_RTC_WAKEUP_TIMER {
 WORD Control;
 WORD CallerID;
 BYTE Day;
 BYTE Hour;
 BYTE Minute;
 BYTE Second;
} SET_RTC_WAKEUP_TIMER, *P_SET_RTC_WAKEUP_TIMER;
typedef struct _ZEROWATT_DEVICE_INFORMATION
{
 BYTE StructureVersion;
 BYTE Checksum;
 WORD SystemID;
 WORD DeviceID;
 BYTE FirmwareRevision;
 BYTE DeviceBuild;
 BYTE Capabilities;
 BYTE BootLoaderRevision;
} ZEROWATT_DEVICE_INFORMATION, *P_ZEROWATT_DEVICE_INFORMATION;
typedef struct _GABI_ZEROWATT_MANAGE_INTERVAL
{
 WORD Control;
 BYTE StartSeconds;
 BYTE StartMinutes;
 BYTE StartHours;
 BYTE EndSeconds;
 BYTE EndMinutes;
 BYTE EndHours;
} GABI_ZEROWATT_MANAGE_INTERVAL, *P_GABI_ZEROWATT_MANAGE_INTERVAL;
typedef struct _GABI_ZEROWATT_RESPONSE_DATA_MANAGE_INTERVALS
{
 BYTE StructFormat;
 BYTE Checksum;
 BYTE StructLength;
 BYTE Feature;
 BYTE NumberIntervalsSupported;
 GABI_ZEROWATT_MANAGE_INTERVAL Intervals[1];
} GABI_ZEROWATT_RESPONSE_DATA_MANAGE_INTERVALS, *P_GABI_ZEROWATT_RESPONSE_DATA_MANAGE_INTERVALS;
typedef struct _ZEROWATT_TIME_INTERVAL
{
 WORD Active;
 BYTE DisaStart_sec;
 BYTE DisaStart_min;
 BYTE DisaStart_hr ;
 BYTE DisaEnd_sec ;
 BYTE DisaEnd_min ;
 BYTE DisaEnd_hr ;
} ZEROWATT_TIME_INTERVAL, *P_ZEROWATT_TIME_INTERVAL;
typedef struct _ZEROWATT_INTERVAL_DATA
{
 BYTE StructureVersion;
 BYTE Checksum;
 BYTE Length;
 BYTE Feature;
 BYTE NoOfIntervals;
 ZEROWATT_TIME_INTERVAL Interval[1];
} ZEROWATT_INTERVAL_DATA, *P_ZEROWATT_INTERVAL_DATA;
typedef struct _GABISYS_DATA_DESCRIPTOR
{
 QWORD BlockAddressPhysical;
 QWORD BlockSize;
} GABISYS_DATA_DESCRIPTOR, *P_GABI_DATA_DESCRIPTOR;
typedef struct _GABI_DATA_NUMBER_DWORD
{
 WORD AllocatedBufferSize;
 WORD StructureVersion;
 DWORD TransactionHandle;
 DWORD NumericValue;
} GABI_DATA_NUMBER_DWORD, *P_GABI_DATA_NUMBER_DWORD;
#pragma pack ()
#pragma pack (1)
typedef struct _Smbus_Driver_Info_Hdr
{
 DWORD VersionOfThisIoctl;
 DWORD CmdNumberOfThisIoctl;
 DWORD SizeOfInOutBuffer;
 DWORD Reserved1;
 DWORD64 pInOutBuffer;
 BOOL Success;
 DWORD Reserved2;
} IOCTLDATA_SMBUS_DRIVER_INFO_HDR, *P_IOCTLDATA_SMBUS_DRIVER_INFO_HDR;
typedef struct _Smbus_Driver_Info
{
 DWORD OSKernelVersionCode;
 DWORD Reserved2b;
 DWORD Reserved2c;
 DWORD Reserved2d;
 DWORD smbus_VersionCode;
 DWORD smbus_ArchMode;
 DWORD smbus_ArchXEN;
 DWORD smbus_ArchFacil;
 DWORD RequestorVersion;
 DWORD Reserved3 [3];
 BYTE smbus_IsSmbiHwFound;
 BYTE smbus_IsBapiHwFound;
 BYTE smbus_IsGabiHwFound;
 BYTE smbus_IsSmbusHwFound;
 BYTE smbus_IsBusIoHwFound;
 BYTE smbus_IsCpuErrHwFound;
 BYTE smbus_IsCpuApicHwFound;
 BYTE smbus_IsCpuInfoHwFound;
 BYTE Reserved4 [8];
 DWORD smbus_MajorDeviceNumber;
 DWORD smbus_IsKmpModule;
 DWORD Reserved5 [2];
 DWORD Reserved6 [4];
 BYTE RequestorName [32];
 BYTE smbus_Name [32];
 BYTE smbus_SrcVersion [64];
 BYTE smbus_SrcDate [64];
 BYTE smbus_ObjDate [64];
 BYTE smbus_OsArchitecture [32];
 BYTE smbus_OsVersion [64];
 BYTE smbus_CompilerVersion [128];
 BYTE smbus_KernelVersion [128];
 BYTE Reserved7 [32];
 BYTE SV_SYSTEM [32];
 BYTE SV_OS [128];
 BYTE SV_NICKNAME [32];
 BYTE smbus_ErrorReturnString [128];
 BYTE Reserved9 [256];
} IOCTLDATA_SMBUS_DRIVER_INFO, *P_IOCTLDATA_SMBUS_DRIVER_INFO;
#pragma pack ()
typedef struct _CPU_ID_regs
{
 DWORD eax;
 DWORD ebx;
 DWORD ecx;
 DWORD edx;
} CPUIDRegs;
typedef struct _IoctlData_Cpu_Info
{
 BYTE LogicalCpuNumber;
 BYTE Align[7];
 INT DenseCpuNr;
 INT SparseCpuNr;
 BOOL regs1Valid;
 BOOL regs2Valid;
 BOOL regs3Valid;
 BOOL regs4Valid;
 BOOL BrandStringValid;
 BOOL NrCoresAMDValid;
 BOOL MachineCheckArchitectureSupported;
 BOOL LocalApicSupported;
 BOOL PrimaryLogicalCpu;
 DWORD LocalApicIdInitial;
 DWORD NumberLogicalCpus;
 WORD NrCores;
 WORD Vendor;
 BYTE Reserved1[8];
 CPUIDRegs regs0;
 CPUIDRegs regs1;
 CPUIDRegs regs2;
 CPUIDRegs regs3;
 CPUIDRegs regs4;
 CPUIDRegs MaxExtentions;
 CPUIDRegs BrandString1;
 CPUIDRegs BrandString2;
 CPUIDRegs BrandString3;
 CPUIDRegs NrCoresAMD;
 BOOL BootstrapCpu;
 BOOL ApicGlobalEnable;
 BOOL x2ApicMode;
 BOOL ApicIdValid;
 DWORD ApicId;
 DWORD Unused2;
 DWORD64 ApicBaseMsr;
 DWORD64 ApicBaseAddress;
 DWORD64 x2ApicLocalApicId;
 DWORD64 Unused4;
} IOCTLDATA_CPU_INFO, *P_IOCTLDATA_CPU_INFO;
#ident "$Header$"
#ifdef __x86_64__
#define ASMX86(args...) asm(args)
#define PUSH_RAX "push %rax"
#define PUSH_RBX "push %rbx"
#define PUSH_RCX "push %rcx"
#define PUSH_RDX "push %rdx"
#define POP_RAX "pop  %rax"
#define POP_RBX "pop  %rbx"
#define POP_RCX "pop  %rcx"
#define POP_RDX "pop  %rdx"
#define RESET_RCX "mov  $0x0,%rcx"
#define PUSH_RRDI "push %%rdi"
#define PUSH_RRSI "push %%rsi"
#define PUSH_RRDX "push %%rdx"
#define PUSH_RRCX "push %%rcx"
#define POP_RRDI "pop  %rdi"
#define POP_RRSI "pop  %rsi"
#define POP_RRDX "pop  %rdx"
#define POP_RRCX "pop  %rcx"
#else
#define ASMX86(args...) asm(args)
#define PUSH_RAX "pushl %eax"
#define PUSH_RBX "pushl %ebx"
#define PUSH_RCX "pushl %ecx"
#define PUSH_RDX "pushl %edx"
#define POP_RAX "popl  %eax"
#define POP_RBX "popl  %ebx"
#define POP_RCX "popl  %ecx"
#define POP_RDX "popl  %edx"
#define RESET_RCX "mov  $0x0,%ecx"
#define PUSH_RRDI "push %%edi"
#define PUSH_RRSI "push %%esi"
#define PUSH_RRDX "push %%edx"
#define PUSH_RRCX "push %%ecx"
#define POP_RRDI "pop  %edi"
#define POP_RRSI "pop  %esi"
#define POP_RRDX "pop  %edx"
#define POP_RRCX "pop  %ecx"
#endif
#pragma pack(1)
typedef struct _Device_Address_Data
{
 IOCTLDATA_SMBUS_OPEN_DEVICE iod_open;
 SMBUS_MUX_ADDR muxdevadr[10];
} SMBUS_DEVICE_ADDRESS_DATA_ST;
#pragma pack()
extern PVOID OpenDevicesPersist[];
extern SMBUS_DEVICE_ADDRESS_DATA_ST SmBus_DAD_Buff [];
extern DWORD smbus_ReadData(BYTE DeviceAddress, BYTE StartOffset, PBYTE pReturnBuffer, DWORD BytesToRead);
extern DWORD smbus_WriteData(BYTE DeviceAddress, BYTE StartOffset, PBYTE pWriteData, DWORD BytesToWrite);
extern INT smbus_OpenDevice(PDWORD pDeviceHandle, SMBUS_DEVICE_ADDRESS_DATA_ST *psmdev, DWORD size);
extern INT smbus_CloseDevice(DWORD DeviceHandle);
extern INT smbus_ReadDevice(DWORD DeviceHandle, BYTE Offset, DWORD BytesToRead, PBYTE pReturnBuffer, PDWORD pBytesRead);
extern INT smbus_WriteDevice (DWORD DeviceHandle, BYTE Offset, DWORD BytesToWrite, PBYTE pWriteBuffer);
extern BOOL smbus_ReadByte(BYTE DeviceAddress, BYTE Offset, PBYTE pData, BOOL NotUseOffset);
extern BOOL smbus_WriteByte(BYTE DeviceAddress, BYTE Offset, BYTE Data, BOOL NotUseOffset);
typedef void (*SMBI_CMD_ROUTINE)(void);
extern PVOID OpenDevices[];
typedef struct _cpu_id_regs
{
 DWORD eax;
 DWORD ebx;
 DWORD ecx;
 DWORD edx;
} CpuIdRegs;
typedef struct _cpu_info_
{
 INT DenseCpuNr;
 INT SparseCpuNr;
 BOOL regs1Valid;
 BOOL regs2Valid;
 BOOL regs3Valid;
 BOOL regs4Valid;
 BOOL BrandStringValid;
 BOOL NrCoresAMDValid;
 BOOL MachineCheckArchitectureSupported;
 BOOL LocalApicSupported;
 BOOL PrimaryLogicalCpu;
 DWORD LocalApicIdInitial;
 DWORD NumberLogicalCpus;
 WORD NrCores;
 WORD Vendor;
 BYTE Reserved1[8];
 CpuIdRegs regs0;
 CpuIdRegs regs1;
 CpuIdRegs regs2;
 CpuIdRegs regs3;
 CpuIdRegs regs4;
 CpuIdRegs MaxExtentions;
 CpuIdRegs BrandString1;
 CpuIdRegs BrandString2;
 CpuIdRegs BrandString3;
 CpuIdRegs NrCoresAMD;
 BOOL BootstrapCpu;
 BOOL ApicGlobalEnable;
 BOOL x2ApicMode;
 BOOL ApicIdValid;
 DWORD ApicId;
 DWORD Unused2;
 DWORD64 ApicBaseMsr;
 DWORD64 ApicBaseAddress;
 DWORD64 x2ApicLocalApicId;
 PDWORD ApicVirtualAddress;
} CpuInfo;
typedef struct _cpu_error_info_
{
 void *pCpuError;
 INT DenseCpuNr;
 DWORD64 McgCap;
 DWORD64 McgStatus;
 INT NrErrorBanks;
 DWORD MsrAddrMCiStatus;
 DWORD MsrAddrMCiAddr;
 BOOL ErrorAvailable;
} CpuErrorInfo;
typedef struct _PHYSICAL_MEMORY_DESCRIPTOR
{
 ULONG AllocatedSize;
 BYTE *pVirtualAddress;
 QWORD PhysicalAddress;
} PHYSICAL_MEMORY_DESCRIPTOR;
typedef struct _PHYSICAL_MEMORY_DESCRIPTOR_LIST
{
 INT_PTR ActNumberOfEntries;
 INT_PTR MaxEntries;
 PHYSICAL_MEMORY_DESCRIPTOR Descriptor[3];
 struct _PHYSICAL_MEMORY_DESCRIPTOR_LIST *pNext;
} PHYSICAL_MEMORY_DESCRIPTOR_LIST;
static int smbusArchMode = 0x00000000;
static int smbusArchXEN = 0x00000000;
static int smbusArchFacil = 0x00000000;
#ifndef GFP_DMA32
#define GFP_DMA32 GFP_DMA
#endif
#ifdef virt_to_bus
#define VIRT_TO_PHYS virt_to_bus
#define PHYS_TO_VIRT bus_to_virt
#else
#define VIRT_TO_PHYS virt_to_phys
#define PHYS_TO_VIRT phys_to_virt
#endif
#ifdef virt_to_machine
#define VIRT_TO_MACHINE virt_to_machine
#else
#define VIRT_TO_MACHINE virt_to_bus
#endif
#if defined CONFIG_XEN && defined page_to_pseudophys
#define PAGE_TO_PSEUDOPHYS(x) page_to_pseudophys(x)
#define VIRT_TO_PAGE(x) virt_to_page(x)
#else
#define PAGE_TO_PSEUDOPHYS(x) (x)
#define VIRT_TO_PAGE(x) (x)
#endif
#if defined CONFIG_XEN && defined virt_to_machine
#define SMBUS_DMA_MEM_GET(Dev, Size, Dummy, Flags) dma_alloc_coherent((Dev), (Size), (Dummy), (Flags))
#define SMBUS_DMA_MEM_FREE(Dev, Size, pVirt, BusVirt) dma_free_coherent((Dev), (Size), (pVirt), (BusVirt))
#else
#define SMBUS_DMA_MEM_GET(Dev, Size, Dummy, Flags) __get_free_page((Flags))
#define SMBUS_DMA_MEM_FREE(Dev, Size, pVirt, BusVirt) free_page((ulong)(pVirt))
#endif
#define SMBUS_MY_DMA_DEVICE NULL
#if defined CONFIG_XEN && defined virt_to_machine
#if (LINUX_VERSION_CODE == KERNEL_VERSION(2, 6, 18))
static struct device smbus_my_x86_dma_fallback_dev =
{
 .bus_id = "smbus_gabi_device",
 .coherent_dma_mask = DMA_32BIT_MASK,
 .dma_mask = &smbus_my_x86_dma_fallback_dev.coherent_dma_mask,
};
#undef SMBUS_MY_DMA_DEVICE
#define SMBUS_MY_DMA_DEVICE &smbus_my_x86_dma_fallback_dev
#endif
#endif
#ifdef USE_REMAP_PFN_RANGE
#define DRIVER_REMAP_RANGE_INTF 0x00000400
#define DRIVER_REMAP_RANGE(vma,va,pfn,vs,pr) remap_pfn_range((vma), (va), ((pfn) >> PAGE_SHIFT), (vs), (pr))
#else
#ifdef NEW_REMAP_INTF
#define DRIVER_REMAP_RANGE_INTF 0x00000200
#define DRIVER_REMAP_RANGE(vma,va,pa,vs,pr) remap_page_range((vma),(va),(pa),(vs),(pr))
#else
#define DRIVER_REMAP_RANGE_INTF 0x00000100
#define DRIVER_REMAP_RANGE(vma,va,pa,vs,pr) remap_page_range((va),(pa),(vs),(pr))
#endif
#endif
#ifndef KERNEL26
#define DRIVER_KERNEL_MODE 0x01000000
#define DRIVER_PCI_PRESENT(result) {result = pci_present();}
#define DRIVER_EXPORT_SYMBOLS EXPORT_NO_SYMBOLS
#define DRIVER_MOD_INC_USE_COUNT MOD_INC_USE_COUNT
#define DRIVER_MOD_DEC_USE_COUNT MOD_DEC_USE_COUNT
#define DRIVER_SET_OWNER do { } while(0)
#define DRIVER_SAVE_FLAGS(flags) save_flags(flags)
#define DRIVER_DISABLE_IRQ() cli()
#define DRIVER_FLAGS_RESTORE(flags) restore_flags(flags)
#define CPU_NUMBER_MAP(sparse) cpu_number_map((sparse))
#define SMP_NUM_CPUS smp_num_cpus
#define PREEMPT_ENABLE
#define PREEMPT_DISABLE
#else
#ifdef KERNEL2616
#ifdef KERNEL2627
#ifdef KERNEL30
#define DRIVER_KERNEL_MODE (0x02000000 | 0x04000000 | 0x08000000 | 0x00100000)
#else
#define DRIVER_KERNEL_MODE (0x02000000 | 0x04000000 | 0x08000000)
#endif
#else
#define DRIVER_KERNEL_MODE (0x02000000 | 0x04000000)
#endif
#else
#define DRIVER_KERNEL_MODE 0x02000000
#endif
#define DRIVER_PCI_PRESENT(result) {result = 1;}
#define DRIVER_EXPORT_SYMBOLS
#define DRIVER_MOD_INC_USE_COUNT
#define DRIVER_MOD_DEC_USE_COUNT
#define DRIVER_SET_OWNER do {smbus_fops.owner = THIS_MODULE;} while (0)
#define DRIVER_SAVE_FLAGS(flags) local_save_flags(flags)
#define DRIVER_DISABLE_IRQ() local_irq_disable()
#define DRIVER_FLAGS_RESTORE(flags) local_irq_restore(flags)
#define CPU_NUMBER_MAP(sparse) (sparse)
#define SMP_NUM_CPUS num_online_cpus()
#define PREEMPT_ENABLE preempt_enable()
#define PREEMPT_DISABLE preempt_disable()
#endif
#ifdef KERNEL30
#define PCI_FIND_DEVICE pci_get_device
#else
#define PCI_FIND_DEVICE pci_find_device
#endif
#ifdef KERNEL30
#define DRIVER_FOPS_WITHOUT_COMPAT .unlocked_ioctl = smbus_ioctl, .mmap = smbus_mmap, .open = smbus_open, .release = smbus_release
#define DRIVER_FOPS_WITH_COMPAT .unlocked_ioctl = smbus_ioctl, .compat_ioctl = smbus_ioctl_compat, .mmap = smbus_mmap, .open = smbus_open, .release = smbus_release
#else
#define DRIVER_FOPS_WITHOUT_COMPAT .ioctl = smbus_ioctl, .mmap = smbus_mmap, .open = smbus_open, .release = smbus_release
#define DRIVER_FOPS_WITH_COMPAT .ioctl = smbus_ioctl, .compat_ioctl = smbus_ioctl_compat, .mmap = smbus_mmap, .open = smbus_open, .release = smbus_release
#endif
#ifdef __x86_64__
#define DRIVER_64BIT_MODE 0x20000000
#else
#define DRIVER_64BIT_MODE 0x00000000
#endif
#ifdef USE_REGISTER_IOCTL32_CONVERSION
#define DRIVER_IOCTL32_CONV 0x00000010
#define DRIVER_FOPS DRIVER_FOPS_WITHOUT_COMPAT
typedef int (*handler_ioctl32_t)(unsigned int fd, unsigned int cmd, unsigned long arg, struct file *file);
extern asmlinkage int sys_ioctl(unsigned int fd, unsigned int cmd, unsigned long arg);
#define REGISTER_IOCTL32_CONVERSION(ret,cmd) {ret = 0; ret = register_ioctl32_conversion((cmd), (handler_ioctl32_t)sys_ioctl);}
#define UNREGISTER_IOCTL32_CONVERSION(ret,cmd) {ret = 0; ret = unregister_ioctl32_conversion((cmd));}
#else
#ifdef USE_COMPAT_IOCTL
#define DRIVER_IOCTL32_CONV 0x00000020
#define DRIVER_FOPS DRIVER_FOPS_WITH_COMPAT
#define REGISTER_IOCTL32_CONVERSION(ret,cmd) {ret = 0;}
#define UNREGISTER_IOCTL32_CONVERSION(ret,cmd) {ret = 0;}
#else
#define DRIVER_IOCTL32_CONV 0
#define DRIVER_FOPS DRIVER_FOPS_WITHOUT_COMPAT
#define REGISTER_IOCTL32_CONVERSION(ret,cmd) {ret = 0;}
#define UNREGISTER_IOCTL32_CONVERSION(ret,cmd) {ret = 0;}
#endif
#endif
#if defined (__x86_64__) || defined (KERNEL30)
#ifdef PAGE_KERNEL_EXEC
#define SMBUS_PAGE_KERNEL_EXEC PAGE_KERNEL_EXEC
#else
#ifdef PAGE_KERNEL_EXECUTABLE
#define SMBUS_PAGE_KERNEL_EXEC PAGE_KERNEL_EXECUTABLE
#else
#define SMBUS_PAGE_KERNEL_EXEC PAGE_KERNEL
#endif
#endif
#define VMALLOC_EXEC(size) __vmalloc((size), GFP_KERNEL | __GFP_HIGHMEM, SMBUS_PAGE_KERNEL_EXEC)
#else
#define VMALLOC_EXEC(size) vmalloc((size))
#endif
DRIVER_EXPORT_SYMBOLS;
static unsigned long jiffies0 = 0;
static short smbusDebug = 0;
static char *smbus_SrcVersion = "6.30-16";
static char *smbus_SrcDate = "2014/10/27-16:02";
static char *smbus_IsKmpModule = MYMOD_ISKMPMODULE;
static char *smbus_ObjDate = MYMOD_OBJDATE;
static char *smbus_CompilerVersion = MYMOD_COMPILERVERSRION;
static char *smbus_KernelVersion = MYMOD_KERNELVERSION;
static char *smbus_OsArchitecture = MYMOD_OSARCHITECTURE;
static char *smbus_OsVersion = MYMOD_OSVERSION;
static IOCTLDATA_SMBUS_DRIVER_INFO_HDR smbus_DriverInfoHdr;
static IOCTLDATA_SMBUS_DRIVER_INFO smbus_DriverInfo;
BOOL IsSmbusHwFound = 0;
BOOL IsSmbiHwFound = 0;
BOOL IsBapiHwFound = 0;
BOOL IsGabiHwFound = 0;
BOOL IsBusIoHwFound = 1;
BOOL IsCpuErrHwFound = 1;
BOOL IsCpuApicHwFound = 1;
BOOL IsCpuInfoHwFound = 1;
static int smbus_register_ioctl32 (unsigned int cmd, char *name);
static int smbus_register_ioctl32_all (void);
static void smbus_unregister_ioctl32 (unsigned int cmd, char *name);
static void smbus_unregister_ioctl32_all (void);
typedef void (*BAPI_CMD_ROUTINE)(ULONG InBuffer, ULONG OutBuffer, ULONG ControlBuffer);
typedef void (*BAPI_CMD_ROUTINE_VOID)(void);
typedef void (*GABI_CMD_ROUTINE)(ULONG InBuffer, ULONG OutBuffer, ULONG ControlBuffer);
typedef void (*GABI_CMD_ROUTINE_VOID)(void);
static void DetectBiosInterfaces (void);
static BOOL FindSmbi (ulong base, ulong offset, ulong size, char *signature, size_t SignatureSize);
static BOOL FindBapi (ulong base, ulong offset, ulong size, DWORD signature);
static BOOL FindGabi (void);
static PBYTE FindSignature (PBYTE pStartAddress, DWORD Size, PBYTE pSignature, DWORD SignatureSize, BYTE ScanBoundary);
static void* smbus_DMA_Memory_Alloc (DWORD Size);
static void smbus_DMA_Memory_Free (void *pVirt, DWORD Size);
static BOOL AllocateBuffer (PHYSICAL_MEMORY_DESCRIPTOR *bufferDescr, DWORD bufferSize);
static void FreeBuffer (PHYSICAL_MEMORY_DESCRIPTOR *bufferDescr);
static BOOL GabiExecuteCommand (LPBYTE pInBuffer, DWORD InDataSize, LPBYTE pOutBuffer, DWORD OutBufferSize, DWORD *ReturnDataSize);
static BOOL GabiPrepareGabiBuffer (PHYSICAL_MEMORY_DESCRIPTOR *bufferDescr, GABI_DATA_BUFFER_COMMON_HEADER *pInputDataBuffer, PHYSICAL_MEMORY_DESCRIPTOR_LIST *pDescriptorList, LPCSTR pBufferName, BOOL copyRequestData);
static BOOL GabiReturnGabiBuffer (PHYSICAL_MEMORY_DESCRIPTOR *bufferDescr, GABI_DATA_BUFFER_COMMON_HEADER *pReturnDataBuffer, PHYSICAL_MEMORY_DESCRIPTOR_LIST *pDescriptorList);
static PHYSICAL_MEMORY_DESCRIPTOR_LIST *GabiAllocateDescriptorList(void);
static void GabiFreeDescriptorLists (PHYSICAL_MEMORY_DESCRIPTOR_LIST *pDescriptorList);
static void DumpBytes (BYTE traceLevel, LPSTR pTitle, BYTE *pMemory, SIZE_T nrBytes);
  void smbus_CallBapi (ULONG InBuffer, ULONG OutBuffer, ULONG ControlBuffer, BAPI_CMD_ROUTINE_VOID BapiEx);
  void smbus_CallGabi (ULONG InBuffer, ULONG OutBuffer, ULONG ControlBuffer, GABI_CMD_ROUTINE_VOID GabiEx);
static void ReadFromIndexedPort (IOCTLDATA_INDEXED_PORT_IO *portio);
static void WriteToIndexedPort (IOCTLDATA_INDEXED_PORT_IO *portio);
static int smbus_open (struct inode *inode, struct file *file);
static int smbus_release (struct inode *inode, struct file *file);
static int smbus_mmap (struct file *file, struct vm_area_struct *vma);
  long smbus_ioctl_compat (struct file *file, unsigned int cmd, unsigned long arg);
#ifdef KERNEL30
static long smbus_ioctl (struct file *file, unsigned int cmd, unsigned long arg);
static long smbus_ioctl_body (struct file *file, unsigned int cmd, unsigned long arg);
#else
static int smbus_ioctl (struct inode *inode, struct file *file, unsigned int cmd, unsigned long arg);
static int smbus_ioctl_body (struct inode *inode, struct file *file, unsigned int cmd, unsigned long arg);
#endif
static void free_all (void);
static int smbus_DetermineEnvironment (void);
  int init_module (void);
  void cleanup_module (void);
static void smbus_InitDriverInfo (void);
static char *SMBUS_DEV = "smbus";
static int smbus_major = 0;
#ifdef KERNEL30
#ifndef DECLARE_MUTEX
#define DECLARE_MUTEX(name) DEFINE_SEMAPHORE(name)
#define init_MUTEX(sem) sema_init(sem, 1)
#define init_MUTEX_LOCKED(sem) sema_init(sem, 0)
#endif
static DECLARE_MUTEX(smbus_driver_big_lock);
#define GET_BIG_DRIVER_LOCK down(&smbus_driver_big_lock)
#define FREE_BIG_DRIVER_LOCK up(&smbus_driver_big_lock)
#else
#define GET_BIG_DRIVER_LOCK
#define FREE_BIG_DRIVER_LOCK
#endif
static DECLARE_MUTEX(smbus_mutex);
#ifndef KERNEL2627
#define SMP_CALL_FUNCTION(func, arg, ignore, wait) smp_call_function((func), (arg), (ignore), (wait))
#else
#define SMP_CALL_FUNCTION(func, arg, ignore, wait) smp_call_function((func), (arg), (wait))
#endif
static CpuInfo smbus_cpuinfotable[1024 + 1];
    void smbus_ReadCpuInfo_callback (void *pent);
static void smbus_do_ReadCpuInfo (CpuInfo *pentry);
    void smbus_ReadApicId_callback (void *pent);
static void smbus_do_ReadApicId (CpuInfo *pentry);
static void smbus_FillCpuInfoTable (void);
static DWORD64 smbus_ReadMsr (DWORD address);
static void smbus_WriteMsr (DWORD address, DWORD64 data);
static void smbus_CpuId (DWORD address, CpuIdRegs *regs);
    void smbus_GetCpuError_callback (void *pCpuErrInfo);
static void smbus_do_GetCpuError (CpuErrorInfo *pCpuErrInfo);
static void smbus_ReadCpuErrorInfo (CpuErrorInfo *pCpuErrInfo);
DRIVER_PARAMETER(smbusDebug, "h", short, S_IRUSR | S_IWUSR);
MODULE_PARM_DESC(smbusDebug, "    0 - debug off; , >0 - debug on)");
DRIVER_PARAMETER(smbusArchMode, "i", int, S_IRUSR);
MODULE_PARM_DESC(smbusArchMode, " This bit field reflects the current architecture mode");
DRIVER_PARAMETER(IsSmbusHwFound, "i", int, S_IRUSR);
MODULE_PARM_DESC(IsSmbusHwFound, "   true if SMBUS  Hardware available)");
DRIVER_PARAMETER(IsBusIoHwFound, "i", int, S_IRUSR);
MODULE_PARM_DESC(IsBusIoHwFound, "   true if BUS IO Hardware available)");
DRIVER_PARAMETER(IsSmbiHwFound, "i", int, S_IRUSR);
MODULE_PARM_DESC(IsSmbiHwFound, "    true if SMBI   Firmware available)");
DRIVER_PARAMETER(IsBapiHwFound, "i", int, S_IRUSR);
MODULE_PARM_DESC(IsBapiHwFound, "    true if BAPI Firmware available)");
DRIVER_PARAMETER(IsGabiHwFound, "i", int, S_IRUSR);
MODULE_PARM_DESC(IsGabiHwFound, "    true if GABI Firmware available)");
DRIVER_PARAMETER(IsCpuApicHwFound, "i", int, S_IRUSR);
MODULE_PARM_DESC(IsCpuApicHwFound, " true if CPU Apic Information available)");
DRIVER_PARAMETER(IsCpuErrHwFound, "i", int, S_IRUSR);
MODULE_PARM_DESC(IsCpuErrHwFound, "  true if CPU Error detection available)");
DRIVER_PARAMETER(IsCpuInfoHwFound, "i", int, S_IRUSR);
MODULE_PARM_DESC(IsCpuInfoHwFound, " true if CPU Information available)");
enum ChipsetType my_Chipset = CS_UNKNOWN;
DWORD my_SMBusBaseAddress = 0;
WORD my_VendorId = 0;
WORD my_DeviceId = 0;
BYTE my_BusNo = 0;
BYTE my_DeviceNo = 0;
BYTE my_FunctionNo = 0;
PVOID OpenDevices[256] = {};
PVOID OpenDevicesPersist[256] = {};
SMBUS_DEVICE_ADDRESS_DATA_ST SmBus_DAD_Buff [256] = {};
static char *m_pSmbiSearchAddr = NULL;
static SMBI_HEADER *m_pSmbiBase = NULL;
static SMBI_CMD_ROUTINE m_fSmbiExec = NULL;
static char *ulSmbiCmdBuffer = NULL;
static char *ulSmbiResultBuffer = NULL;
static void *pVirtMemorySmbi = NULL;
static char *m_pBapiSearchAddr = NULL;
static BIOS_API_HEADER_64 *m_pBapiBase = NULL;
static BAPI_CMD_ROUTINE m_fBapiExec = NULL;
static BAPI_STATIC_BUF *m_pBAPIStaticPage = NULL;
static void *m_pVirtMemoryBAPI = NULL;
static ULONG m_phys_BAPI_CB = 0;
static ULONG m_phys_BAPI_DB = 0;
static ULONG m_phys_BAPI_SP = 0;
static ULONG m_phys_BAPI_EvIn = 0;
static ULONG m_phys_BAPI_EvOut = 0;
static ULONG m_phys_BAPI_MemErr = 0;
static char *m_pGabiSearchAddr = NULL;
static GABI_ENTRY_POINT *m_pGabiBase = NULL;
static GABI_CMD_ROUTINE m_fGabiExec = NULL;
static void *m_pVirtMemoryGABI = NULL;
static BYTE *m_pInOutBufferGABI = NULL;
static PHYSICAL_MEMORY_DESCRIPTOR m_GabiControlBuffer;
static PHYSICAL_MEMORY_DESCRIPTOR m_GabiRequestBuffer;
static PHYSICAL_MEMORY_DESCRIPTOR m_GabiResponseBuffer;
static PHYSICAL_MEMORY_DESCRIPTOR m_pGABIStaticPage;
static BYTE *m_pFreeVirtStMemGABI = NULL;
static ULONG m_pFreePhysStMemGABI = 0;
static DWORD m_FreeStMemGABI = 0;
static int smbus_open(struct inode *inode, struct file *file)
{
 do { if (smbusDebug & (1 << (0))) printk(KERN_DEBUG "smbus(%d):" "smbus_open(0x%p,0x%p)\n", (int)(jiffies-jiffies0), inode, file); } while (0);
 DRIVER_MOD_INC_USE_COUNT;
 return 0;
}
static int smbus_release(struct inode *inode, struct file *file)
{
 do { if (smbusDebug & (1 << (0))) printk(KERN_DEBUG "smbus(%d):" "smbus_release(0x%p,0x%p)\n", (int)(jiffies-jiffies0), inode, file); } while (0);
 DRIVER_MOD_DEC_USE_COUNT;
 return 0;
}
static int smbus_mmap(struct file *file, struct vm_area_struct *vma)
{
 int status;
 ulong start = (unsigned long)vma->vm_start;
 ulong size = (unsigned long)(vma->vm_end - vma->vm_start);
 do { if (smbusDebug & (1 << (0))) printk(KERN_DEBUG "smbus(%d):" "smbus_mmap(0x%p,0x%p) start 0x%016lx, length %ld\n", (int)(jiffies-jiffies0), file, vma, start, size); } while (0);
 if (size < sizeof(BAPI_STATIC_BUF)) return -EINVAL;
 if (size > PAGE_SIZE) return -EINVAL;
 if (!IsBapiHwFound || m_pBAPIStaticPage == NULL)
  return -ENODEV;
#if defined CONFIG_XEN && defined page_to_pseudophys
 status = DRIVER_REMAP_RANGE(vma, start, page_to_pseudophys(virt_to_page(m_pBAPIStaticPage)), size, vma->vm_page_prot);
 do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "PseudoPhysBAPIStaticPage = 0x%016lX\n", (int)(jiffies-jiffies0), (unsigned long)page_to_pseudophys(virt_to_page(m_pBAPIStaticPage))); } while (0);
#else
 status = DRIVER_REMAP_RANGE(vma, start, m_phys_BAPI_SP, size, vma->vm_page_prot);
#endif
 if (status != 0)
 {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_mmap: remap_page_range of 0x%016lx failed: %d\n", (int)(jiffies-jiffies0), m_phys_BAPI_SP, status); } while (0);
  return -EAGAIN;
 }
 return 0;
}
static int smbus_DetermineEnvironment(void)
{
 char *pointer = NULL;
 if (smbusArchMode == 0x00000000) {
  smbusArchMode |= DRIVER_REMAP_RANGE_INTF;
  smbusArchMode |= DRIVER_KERNEL_MODE;
  smbusArchMode |= DRIVER_IOCTL32_CONV;
  if (sizeof(pointer) == 4) {
   smbusArchMode |= 0x10000000;
  } else if (sizeof(pointer) == 8) {
   smbusArchMode |= DRIVER_64BIT_MODE;
  } else {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Environment: unknown XX-Bit mode (%d)\n", (int)(jiffies-jiffies0),0); } while (0);
   return -1;
  }
 } else {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Environment: has been determined by insmod\n", (int)(jiffies-jiffies0)); } while (0);
 }
 if (((smbusArchMode & 0x10000000) != 0x10000000) &&
  ((smbusArchMode & 0x20000000) != 0x20000000))
 {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Environment: unsupported mode --> bail out ! (%d)\n", (int)(jiffies-jiffies0),0); } while (0);
  return -2;
 }
#ifdef CONFIG_XEN
 smbusArchXEN = 0x00000001;
#endif
 smbusArchFacil |= 0x00000001;
 smbusArchFacil |= 0x00000010;
 smbusArchFacil |= 0x00001000;
#ifdef GFP_DMA32
 smbusArchFacil |= 0x00000002;
#endif
#ifdef virt_to_bus
 smbusArchFacil |= 0x00000020;
#endif
#ifdef virt_to_machine
 smbusArchFacil |= 0x00000040;
#endif
#if defined CONFIG_XEN && defined page_to_pseudophys
 smbusArchFacil |= 0x00000100;
 smbusArchFacil |= 0x00000200;
#endif
#if defined CONFIG_XEN && defined virt_to_machine
 smbusArchFacil |= 0x00002000;
#endif
#if defined CONFIG_XEN && defined virt_to_machine
#if (LINUX_VERSION_CODE == KERNEL_VERSION(2, 6, 18))
 smbusArchFacil |= 0x01000000;
#endif
#endif
#if 0
#if (LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 15)) && (defined(CONFIG_X86_PAE) || defined(__LP64__))
 smbusArchFacil |= 0x00002000;
#endif
#endif
 if (smbusDebug> 0)
 {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Module Info: Source Version          = %s\n", (int)(jiffies-jiffies0), smbus_SrcVersion); } while (0);
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Module Info: Source Date             = %s\n", (int)(jiffies-jiffies0), smbus_SrcDate); } while (0);
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Module Info: Is KMP Module           = %s\n", (int)(jiffies-jiffies0), smbus_IsKmpModule); } while (0);
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Module Info: Object Date             = %s\n", (int)(jiffies-jiffies0), smbus_ObjDate); } while (0);
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Module Info: Compiler Version        = %s\n", (int)(jiffies-jiffies0), smbus_CompilerVersion); } while (0);
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Module Info: My Kernel Version       = %s\n", (int)(jiffies-jiffies0), smbus_KernelVersion); } while (0);
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Module Info: OS Architecture         = %s\n", (int)(jiffies-jiffies0), smbus_OsArchitecture); } while (0);
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Module Info: OS Version              = %s\n", (int)(jiffies-jiffies0), smbus_OsVersion); } while (0);
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Module Info: OS Linux Version Code   = 0x%08X\n", (int)(jiffies-jiffies0), LINUX_VERSION_CODE); } while (0);
  if (smbusArchMode & 0x10000000) do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Env: IA32 (x86) mode    is active, (0x%08X)\n", (int)(jiffies-jiffies0), smbusArchMode); } while (0);
  if (smbusArchMode & 0x20000000) do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Env: __x86_64__ mode    is active, (0x%08X)\n", (int)(jiffies-jiffies0), smbusArchMode); } while (0);
  if (smbusArchMode & 0x01000000) do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Env: KERNEL 2.4    mode is active, (0x%08X)\n", (int)(jiffies-jiffies0), smbusArchMode); } while (0);
  if (smbusArchMode & 0x02000000) do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Env: KERNEL 2.6    mode is active, (0x%08X)\n", (int)(jiffies-jiffies0), smbusArchMode); } while (0);
  if (smbusArchMode & 0x04000000) do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Env: KERNEL 2.6.16 mode is active, (0x%08X)\n", (int)(jiffies-jiffies0), smbusArchMode); } while (0);
  if (smbusArchMode & 0x08000000) do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Env: KERNEL 2.6.27 mode is active, (0x%08X)\n", (int)(jiffies-jiffies0), smbusArchMode); } while (0);
  if (smbusArchMode & 0x00100000) do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Env: KERNEL 3.0    mode is active, (0x%08X)\n", (int)(jiffies-jiffies0), smbusArchMode); } while (0);
  if (smbusArchMode & 0x00000100) do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Env: OLD_REMAP_INTF     is active, (0x%08X)\n", (int)(jiffies-jiffies0), smbusArchMode); } while (0);
  if (smbusArchMode & 0x00000200) do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Env: NEW_REMAP_INTF     is active, (0x%08X)\n", (int)(jiffies-jiffies0), smbusArchMode); } while (0);
  if (smbusArchMode & 0x00000400) do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Env: PFN_REMAP_INTF     is active, (0x%08X)\n", (int)(jiffies-jiffies0), smbusArchMode); } while (0);
  if (smbusArchMode & 0x00000010) do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Env: IOCTL32_CONVERSION is active, (0x%08X)\n", (int)(jiffies-jiffies0), smbusArchMode); } while (0);
  if (smbusArchMode & 0x00000020) do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Env: IOCTL32_COMPAT     is active, (0x%08X)\n", (int)(jiffies-jiffies0), smbusArchMode); } while (0);
  if (smbusArchXEN & 0x00000001) do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Env: XEN kernel         detected,  (0x%08X)\n", (int)(jiffies-jiffies0), smbusArchXEN); } while (0);
  if (smbusArchFacil & 0x00000001) do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Env: GFP_DMA            detected,  (0x%08X)\n", (int)(jiffies-jiffies0), smbusArchFacil); } while (0);
  if (smbusArchFacil & 0x00000002) do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Env: GFP_DMA32          detected,  (0x%08X)\n", (int)(jiffies-jiffies0), smbusArchFacil); } while (0);
  if (smbusArchFacil & 0x00000010) do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Env: virt_to_phys       detected,  (0x%08X)\n", (int)(jiffies-jiffies0), smbusArchFacil); } while (0);
  if (smbusArchFacil & 0x00000020) do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Env: virt_to_bus        detected,  (0x%08X)\n", (int)(jiffies-jiffies0), smbusArchFacil); } while (0);
  if (smbusArchFacil & 0x00000040) do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Env: virt_to_machine    detected,  (0x%08X)\n", (int)(jiffies-jiffies0), smbusArchFacil); } while (0);
  if (smbusArchFacil & 0x00000100) do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Env: page_to_pseudophys detected,  (0x%08X)\n", (int)(jiffies-jiffies0), smbusArchFacil); } while (0);
  if (smbusArchFacil & 0x00000200) do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Env: virt_to_page       detected,  (0x%08X)\n", (int)(jiffies-jiffies0), smbusArchFacil); } while (0);
  if (smbusArchFacil & 0x00001000) do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Env: get_free_page mode detected,  (0x%08X)\n", (int)(jiffies-jiffies0), smbusArchFacil); } while (0);
  if (smbusArchFacil & 0x00002000) do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Env: dma_coherent  mode is active, (0x%08X)\n", (int)(jiffies-jiffies0), smbusArchFacil); } while (0);
  if (smbusArchFacil & 0x01000000) do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Env: use RHEL57_XEN_2618 fix dma_coherent  mode is active, (0x%08X)\n", (int)(jiffies-jiffies0), smbusArchFacil); } while (0);
 }
 return 0;
}
static void smbus_InitDriverInfo (void)
{
 DWORD DriverStep = 0;
 DWORD DriverMajor = 0;
 DWORD DriverMinor = 0;
 IOCTLDATA_SMBUS_DRIVER_INFO_HDR *pHdr = &smbus_DriverInfoHdr;
 IOCTLDATA_SMBUS_DRIVER_INFO *pBuf = &smbus_DriverInfo;
 memset ((BYTE *)pHdr, 0, sizeof(IOCTLDATA_SMBUS_DRIVER_INFO_HDR));
 memset ((BYTE *)pBuf, 0, sizeof(IOCTLDATA_SMBUS_DRIVER_INFO));
 pHdr->VersionOfThisIoctl = (DWORD) 0x00000001;
 pHdr->CmdNumberOfThisIoctl = (DWORD) 0xFF;
 pHdr->SizeOfInOutBuffer = (DWORD) sizeof(IOCTLDATA_SMBUS_DRIVER_INFO);
 pBuf->OSKernelVersionCode = (DWORD) LINUX_VERSION_CODE;
 sscanf(smbus_SrcVersion, "%d.%d-%d", &DriverStep, &DriverMajor, &DriverMinor);
 pBuf->smbus_VersionCode = (DWORD) ((DriverStep<<16) | (DriverMajor<<8) | (DriverMinor));
 pBuf->smbus_ArchMode = (DWORD) smbusArchMode;
 pBuf->smbus_ArchXEN = (DWORD) smbusArchXEN;
 pBuf->smbus_ArchFacil = (DWORD) smbusArchFacil;
 pBuf->smbus_IsSmbiHwFound = (BYTE) IsSmbiHwFound;
 pBuf->smbus_IsBapiHwFound = (BYTE) IsBapiHwFound;
 pBuf->smbus_IsGabiHwFound = (BYTE) IsGabiHwFound;
 pBuf->smbus_IsSmbusHwFound = (BYTE) IsSmbusHwFound;
 pBuf->smbus_IsBusIoHwFound = (BYTE) IsBusIoHwFound;
 pBuf->smbus_IsCpuErrHwFound = (BYTE) IsCpuErrHwFound;
 pBuf->smbus_IsCpuApicHwFound = (BYTE) IsCpuApicHwFound;
 pBuf->smbus_IsCpuInfoHwFound = (BYTE) IsCpuInfoHwFound;
 pBuf->smbus_MajorDeviceNumber = (DWORD) smbus_major;
 if (strcmp(smbus_IsKmpModule, "no") == 0)
 {
  pBuf->smbus_IsKmpModule = (DWORD) 0;
 } else {
  pBuf->smbus_IsKmpModule = (DWORD) 1;
 }
 do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Module Info: smbus Version Code = 0x%08X\n", (int)(jiffies-jiffies0), pBuf->smbus_VersionCode); } while (0);
 snprintf(pBuf->smbus_Name, sizeof(pBuf->smbus_Name), "%s", "SMBUS-Driver");
 pBuf->smbus_Name[sizeof(pBuf->smbus_Name) - 1] = '\0';
 strncpy(pBuf->smbus_SrcVersion, smbus_SrcVersion, sizeof(pBuf->smbus_SrcVersion));
 pBuf->smbus_SrcVersion[sizeof(pBuf->smbus_SrcVersion) - 1] = '\0';
 strncpy(pBuf->smbus_SrcDate, smbus_SrcDate, sizeof(pBuf->smbus_SrcDate));
 pBuf->smbus_SrcDate[sizeof(pBuf->smbus_SrcDate) - 1] = '\0';
 strncpy(pBuf->smbus_ObjDate, smbus_ObjDate, sizeof(pBuf->smbus_ObjDate));
 pBuf->smbus_ObjDate[sizeof(pBuf->smbus_ObjDate) - 1] = '\0';
 strncpy(pBuf->smbus_OsArchitecture, smbus_OsArchitecture, sizeof(pBuf->smbus_OsArchitecture));
 pBuf->smbus_OsArchitecture[sizeof(pBuf->smbus_OsArchitecture) - 1] = '\0';
 strncpy(pBuf->smbus_OsVersion, smbus_OsVersion, sizeof(pBuf->smbus_OsVersion));
 pBuf->smbus_OsVersion[sizeof(pBuf->smbus_OsVersion) - 1] = '\0';
 strncpy(pBuf->smbus_CompilerVersion, smbus_CompilerVersion, sizeof(pBuf->smbus_CompilerVersion));
 pBuf->smbus_CompilerVersion[sizeof(pBuf->smbus_CompilerVersion) - 1] = '\0';
 strncpy(pBuf->smbus_KernelVersion, smbus_KernelVersion, sizeof(pBuf->smbus_KernelVersion));
 pBuf->smbus_KernelVersion[sizeof(pBuf->smbus_KernelVersion) - 1] = '\0';
 return;
}
static void* smbus_DMA_Memory_Alloc(DWORD Size)
{
 void *pVirt = NULL;
 dma_addr_t dummy;
 if ((smbusArchXEN & 0x00000001) &&
  (smbusArchFacil & 0x00002000))
 {
  pVirt = (void *) SMBUS_DMA_MEM_GET(SMBUS_MY_DMA_DEVICE, 4*1024, &dummy, GFP_DMA);
  if (pVirt == NULL)
  {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_DMA_alloc(): ## ERROR! dma_alloc_coherent failed (dev=0x%p, size=%d, dummy=0x%p, flags=0x%08X)!\n", (int)(jiffies-jiffies0), SMBUS_MY_DMA_DEVICE, 4*1024, &dummy, GFP_DMA); } while (0);
   return NULL;
  }
  else
  {
   return pVirt;
  }
 }
 else
 {
  pVirt = (void *) __get_free_page(GFP_KERNEL | GFP_DMA);
  if (pVirt == NULL)
  {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_DMA_alloc(): ## ERROR! __get_free_page failed (0x%08X)!\n", (int)(jiffies-jiffies0), (GFP_KERNEL | GFP_DMA)); } while (0);
   return NULL;
  }
  else
  {
   mem_map_reserve(virt_to_page(pVirt));
   return pVirt;
  }
 }
 do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_DMA_alloc(): ## ERROR! This should not happend (0x%08X)!\n", (int)(jiffies-jiffies0), 0xFFFFFFFF); } while (0);
 return NULL;
}
static void smbus_DMA_Memory_Free(void *pVirt, DWORD Size)
{
 if (pVirt != NULL)
 {
  if ((smbusArchXEN & 0x00000001) &&
   (smbusArchFacil & 0x00002000))
  {
   SMBUS_DMA_MEM_FREE(SMBUS_MY_DMA_DEVICE, 4*1024, pVirt, virt_to_bus(pVirt));
  }
  else
  {
   mem_map_unreserve(virt_to_page(pVirt));
   free_page((ulong)(pVirt));
  }
 }
}
static int smbus_register_ioctl32 (unsigned int cmd, char *name)
{
 int ret = 0;
 REGISTER_IOCTL32_CONVERSION(ret, cmd);
 if (ret < 0) {
  printk(KERN_ERR "smbus(%d): " "smbus_register_ioctl32: unable to register %s, ret=%d\n", (int)(jiffies-jiffies0),name, ret);
  return ret;
 } else {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_register_ioctl32: successfully registered %s\n", (int)(jiffies-jiffies0),name); } while (0);
 }
 return 0;
}
static int smbus_register_ioctl32_all (void)
{
 int ret;
 if ( !(smbusArchMode & 0x00000010) ) return 0;
 do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_register_ioctl32_all: register ioctl32 commands (%d)\n", (int)(jiffies-jiffies0),0); } while (0);
 if ((ret = smbus_register_ioctl32(_IOWR('s', 0xFF, QWORD), "IOCTL_SMBUS_DRIVER_INFO" )) < 0) return ret;
 if ((ret = smbus_register_ioctl32(_IOW('s', 0x5D, SMBI_HEADER), "IOCTL_DEVBIOS_SMBI_INFO" )) < 0) return ret;
 if ((ret = smbus_register_ioctl32(_IOWR('s',0x5E, LA_DRIVER_IOCTRL), "IOCTL_DEVBIOS_SMBI_CMD" )) < 0) return ret;
 if ((ret = smbus_register_ioctl32(_IOW('s', 0x6B, IOCTLDATA_INDEXED_PORT_IO), "IOCTL_DEVBUSIO_INDEXED_PORT_OUT" )) < 0) return ret;
 if ((ret = smbus_register_ioctl32(_IOR('s', 0x6C, IOCTLDATA_INDEXED_PORT_IO), "IOCTL_DEVBUSIO_INDEXED_PORT_IN" )) < 0) return ret;
 if ((ret = smbus_register_ioctl32(_IOR('s', 0x60, BIOS_API_HEADER), "IOCTL_DEVBAPI_BAPI_INFO" )) < 0) return ret;
 if ((ret = smbus_register_ioctl32(_IOWR('s',0x61 , DWORD), "IOCTL_DEVBAPI_BAPI_CMD" )) < 0) return ret;
 if ((ret = smbus_register_ioctl32(_IOWR('s',0x62, DWORD), "IOCTL_DEVBAPI_BAPI_CMD_EX" )) < 0) return ret;
 if ((ret = smbus_register_ioctl32(_IOR('s', 0x55, LA_DRIVER_IOCTRL), "IOCTL_DEVSMBUS_READ_SMBUS_DATA" )) < 0) return ret;
 if ((ret = smbus_register_ioctl32(_IOR('s', 0x56, IOCTLDATA_WRITE_SMBUS), "IOCTL_DEVSMBUS_WRITE_SMBUS_DATA" )) < 0) return ret;
 if ((ret = smbus_register_ioctl32(_IOWR('s',0x57, LA_DRIVER_IOCTRL), "IOCTL_DEVSMBUS_OPEN_DEVICE" )) < 0) return ret;
 if ((ret = smbus_register_ioctl32(_IOR('s', 0x58, DWORD), "IOCTL_DEVSMBUS_CLOSE_DEVICE" )) < 0) return ret;
 if ((ret = smbus_register_ioctl32(_IOR('s', 0x59, LA_DRIVER_IOCTRL), "IOCTL_DEVSMBUS_READ_DEVICE" )) < 0) return ret;
 if ((ret = smbus_register_ioctl32(_IOW('s', 0x5A, IOCTLDATA_SMBUS_WRITE_DEVICE), "IOCTL_DEVSMBUS_WRITE_DEVICE" )) < 0) return ret;
 if ((ret = smbus_register_ioctl32(_IOWR('s',0x63, DWORD), "IOCTL_DEVBAPI_BAPI_CONNECT_EVENTS" )) < 0) return ret;
 if ((ret = smbus_register_ioctl32(_IOWR('s',0x64, DWORD), "IOCTL_DEVBAPI_BAPI_CONNECT_MEM_ERRS" )) < 0) return ret;
 if ((ret = smbus_register_ioctl32(_IOR('s', 0x66, GABI_ENTRY_POINT), "IOCTL_DEVBIOS_GABI_DETECTED" )) < 0) return ret;
 if ((ret = smbus_register_ioctl32(_IOWR('s',0x67, LA_DRIVER_IOCTRL), "IOCTL_DEVBIOS_GABI_EXEC_CMD" )) < 0) return ret;
 if ((ret = smbus_register_ioctl32(_IOR('s', 0x6D, IOCTLDATA_GEN_IO), "IOCTL_DEVBUSIO_GENERIC_PORT_IN" )) < 0) return ret;
 if ((ret = smbus_register_ioctl32(_IOW('s', 0x6E, IOCTLDATA_GEN_IO), "IOCTL_DEVBUSIO_GENERIC_PORT_OUT" )) < 0) return ret;
 if ((ret = smbus_register_ioctl32(_IOW('s', 0x6F, IOCTLDATA_MULTIPORT_IO), "IOCTL_DEVBUSIO_MULTI_PORT_IO" )) < 0) return ret;
 if ((ret = smbus_register_ioctl32(_IOR('s', 0x70, IOCTLDATA_CORR_CPU_ERROR), "IOCTL_DEVBUSIO_GET_CPU_ERROR" )) < 0) return ret;
 if ((ret = smbus_register_ioctl32(_IOR('s', 0x71, IOCTLDATA_CPU_APICID_BOOT_CPU),"IOCTL_DEVBUSIO_GET_CPU_LOCAL_APIC_ID")) < 0) return ret;
 if ((ret = smbus_register_ioctl32(_IOR('s', 0x72, IOCTLDATA_CPU_INFO), "IOCTL_DEVBUSIO_GET_CPU_INFO" )) < 0) return ret;
 if ((ret = smbus_register_ioctl32(_IOR('s', 0x73, IOCTLDATA_CPU_APICID_EX),"IOCTL_DEVBUSIO_GET_CPU_LOCAL_APIC_ID_EX")) < 0) return ret;
 return 0;
}
static void smbus_unregister_ioctl32 (unsigned int cmd, char *name)
{
 int ret = 0;
 UNREGISTER_IOCTL32_CONVERSION(ret, cmd);
 if (ret < 0) {
  printk(KERN_ERR "smbus(%d): " "smbus_unregister_ioctl32: unable to unregister %s, ret=%d\n", (int)(jiffies-jiffies0),name, ret);
 } else {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_unregister_ioctl32: successfully unregistered %s\n", (int)(jiffies-jiffies0),name); } while (0);
 }
 return;
}
static void smbus_unregister_ioctl32_all (void)
{
 if ( !(smbusArchMode & 0x00000010) ) return;
 do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_unregister_ioctl32_all: unregister ioctl32 commands (%d)\n", (int)(jiffies-jiffies0),0); } while (0);
 smbus_unregister_ioctl32(_IOWR('s', 0xFF, QWORD), "IOCTL_SMBUS_DRIVER_INFO" );
 smbus_unregister_ioctl32(_IOW('s', 0x5D, SMBI_HEADER), "IOCTL_DEVBIOS_SMBI_INFO" );
 smbus_unregister_ioctl32(_IOWR('s',0x5E, LA_DRIVER_IOCTRL), "IOCTL_DEVBIOS_SMBI_CMD" );
 smbus_unregister_ioctl32(_IOW('s', 0x6B, IOCTLDATA_INDEXED_PORT_IO), "IOCTL_DEVBUSIO_INDEXED_PORT_OUT" );
 smbus_unregister_ioctl32(_IOR('s', 0x6C, IOCTLDATA_INDEXED_PORT_IO), "IOCTL_DEVBUSIO_INDEXED_PORT_IN" );
 smbus_unregister_ioctl32(_IOR('s', 0x60, BIOS_API_HEADER), "IOCTL_DEVBAPI_BAPI_INFO" );
 smbus_unregister_ioctl32(_IOWR('s',0x61 , DWORD), "IOCTL_DEVBAPI_BAPI_CMD" );
 smbus_unregister_ioctl32(_IOWR('s',0x62, DWORD), "IOCTL_DEVBAPI_BAPI_CMD_EX" );
 smbus_unregister_ioctl32(_IOR('s', 0x55, LA_DRIVER_IOCTRL), "IOCTL_DEVSMBUS_READ_SMBUS_DATA" );
 smbus_unregister_ioctl32(_IOR('s', 0x56, IOCTLDATA_WRITE_SMBUS), "IOCTL_DEVSMBUS_WRITE_SMBUS_DATA" );
 smbus_unregister_ioctl32(_IOWR('s',0x57, LA_DRIVER_IOCTRL), "IOCTL_DEVSMBUS_OPEN_DEVICE" );
 smbus_unregister_ioctl32(_IOR('s', 0x58, DWORD), "IOCTL_DEVSMBUS_CLOSE_DEVICE" );
 smbus_unregister_ioctl32(_IOR('s', 0x59, LA_DRIVER_IOCTRL), "IOCTL_DEVSMBUS_READ_DEVICE" );
 smbus_unregister_ioctl32(_IOW('s', 0x5A, IOCTLDATA_SMBUS_WRITE_DEVICE), "IOCTL_DEVSMBUS_WRITE_DEVICE" );
 smbus_unregister_ioctl32(_IOWR('s',0x63, DWORD), "IOCTL_DEVBAPI_BAPI_CONNECT_EVENTS" );
 smbus_unregister_ioctl32(_IOWR('s',0x64, DWORD), "IOCTL_DEVBAPI_BAPI_CONNECT_MEM_ERRS" );
 smbus_unregister_ioctl32(_IOR('s', 0x66, GABI_ENTRY_POINT), "IOCTL_DEVBIOS_GABI_DETECTED" );
 smbus_unregister_ioctl32(_IOWR('s',0x67, LA_DRIVER_IOCTRL), "IOCTL_DEVBIOS_GABI_EXEC_CMD" );
 smbus_unregister_ioctl32(_IOR('s', 0x6D, IOCTLDATA_GEN_IO), "IOCTL_DEVBUSIO_GENERIC_PORT_IN" );
 smbus_unregister_ioctl32(_IOW('s', 0x6E, IOCTLDATA_GEN_IO), "IOCTL_DEVBUSIO_GENERIC_PORT_OUT" );
 smbus_unregister_ioctl32(_IOW('s', 0x6F, IOCTLDATA_MULTIPORT_IO), "IOCTL_DEVBUSIO_MULTI_PORT_IO" );
 smbus_unregister_ioctl32(_IOR('s', 0x70, IOCTLDATA_CORR_CPU_ERROR), "IOCTL_DEVBUSIO_GET_CPU_ERROR" );
 smbus_unregister_ioctl32(_IOR('s', 0x71, IOCTLDATA_CPU_APICID_BOOT_CPU),"IOCTL_DEVBUSIO_GET_CPU_LOCAL_APIC_ID");
 smbus_unregister_ioctl32(_IOR('s', 0x72, IOCTLDATA_CPU_INFO), "IOCTL_DEVBUSIO_GET_CPU_INFO" );
 smbus_unregister_ioctl32(_IOR('s', 0x73, IOCTLDATA_CPU_APICID_EX),"IOCTL_DEVBUSIO_GET_CPU_LOCAL_APIC_ID_EX");
 return;
}
static void free_all(void)
{
 int i;
 if (pVirtMemorySmbi != NULL) {
  vfree(pVirtMemorySmbi);
  pVirtMemorySmbi = NULL;
  m_fSmbiExec = NULL;
 }
 if (m_pSmbiSearchAddr != NULL) {
  iounmap((void *) m_pSmbiSearchAddr);
  m_pSmbiSearchAddr = NULL;
 }
 if (m_pVirtMemoryBAPI != NULL) {
  vfree(m_pVirtMemoryBAPI);
  m_pVirtMemoryBAPI = NULL;
  m_fBapiExec = NULL;
 }
 if (m_pBAPIStaticPage != NULL) {
  mem_map_unreserve(virt_to_page(m_pBAPIStaticPage));
  free_page((ulong)m_pBAPIStaticPage);
  m_pBAPIStaticPage = NULL;
 }
 if (m_pBapiSearchAddr != NULL) {
  iounmap((void *) m_pBapiSearchAddr);
  m_pBapiSearchAddr = NULL;
 }
 if (m_pGabiSearchAddr != NULL) {
  iounmap((void *) m_pGabiSearchAddr);
  m_pGabiSearchAddr = NULL;
 }
 if (m_pVirtMemoryGABI != NULL) {
  vfree(m_pVirtMemoryGABI);
  m_pVirtMemoryGABI = NULL;
  m_fGabiExec = NULL;
 }
 FreeBuffer (&m_GabiControlBuffer);
 FreeBuffer (&m_GabiRequestBuffer);
 FreeBuffer (&m_GabiResponseBuffer);
 FreeBuffer (&m_pGABIStaticPage);
 if (m_pInOutBufferGABI != NULL)
 {
  kfree(m_pInOutBufferGABI);
  m_pInOutBufferGABI = NULL;
 }
 for (i = 0; i < 256; i++)
 {
  memset(OpenDevicesPersist[i], 0, sizeof(SMBUS_DEVICE_ADDRESS_DATA_ST));
  OpenDevices[i] = NULL;
 }
}
static struct file_operations smbus_fops =
{
 DRIVER_FOPS
};
int init_module(void)
{
 int ret;
 int result = 0;
 int i;
 jiffies0 = jiffies;
 if ((ret = smbus_DetermineEnvironment()) < 0) {
  printk(KERN_ERR "smbus(%d): " "init_module: unable to determine OS/HW environment (return = %d)\n", (int)(jiffies-jiffies0), ret);
  return -ENODEV;
 }
 DRIVER_PCI_PRESENT(result);
 if (result == 0) {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "init_module: ERROR: pcibios  is NOT present (%d)\n", (int)(jiffies-jiffies0), result); } while (0);
  return -ENODEV;
 }
 DetectBiosInterfaces();
 if (smbusDebug> 0)
 {
  do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "init_module: IsSmbiHwFound    = %d\n", (int)(jiffies-jiffies0), IsSmbiHwFound); } while (0);
  do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "init_module: IsBapiHwFound    = %d\n", (int)(jiffies-jiffies0), IsBapiHwFound); } while (0);
  do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "init_module: IsGabiHwFound    = %d\n", (int)(jiffies-jiffies0), IsGabiHwFound); } while (0);
  do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "init_module: IsSmbusHwFound   = %d --> postponed to later on\n", (int)(jiffies-jiffies0), IsSmbusHwFound); } while (0);
  do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "init_module: IsBusIoHwFound   = %d\n", (int)(jiffies-jiffies0), IsBusIoHwFound); } while (0);
  do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "init_module: IsCpuErrHwFound  = %d\n", (int)(jiffies-jiffies0), IsCpuErrHwFound); } while (0);
  do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "init_module: IsCpuApicHwFound = %d\n", (int)(jiffies-jiffies0), IsCpuApicHwFound); } while (0);
  do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "init_module: IsCpuInfoHwFound = %d\n", (int)(jiffies-jiffies0), IsCpuInfoHwFound); } while (0);
 }
 DRIVER_SET_OWNER;
 if((ret = register_chrdev(smbus_major, SMBUS_DEV, &smbus_fops)) < 0) {
  printk(KERN_ERR "smbus(%d): " "unable to get major %d  return = %d\n", (int)(jiffies-jiffies0), smbus_major, ret);
  free_all();
  return -EIO;
 }
 if (ret > 0) smbus_major = ret;
 do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "init_module: major device number = %d (0x%08x)\n", (int)(jiffies-jiffies0),smbus_major, smbus_major); } while (0);
 if ((ret = smbus_register_ioctl32_all()) < 0) {
  printk(KERN_ERR "smbus(%d): " "init_module: smbus_register_ioctl32 failed, ret = %d\n", (int)(jiffies-jiffies0), ret);
  cleanup_module();
  return -EIO;
 }
 for (i=0; i<256; i++)
 {
  OpenDevicesPersist[i] = &(SmBus_DAD_Buff[i]);
 }
 smbus_FillCpuInfoTable();
 smbus_InitDriverInfo();
 return 0;
}
void cleanup_module(void)
{
 do { if (smbusDebug & (1 << (0))) printk(KERN_DEBUG "smbus(%d):" "cleanup_module entered (%d)\n", (int)(jiffies-jiffies0),0); } while (0);
 smbus_unregister_ioctl32_all();
 free_all();
 (void) unregister_chrdev(smbus_major, SMBUS_DEV);
}
static void DetectBiosInterfaces(void)
{
 char smbiSignature[] = {'S','M','B','I','A','S','U','S'};
 IsGabiHwFound = FindGabi();
 if (!IsGabiHwFound)
 {
  IsBapiHwFound = FindBapi(0xE0000, 0, 0x20000, (DWORD)0x4DC94253);
  if (!IsBapiHwFound)
  {
   IsSmbiHwFound = FindSmbi(0xE0000, 0x10000, 0x10000, smbiSignature, sizeof(smbiSignature));
  }
 }
 return;
}
long smbus_ioctl_compat(struct file *file, unsigned int cmd, unsigned long arg)
{
 long result;
 GET_BIG_DRIVER_LOCK;
#ifdef KERNEL30
 result = (long) smbus_ioctl_body(file, cmd, arg);
#else
 result = (long) smbus_ioctl_body(NULL, file, cmd, arg);
#endif
 FREE_BIG_DRIVER_LOCK;
 return result;
}
#ifdef KERNEL30
static long smbus_ioctl(struct file *file, unsigned int cmd, unsigned long arg)
{
 long result;
 GET_BIG_DRIVER_LOCK;
 result = (long) smbus_ioctl_body(file, cmd, arg);
 FREE_BIG_DRIVER_LOCK;
 return result;
}
#else
static int smbus_ioctl(struct inode *inode, struct file *file, unsigned int cmd, unsigned long arg)
{
 int result;
 result = (int) smbus_ioctl_body(NULL, file, cmd, arg);
 return result;
}
#endif
#ifdef KERNEL30
static long smbus_ioctl_body(struct file *file, unsigned int cmd, unsigned long arg)
#else
static int smbus_ioctl_body(struct inode *inode, struct file *file, unsigned int cmd, unsigned long arg)
#endif
{
 unsigned int ioc_number = 0;
 unsigned int ioc_magic = 0;
 unsigned int ioc_size = 0;
 int err = 0;
 int i;
 unsigned char *ptmp = NULL;
 unsigned char dumpbuf[128];
#ifdef KERNEL30
 struct inode *inode = NULL;
 if (file != NULL && file->f_dentry != NULL)
 {
  inode = file->f_dentry->d_inode;
 }
#endif
 ioc_magic = (unsigned int)_IOC_TYPE(cmd);
 ioc_size = (unsigned int)_IOC_SIZE(cmd);
 ioc_number = (unsigned int)_IOC_NR(cmd);
 do { if (smbusDebug & (1 << (0))) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: (node=0x%p,file=0x%p) IOCTL=0x%08X (magic=0x%08X, number=0x%08X, size=0x%08X) arg=0x%016lX\n", (int)(jiffies-jiffies0),(void *)inode, (void *)file, cmd, ioc_magic, ioc_number, ioc_size, arg); } while (0);
 if (ioc_magic != 's') {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: CmdType != magic (0x%08X, 0x%08X) !!!\n", (int)(jiffies-jiffies0), ioc_magic, 's'); } while (0);
  return -EPERM;
 }
 if (ioc_number == (unsigned int)0xFF)
 {
  BYTE *parg;
  IOCTLDATA_SMBUS_DRIVER_INFO *pInOutBuf;
  IOCTLDATA_SMBUS_DRIVER_INFO_HDR IoCtrlBufHdr;
  IOCTLDATA_SMBUS_DRIVER_INFO IoCtrlBuf;
  parg = (BYTE *) (unsigned long) arg;
  if (parg == NULL) {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: IOCTL_SMBUS_DRIVER_INFO: arg pointer is NULL !!! (0x%p) \n", (int)(jiffies-jiffies0), parg); } while (0);
   return -EINVAL;
  }
  err = copy_from_user((BYTE *)&IoCtrlBufHdr, parg, sizeof(IoCtrlBufHdr));
  if (err != 0) {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: IOCTL_SMBUS_DRIVER_INFO: copy_from_user failed err = 0x%08X, parg = 0x%p\n", (int)(jiffies-jiffies0), err, (BYTE *)parg); } while (0);
   return -EFAULT;
  }
  if (IoCtrlBufHdr.VersionOfThisIoctl != smbus_DriverInfoHdr.VersionOfThisIoctl)
  {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: something is fishy on IOCTL_SMBUS_DRIVER_INFO: VersOfIoctl=%d, VerOfDriver=%d\n", (int)(jiffies-jiffies0), IoCtrlBufHdr.VersionOfThisIoctl, smbus_DriverInfoHdr.VersionOfThisIoctl); } while (0);
   return -EINVAL;
  }
  if (IoCtrlBufHdr.SizeOfInOutBuffer != smbus_DriverInfoHdr.SizeOfInOutBuffer)
  {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: something is fishy on IOCTL_SMBUS_DRIVER_INFO: sizeIoctl=%d, sizeDriver=%d\n", (int)(jiffies-jiffies0), IoCtrlBufHdr.SizeOfInOutBuffer, smbus_DriverInfoHdr.SizeOfInOutBuffer); } while (0);
   return -EINVAL;
  }
  do { if (smbusDebug & (1 << (0))) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: IOCTL_SMBUS_DRIVER_INFO is OK ! (node=0x%p,file=0x%p) IOCTL=0x%08X (magic=0x%08X, number=0x%08X, size=0x%08X) arg=0x%016lX\n", (int)(jiffies-jiffies0),(void *)inode, (void *)file, cmd, ioc_magic, ioc_number, ioc_size, arg); } while (0);
  smbus_DriverInfoHdr.pInOutBuffer = IoCtrlBufHdr.pInOutBuffer;
  pInOutBuf = (IOCTLDATA_SMBUS_DRIVER_INFO *)(unsigned long)(IoCtrlBufHdr.pInOutBuffer);
  if (pInOutBuf == NULL)
  {
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ## ERROR: IOCTL_SMBUS_DRIVER_INFO: Illegal parameter pInOutBuf=0x%p\n", (int)(jiffies-jiffies0), pInOutBuf); } while (0);
   return -EINVAL;
  }
  err = copy_from_user((BYTE*)&IoCtrlBuf, (BYTE *)pInOutBuf, sizeof(IoCtrlBuf));
  if (err != 0) {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ## ERROR: IOCTL_SMBUS_DRIVER_INFO copy_from_user failed err = 0x%08X, pInOutBuf = 0x%p\n", (int)(jiffies-jiffies0), err, pInOutBuf); } while (0);
   return -EFAULT;
  }
  strncpy(smbus_DriverInfo.RequestorName, IoCtrlBuf.RequestorName, sizeof(smbus_DriverInfo.RequestorName));
  smbus_DriverInfo.RequestorName[sizeof(smbus_DriverInfo.RequestorName) - 1] = '\0';
  smbus_DriverInfo.RequestorVersion = IoCtrlBuf.RequestorVersion;
  do { if (smbusDebug & (1 << (0))) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: IOCTL_SMBUS_DRIVER_INFO: RequestorName = \"%s\", RequestorVersion = 0x%08X\n", (int)(jiffies-jiffies0), smbus_DriverInfo.RequestorName, smbus_DriverInfo.RequestorVersion); } while (0);
  if (smbus_DriverInfo.RequestorVersion < smbus_DriverInfo.smbus_VersionCode)
  {
   printk(KERN_INFO "smbus(%d): " "smbus_ioctl: WARNING: IOCTL_SMBUS_DRIVER_INFO: Version Code (0x%08X) of Requestor \"%s\" is less than Version Code (0x%08X) of this driver\n", (int)(jiffies-jiffies0), smbus_DriverInfo.RequestorVersion, smbus_DriverInfo.RequestorName, smbus_DriverInfo.smbus_VersionCode);
  }
  strncpy(smbus_DriverInfo.SV_SYSTEM, IoCtrlBuf.SV_SYSTEM, sizeof(smbus_DriverInfo.SV_SYSTEM));
  smbus_DriverInfo.SV_SYSTEM[sizeof(smbus_DriverInfo.SV_SYSTEM) - 1] = '\0';
  do { if (smbusDebug & (1 << (0))) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: IOCTL_SMBUS_DRIVER_INFO: Requestor: SV_SYSTEM   = \"%s\"\n", (int)(jiffies-jiffies0), smbus_DriverInfo.SV_SYSTEM); } while (0);
  strncpy(smbus_DriverInfo.SV_OS, IoCtrlBuf.SV_OS, sizeof(smbus_DriverInfo.SV_OS));
  smbus_DriverInfo.SV_OS[sizeof(smbus_DriverInfo.SV_OS) - 1] = '\0';
  do { if (smbusDebug & (1 << (0))) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: IOCTL_SMBUS_DRIVER_INFO: Requestor: SV_OS       = \"%s\"\n", (int)(jiffies-jiffies0), smbus_DriverInfo.SV_OS); } while (0);
  strncpy(smbus_DriverInfo.SV_NICKNAME, IoCtrlBuf.SV_NICKNAME, sizeof(smbus_DriverInfo.SV_NICKNAME));
  smbus_DriverInfo.SV_NICKNAME[sizeof(smbus_DriverInfo.SV_NICKNAME) - 1] = '\0';
  do { if (smbusDebug & (1 << (0))) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: IOCTL_SMBUS_DRIVER_INFO: Requestor: SV_NICKNAME = \"%s\"\n", (int)(jiffies-jiffies0), smbus_DriverInfo.SV_NICKNAME); } while (0);
  err = copy_to_user((BYTE *)pInOutBuf, (BYTE *)&smbus_DriverInfo, IoCtrlBufHdr.SizeOfInOutBuffer);
  if (err != 0) {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: IOCTL_SMBUS_DRIVER_INFO: copy_to_user failed err = 0x%08X, pInOutBuf = 0x%p\n", (int)(jiffies-jiffies0), err, (BYTE *)pInOutBuf); } while (0);
   return -EFAULT;
  }
  smbus_DriverInfoHdr.Success = 1;
  err = copy_to_user(parg, (BYTE *)&smbus_DriverInfoHdr, sizeof(IOCTLDATA_SMBUS_DRIVER_INFO_HDR));
  if (err != 0) {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: IOCTL_SMBUS_DRIVER_INFO: copy_to_user failed err = 0x%08X, parg = 0x%p\n", (int)(jiffies-jiffies0), err, (BYTE *)parg); } while (0);
   return -EFAULT;
  }
  return sizeof(IOCTLDATA_SMBUS_DRIVER_INFO);
 }
 if ((ioc_number < 0x55) || (ioc_number > 0x73)) {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: CmdNumber out of range (0x%08X [0x%08X 0x%08X]) !!! \n", (int)(jiffies-jiffies0), ioc_number, 0x55, 0x73); } while (0);
  return -EPERM;
 }
 switch(ioc_number)
 {
  case 0x5D:
  {
   SMBI_HEADER *parg;
   if (!IsSmbiHwFound || (m_pSmbiBase == NULL)) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: WARNING: SMBI not available ! m_pSmbiBase = 0x%p\n", (int)(jiffies-jiffies0), m_pSmbiBase); } while (0);
    return -ENXIO;
   }
   parg = (SMBI_HEADER *) (unsigned long) arg;
   if (parg == NULL) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: arg pointer is NULL !!! (0x%p) \n", (int)(jiffies-jiffies0), parg); } while (0);
    return -EINVAL;
   }
   err = copy_to_user(parg, m_pSmbiBase, sizeof(SMBI_HEADER));
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_to_user failed err = 0x%08X, parg = 0x%p\n", (int)(jiffies-jiffies0), err, (BYTE *)parg); } while (0);
    return -EFAULT;
   }
   return sizeof(SMBI_HEADER);
  }
  case 0x5E:
  {
   BYTE *parg;
   BYTE *pInBuffer;
   BYTE *pOutBuffer;
   LA_DRIVER_IOCTRL IoCtrlBuf;
   DWORD InBufferSize;
   DWORD OutBufferSize;
   DWORD length;
   if (!IsSmbiHwFound || (m_pSmbiBase == NULL)) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: WARNING: SMBI not available ! m_pSmbiBase = 0x%p\n", (int)(jiffies-jiffies0), m_pSmbiBase); } while (0);
    return -ENXIO;
   }
   down(&smbus_mutex);
   parg = (BYTE *) (unsigned long) arg;
   if (parg == NULL) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: arg pointer is NULL !!! (0x%p) \n", (int)(jiffies-jiffies0), parg); } while (0);
    up(&smbus_mutex);
    return -EINVAL;
   }
   err = copy_from_user((BYTE *)&IoCtrlBuf, parg, sizeof(IoCtrlBuf));
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_from_user failed err = 0x%08X, parg = 0x%p\n", (int)(jiffies-jiffies0), err, (BYTE *)parg); } while (0);
    up(&smbus_mutex);
    return -EFAULT;
   }
   pInBuffer = (BYTE *)(unsigned long)(IoCtrlBuf.pInBuffer);
   pOutBuffer = (BYTE *)(unsigned long)(IoCtrlBuf.pOutBuffer);
   InBufferSize = IoCtrlBuf.InBufferSize;
   OutBufferSize = IoCtrlBuf.OutBufferSize;
   do { if (smbusDebug & (1 << (5))) printk(KERN_DEBUG "smbus(%d):" "SMBI cmd 0x%p(0x%08X) res 0x%p(0x%08X)\n", (int)(jiffies-jiffies0), pInBuffer, InBufferSize, pOutBuffer, OutBufferSize); } while (0);
   if ((pInBuffer == NULL) || (InBufferSize == 0)) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: invalid request len = 0x%08X, ptr = 0x%p\n", (int)(jiffies-jiffies0), InBufferSize, pInBuffer); } while (0);
    up(&smbus_mutex);
    return -EINVAL;
   }
   length = (InBufferSize < m_pSmbiBase->CMD_size) ? InBufferSize : m_pSmbiBase->CMD_size;
   err = copy_from_user(ulSmbiCmdBuffer, pInBuffer, length);
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_from_user failed err = 0x%08X, pInBuffer = 0x%p\n", (int)(jiffies-jiffies0), err, pInBuffer); } while (0);
    up(&smbus_mutex);
    return -EFAULT;
   }
   ASMX86(PUSH_RDX);
   ASMX86(PUSH_RAX);
   (*m_fSmbiExec)();
   ASMX86(POP_RAX);
   ASMX86(POP_RDX);
   if ((pOutBuffer == NULL) || (OutBufferSize == 0)) {
    length = 0;
    IoCtrlBuf.ReturnedBytes = 0;
    IoCtrlBuf.Success = 1;
   } else {
    length = ulSmbiResultBuffer[1];
    if (length > m_pSmbiBase->Result_size)
     length = m_pSmbiBase->Result_size;
    if (length > OutBufferSize)
     length = OutBufferSize;
    IoCtrlBuf.ReturnedBytes = sizeof(RESLT_PACKET);
    IoCtrlBuf.Success = 1;
   }
   err = copy_to_user(pOutBuffer, ulSmbiResultBuffer, length);
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_to_user failed err = 0x%08X, pOutBuffer = 0x%p\n", (int)(jiffies-jiffies0), err, pOutBuffer); } while (0);
    up(&smbus_mutex);
    return -EFAULT;
   }
   err = copy_to_user(parg, (BYTE *)&IoCtrlBuf, sizeof(IoCtrlBuf));
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_to_user failed err = 0x%08X, parg = 0x%p\n", (int)(jiffies-jiffies0), err, parg); } while (0);
    up(&smbus_mutex);
    return -EFAULT;
   }
   up(&smbus_mutex);
   return length;
  }
  case 0x60:
  {
   BIOS_API_HEADER_64 *parg;
   if (!IsBapiHwFound || (m_pBapiBase == NULL)) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: WARNING: BAPI not available ! m_pBapiBase = 0x%p\n", (int)(jiffies-jiffies0), m_pBapiBase); } while (0);
    return -ENXIO;
   }
   parg = (BIOS_API_HEADER_64 *) (unsigned long) arg;
   if (parg == NULL) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: arg pointer is NULL !!! (0x%p) \n", (int)(jiffies-jiffies0), parg); } while (0);
    return -EINVAL;
   }
   err = copy_to_user(parg, m_pBapiBase, sizeof(BIOS_API_HEADER_64));
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_to_user failed err = 0x%08X, parg = 0x%p\n", (int)(jiffies-jiffies0), err, (BYTE *)parg); } while (0);
    return -EFAULT;
   }
   return sizeof(BIOS_API_HEADER_64);
  }
  case 0x61:
  {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: WARNING: obsolete BAPI-Ioctl -> ignoring ! (0x%p, 0x%p)\n", (int)(jiffies-jiffies0), m_pBapiBase, m_pBAPIStaticPage); } while (0);
   return -EINVAL;
  }
  case 0x62:
  {
   if (!IsBapiHwFound || (m_pBapiBase == NULL) || (m_pBAPIStaticPage == NULL)) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: WARNING: BAPI not available ! (0x%p, 0x%p) \n", (int)(jiffies-jiffies0), m_pBapiBase, m_pBAPIStaticPage); } while (0);
    return -ENXIO;
   }
   if (smbusDebug > 0)
   {
    ptmp = &dumpbuf[0];
    for (i=0; i<16; i++)
    {
     sprintf(ptmp, "%02X ", *((unsigned char *)(&m_pBAPIStaticPage->Control)+i));
     ptmp = ptmp+3;
    }
    *ptmp = '\0';
    do { if (smbusDebug & (1 << (6))) printk(KERN_DEBUG "smbus(%d):" "BAPI-Cmd: Ctrl-Buf In : 0x %s\n", (int)(jiffies-jiffies0), dumpbuf); } while (0);
    do { if (smbusDebug & (1 << (6))) printk(KERN_DEBUG "smbus(%d):" "BAPI-Cmd: inlen=0x%08X\n", (int)(jiffies-jiffies0), m_pBAPIStaticPage->Data.In.Length); } while (0);
    ptmp = &dumpbuf[0];
    for (i=0; i<16; i++)
    {
     sprintf(ptmp, "%02X ", *((unsigned char *)(&m_pBAPIStaticPage->Data)+i));
     ptmp = ptmp+3;
    }
    *ptmp = '\0';
    do { if (smbusDebug & (1 << (6))) printk(KERN_DEBUG "smbus(%d):" "BAPI-Cmd: Data-Buf In : 0x %s\n", (int)(jiffies-jiffies0), dumpbuf); } while (0);
   }
   down(&smbus_mutex);
   smbus_CallBapi(m_phys_BAPI_DB, m_phys_BAPI_DB, m_phys_BAPI_CB, (BAPI_CMD_ROUTINE_VOID)m_fBapiExec);
   up(&smbus_mutex);
   if (smbusDebug > 0)
   {
    ptmp = &dumpbuf[0];
    for (i=0; i<16; i++)
    {
     sprintf(ptmp, "%02X ", *((unsigned char *)(&m_pBAPIStaticPage->Control)+i));
     ptmp = ptmp+3;
    }
    *ptmp = '\0';
    do { if (smbusDebug & (1 << (6))) printk(KERN_DEBUG "smbus(%d):" "BAPI-Cmd: Ctrl-Buf Out: 0x %s\n", (int)(jiffies-jiffies0), dumpbuf); } while (0);
    do { if (smbusDebug & (1 << (6))) printk(KERN_DEBUG "smbus(%d):" "BAPI-Cmd: outlen=0x%08X\n", (int)(jiffies-jiffies0), m_pBAPIStaticPage->Data.Out.Length); } while (0);
    ptmp = &dumpbuf[0];
    for (i=0; i<16; i++)
    {
     sprintf(ptmp, "%02X ", *((unsigned char *)(&m_pBAPIStaticPage->Data)+i));
     ptmp = ptmp+3;
    }
    *ptmp = '\0';
    do { if (smbusDebug & (1 << (6))) printk(KERN_DEBUG "smbus(%d):" "BAPI-Cmd: Data-Buf Out: 0x %s\n", (int)(jiffies-jiffies0), dumpbuf); } while (0);
   }
   return 0;
  }
  case 0x63:
  {
   if (!IsBapiHwFound || (m_pBapiBase == NULL) || (m_pBAPIStaticPage == NULL)) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: WARNING: BAPI not available ! (0x%p, 0x%p) \n", (int)(jiffies-jiffies0), m_pBapiBase, m_pBAPIStaticPage); } while (0);
    return -ENXIO;
   }
   do { if (smbusDebug & (1 << (6))) printk(KERN_DEBUG "smbus(%d):" "BAPI-Ev: inlen=0x%08X\n", (int)(jiffies-jiffies0), m_pBAPIStaticPage->EventsIn.Ev.AsStruct.Length); } while (0);
   down(&smbus_mutex);
   smbus_CallBapi(m_phys_BAPI_EvIn, m_phys_BAPI_EvOut, m_phys_BAPI_CB, (BAPI_CMD_ROUTINE_VOID)m_fBapiExec);
   up(&smbus_mutex);
   do { if (smbusDebug & (1 << (6))) printk(KERN_DEBUG "smbus(%d):" "BAPI-Ev: outlen=0x%08X\n", (int)(jiffies-jiffies0), m_pBAPIStaticPage->EventsOut.Ev.AsStruct.Length); } while (0);
   return 0;
  }
  case 0x64:
  {
   if (!IsBapiHwFound || (m_pBapiBase == NULL) || (m_pBAPIStaticPage == NULL)) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: WARNING: BAPI not available ! (0x%p, 0x%p) \n", (int)(jiffies-jiffies0), m_pBapiBase, m_pBAPIStaticPage); } while (0);
    return -ENXIO;
   }
   do { if (smbusDebug & (1 << (6))) printk(KERN_DEBUG "smbus(%d):" "BAPI-MemErr: inlen=0x%08X\n", (int)(jiffies-jiffies0), m_pBAPIStaticPage->MemoryErrors.Mem.AsStruct.Length); } while (0);
   down(&smbus_mutex);
   smbus_CallBapi(m_phys_BAPI_MemErr, m_phys_BAPI_MemErr, m_phys_BAPI_CB, (BAPI_CMD_ROUTINE_VOID)m_fBapiExec);
   up(&smbus_mutex);
   do { if (smbusDebug & (1 << (6))) printk(KERN_DEBUG "smbus(%d):" "BAPI-MemErr: outlen=0x%08X\n", (int)(jiffies-jiffies0), m_pBAPIStaticPage->MemoryErrors.Mem.AsStruct.Length); } while (0);
   return 0;
  }
  case 0x66:
  {
   down(&smbus_mutex);
   do { if (smbusDebug & (1 << (6))) printk(KERN_DEBUG "smbus(%d):" "GABI: IOCTL_DEVBIOS_GABI_DETECTED %d\n", (int)(jiffies-jiffies0), IsGabiHwFound); } while (0);
   if (!IsGabiHwFound || (m_pGabiBase == NULL) || (m_fGabiExec == NULL)) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: WARNING: GABI not available ! (0x%p, 0x%p) \n", (int)(jiffies-jiffies0), m_pGabiBase, m_fGabiExec); } while (0);
    up(&smbus_mutex);
    return -ENXIO;
   }
   up(&smbus_mutex);
   return 0;
  }
  case 0x67:
  {
   BYTE *parg = NULL;
   BYTE *pInputBufferUser = NULL;
   BYTE *pOutputBufferUser = NULL;
   BYTE *pInputBuffer = NULL;
   BYTE *pOutputBuffer = NULL;
   LA_DRIVER_IOCTRL IoCtrlBuf;
   DWORD inputSize = 0;
   DWORD outputSize = 0;
   DWORD nrBytesReturn = 0;
   down(&smbus_mutex);
   do { if (smbusDebug & (1 << (6))) printk(KERN_DEBUG "smbus(%d):" "GABI: IOCTL_DEVBIOS_GABI_EXEC_CMD %d\n", (int)(jiffies-jiffies0), IsGabiHwFound); } while (0);
   if (!IsGabiHwFound || (m_pGabiBase == NULL) || (m_fGabiExec == NULL)) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: WARNING: GABI not available ! (0x%p, 0x%p) \n", (int)(jiffies-jiffies0), m_pGabiBase, m_fGabiExec); } while (0);
    up(&smbus_mutex);
    return -ENXIO;
   }
   parg = (BYTE *) (unsigned long) arg;
   if (parg == NULL) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ## ERROR: arg pointer is NULL !!! (0x%p) \n", (int)(jiffies-jiffies0), parg); } while (0);
    up(&smbus_mutex);
    return -EINVAL;
   }
   err = copy_from_user((BYTE *)&IoCtrlBuf, parg, sizeof(IoCtrlBuf));
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ## ERROR: copy_from_user failed err = 0x%08X, parg = 0x%p\n", (int)(jiffies-jiffies0), err, parg); } while (0);
    up(&smbus_mutex);
    return -EFAULT;
   }
   pInputBufferUser = (BYTE *)(unsigned long)(IoCtrlBuf.pInBuffer);
   pOutputBufferUser = (BYTE *)(unsigned long)(IoCtrlBuf.pOutBuffer);
   inputSize = IoCtrlBuf.InBufferSize;
   outputSize = IoCtrlBuf.OutBufferSize;
   pInputBuffer = m_pInOutBufferGABI;
   pOutputBuffer = m_pInOutBufferGABI + 6*1024;
   if (NULL == pInputBufferUser || NULL == pInputBufferUser ||
    inputSize == 0 || outputSize == 0 || inputSize > 6*1024 || outputSize > 6*1024)
   {
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ## ERROR! Illegal parameters pInputBufferUser=0x%p, pOutputBufferUser=0x%p, inputSize=%d, outputSize=%d!\n", (int)(jiffies-jiffies0), pInputBufferUser, pOutputBufferUser, inputSize, outputSize); } while (0);
    up(&smbus_mutex);
    return -EINVAL;
   }
   err = copy_from_user(pInputBuffer, pInputBufferUser, inputSize);
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ## ERROR: copy_from_user failed err = 0x%08X, pInputBufferUser = 0x%p\n", (int)(jiffies-jiffies0), err, pInputBufferUser); } while (0);
    up(&smbus_mutex);
    return -EFAULT;
   }
   if (!GabiExecuteCommand (pInputBuffer, inputSize, pOutputBuffer, outputSize, &nrBytesReturn))
   {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ## ERROR: GabiExecuteCommand() failed ! parg=0x%p\n", (int)(jiffies-jiffies0), parg); } while (0);
    up(&smbus_mutex);
    return -EFAULT;
   }
   if (nrBytesReturn > outputSize)
   {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ## WARNING: nrBytesReturn (%d) is greater than > outputSize (%d) --> truncated\n", (int)(jiffies-jiffies0), nrBytesReturn, outputSize); } while (0);
    nrBytesReturn = outputSize;
   }
   err = copy_to_user(pOutputBufferUser, pOutputBuffer, nrBytesReturn);
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ## ERROR: copy_from_user failed err = 0x%08X, pOutputBuffer = 0x%p, nrBytesReturn=%d\n", (int)(jiffies-jiffies0), err, pOutputBuffer, nrBytesReturn); } while (0);
    up(&smbus_mutex);
    return -EFAULT;
   }
   IoCtrlBuf.ReturnedBytes = nrBytesReturn;
   IoCtrlBuf.Success = 1;
   err = copy_to_user(parg, (BYTE *)&IoCtrlBuf, sizeof(IoCtrlBuf));
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ## ERROR: copy_to_user failed err = 0x%08X, parg = 0x%p\n", (int)(jiffies-jiffies0), err, parg); } while (0);
    up(&smbus_mutex);
    return -EFAULT;
   }
   up(&smbus_mutex);
   return nrBytesReturn;
  }
  case 0x55:
  {
   BYTE *parg;
   BYTE *pInBuffer;
   BYTE *pOutBuffer;
   LA_DRIVER_IOCTRL IoCtrlBuf;
   IOCTLDATA_READ_SMBUS smbus;
   DWORD InBufferSize;
   DWORD OutBufferSize;
   BYTE SBuffer[sizeof(DWORD)];
   PBYTE pBuffer = (BYTE *)SBuffer;
   PBYTE pBAlloc = NULL;
   DWORD iLength;
   if (!IsSmbusHwFound) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: WARNING: SMBUS not available (IsSmbusHwFound = %d) !\n", (int)(jiffies-jiffies0), IsSmbusHwFound); } while (0);
    return -ENXIO;
   }
   parg = (BYTE *) (unsigned long) arg;
   if (parg == NULL) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: arg pointer is NULL !!! (0x%p) \n", (int)(jiffies-jiffies0), parg); } while (0);
    return -EINVAL;
   }
   err = copy_from_user((BYTE *)&IoCtrlBuf, parg, sizeof(IoCtrlBuf));
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_from_user failed err = 0x%08X, parg = 0x%p\n", (int)(jiffies-jiffies0), err, parg); } while (0);
    return -EFAULT;
   }
   pInBuffer = (BYTE *)(unsigned long)(IoCtrlBuf.pInBuffer);
   pOutBuffer = (BYTE *)(unsigned long)(IoCtrlBuf.pOutBuffer);
   InBufferSize = IoCtrlBuf.InBufferSize;
   OutBufferSize = IoCtrlBuf.OutBufferSize;
   if ((pInBuffer == NULL) || (pOutBuffer == NULL)) {
    do { if (smbusDebug & (1 << (9))) printk(KERN_DEBUG "smbus(%d):" "SMDEV: ERROR (EINVAL) pInBuffer=0x%p, pOutBuffer=0x%p\n", (int)(jiffies-jiffies0), pInBuffer, pOutBuffer); } while (0);
    return -EINVAL;
   }
   if ((InBufferSize < sizeof(IOCTLDATA_READ_SMBUS)) || (OutBufferSize == 0)) {
    do { if (smbusDebug & (1 << (9))) printk(KERN_DEBUG "smbus(%d):" "SMDEV: ERROR (EINVAL) InBufferSize=%d (min %d), OutBufferSize=%d\n", (int)(jiffies-jiffies0), InBufferSize, (DWORD)sizeof(IOCTLDATA_READ_SMBUS), OutBufferSize); } while (0);
    return -EINVAL;
   }
   err = copy_from_user((BYTE *)&smbus, pInBuffer, sizeof(IOCTLDATA_READ_SMBUS));
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_from_user failed err = 0x%08X, pInBuffer = 0x%p\n", (int)(jiffies-jiffies0), err, pInBuffer); } while (0);
    return -EFAULT;
   }
   do { if (smbusDebug & (1 << (9))) printk(KERN_DEBUG "smbus(%d):" "SMBUS dev 0x%08X off 0x%08X len %d\n", (int)(jiffies-jiffies0), smbus.DeviceAddress, smbus.StartOffset, OutBufferSize); } while (0);
   if ((smbus.DeviceAddress >= 0x100) || (smbus.StartOffset >= 0x100)) {
    do { if (smbusDebug & (1 << (9))) printk(KERN_DEBUG "smbus(%d):" "SMDEV: ERROR (EINVAL) invalid DeviceAddress=%d or StartOffset=%d (max 255)\n", (int)(jiffies-jiffies0), smbus.DeviceAddress, smbus.StartOffset); } while (0);
    return -EINVAL;
   }
   if (OutBufferSize > sizeof(SBuffer)) {
    pBAlloc = pBuffer = (PBYTE)kmalloc(OutBufferSize, GFP_USER);
    if (!pBAlloc)
     return -EAGAIN;
   }
   iLength = smbus_ReadData((BYTE)(smbus.DeviceAddress), (BYTE)(smbus.StartOffset), pBuffer, OutBufferSize);
   if (iLength > OutBufferSize)
    iLength = OutBufferSize;
   if (iLength > 0) {
    err = copy_to_user(pOutBuffer, pBuffer, iLength);
    if (err != 0) {
     do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_to_user failed err = 0x%08X, pOutBuffer = 0x%p\n", (int)(jiffies-jiffies0), err, pOutBuffer); } while (0);
     if (pBAlloc != NULL)
      kfree(pBAlloc);
     return -EFAULT;
    }
    IoCtrlBuf.ReturnedBytes = iLength;
    IoCtrlBuf.Success = (iLength == OutBufferSize);
   }
   if (pBAlloc != NULL)
    kfree(pBAlloc);
   err = copy_to_user(parg, (BYTE *)&IoCtrlBuf, sizeof(IoCtrlBuf));
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_to_user failed err = 0x%08X, parg = 0x%p\n", (int)(jiffies-jiffies0), err, parg); } while (0);
    return -EFAULT;
   }
   return iLength;
  }
  case 0x56:
  {
   BYTE *parg;
   BYTE *pData;
   IOCTLDATA_WRITE_SMBUS smbus;
   BYTE SBuffer[sizeof(DWORD)];
   PBYTE pBuffer = (BYTE *)SBuffer;
   PBYTE pBAlloc = NULL;
   DWORD iLength;
   if (!IsSmbusHwFound) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: WARNING: SMBUS not available (IsSmbusHwFound = %d) !\n", (int)(jiffies-jiffies0), IsSmbusHwFound); } while (0);
    return -ENXIO;
   }
   parg = (BYTE *) (unsigned long) arg;
   if (parg == NULL) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: arg pointer is NULL !!! (0x%p) \n", (int)(jiffies-jiffies0), parg); } while (0);
    return -EINVAL;
   }
   err = copy_from_user((BYTE *)&smbus, parg, (sizeof (IOCTLDATA_WRITE_SMBUS) - 256));
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_from_user failed err = 0x%08X, parg = 0x%p\n", (int)(jiffies-jiffies0), err, parg); } while (0);
    return -EFAULT;
   }
   pData = parg + (sizeof (IOCTLDATA_WRITE_SMBUS) - 256);
   do { if (smbusDebug & (1 << (9))) printk(KERN_DEBUG "smbus(%d):" "SMBUS dev 0x%08X off 0x%08X data 0x%p len %d\n", (int)(jiffies-jiffies0), smbus.DeviceAddress, smbus.StartOffset, pData, smbus.BytesToWrite); } while (0);
   if ((smbus.BytesToWrite == 0) || (smbus.BytesToWrite > 256)) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: invalid BytesToWrite value !!! (%d) \n", (int)(jiffies-jiffies0), smbus.BytesToWrite); } while (0);
    return -EINVAL;
   }
   if (smbus.StartOffset >= 0x100) {
    do { if (smbusDebug & (1 << (9))) printk(KERN_DEBUG "smbus(%d):" "SMDEV: ERROR (EINVAL) invalid StartOffset=%d (max 255)\n", (int)(jiffies-jiffies0), smbus.StartOffset); } while (0);
    return -EINVAL;
   }
   if (smbus.BytesToWrite > sizeof SBuffer) {
    pBAlloc = pBuffer = (PBYTE)kmalloc(smbus.BytesToWrite, GFP_USER);
    if (!pBAlloc)
     return -EAGAIN;
   }
   err = copy_from_user(pBuffer, pData, smbus.BytesToWrite);
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_from_user failed err = 0x%08X, pData = 0x%p\n", (int)(jiffies-jiffies0), err, pData); } while (0);
    if (pBAlloc)
     kfree(pBAlloc);
    return -EFAULT;
   }
   iLength = smbus_WriteData((BYTE)(smbus.DeviceAddress), (BYTE)(smbus.StartOffset), pBuffer, smbus.BytesToWrite);
   if ( iLength != smbus.BytesToWrite) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: smbus_WriteData() failed, only %d written\n", (int)(jiffies-jiffies0), iLength); } while (0);
    if (pBAlloc != NULL)
     kfree(pBAlloc);
    return -ENXIO;
   }
   if (pBAlloc != NULL)
    kfree(pBAlloc);
   return smbus.BytesToWrite;
  }
  case 0x57:
  {
   BYTE *parg;
   BYTE *pInBuffer;
   BYTE *pOutBuffer;
   LA_DRIVER_IOCTRL IoCtrlBuf;
   SMBUS_DEVICE_ADDRESS_DATA_ST smdev;
   DWORD InBufferSize;
   DWORD OutBufferSize;
   DWORD DeviceHandle;
   if (!IsSmbusHwFound) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: WARNING: SMBUS not available (IsSmbusHwFound = %d) !\n", (int)(jiffies-jiffies0), IsSmbusHwFound); } while (0);
    return -ENXIO;
   }
   parg = (BYTE *) (unsigned long) arg;
   if (parg == NULL) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: arg pointer is NULL !!! (0x%p) \n", (int)(jiffies-jiffies0), parg); } while (0);
    return -EINVAL;
   }
   err = copy_from_user((BYTE *)&IoCtrlBuf, parg, sizeof(IoCtrlBuf));
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_from_user failed err = 0x%08X, parg = 0x%p\n", (int)(jiffies-jiffies0), err, parg); } while (0);
    return -EFAULT;
   }
   pInBuffer = (BYTE *)(unsigned long)(IoCtrlBuf.pInBuffer);
   pOutBuffer = (BYTE *)(unsigned long)(IoCtrlBuf.pOutBuffer);
   InBufferSize = IoCtrlBuf.InBufferSize;
   OutBufferSize = IoCtrlBuf.OutBufferSize;
   if ((pInBuffer == NULL) || (pOutBuffer == NULL)) {
    do { if (smbusDebug & (1 << (9))) printk(KERN_DEBUG "smbus(%d):" "SMDEV: ERROR (EINVAL) pInBuffer=0x%p, pOutBuffer=0x%p\n", (int)(jiffies-jiffies0), pInBuffer, pOutBuffer); } while (0);
    return -EINVAL;
   }
   if ((InBufferSize < (sizeof(IOCTLDATA_SMBUS_OPEN_DEVICE))) ||
    (InBufferSize > sizeof(smdev)) || (OutBufferSize < sizeof(DWORD)))
   {
    do { if (smbusDebug & (1 << (9))) printk(KERN_DEBUG "smbus(%d):" "SMDEV: ERROR (EINVAL) InBufferSize=%d (max %d), OutBufferSize=%d\n", (int)(jiffies-jiffies0), InBufferSize, (DWORD)sizeof(smdev), OutBufferSize); } while (0);
    return -EINVAL;
   }
   err = copy_from_user((BYTE *)&smdev, pInBuffer, InBufferSize);
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_from_user failed err = 0x%08X, pInBuffer = 0x%p, InBufferSize = %d\n", (int)(jiffies-jiffies0), err, pInBuffer, InBufferSize); } while (0);
    return -EFAULT;
   }
   do { if (smbusDebug & (1 << (9))) printk(KERN_DEBUG "smbus(%d):" "SMDEV dev 0x%02x\n", (int)(jiffies-jiffies0), smdev.iod_open.DeviceAddress); } while (0);
   err = smbus_OpenDevice(&DeviceHandle, &smdev, InBufferSize);
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: smbus_OpenDevice() failed, err = 0x%08X\n", (int)(jiffies-jiffies0), err); } while (0);
    return -ENXIO;
   }
   err = copy_to_user(pOutBuffer, &DeviceHandle, sizeof(DWORD));
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_to_user failed err = 0x%08X, pOutBuffer = 0x%p\n", (int)(jiffies-jiffies0), err, pOutBuffer); } while (0);
    smbus_CloseDevice(DeviceHandle);
    return -EFAULT;
   }
   IoCtrlBuf.ReturnedBytes = sizeof(DWORD);
   IoCtrlBuf.Success = 1;
   err = copy_to_user(parg, (BYTE *)&IoCtrlBuf, sizeof(IoCtrlBuf));
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_to_user failed err = 0x%08X, parg = 0x%p\n", (int)(jiffies-jiffies0), err, parg); } while (0);
    smbus_CloseDevice(DeviceHandle);
    return -EFAULT;
   }
   return sizeof(DWORD);
  }
  case 0x58:
  {
   DWORD DeviceHandle;
   BYTE *parg;
   if (!IsSmbusHwFound) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: WARNING: SMBUS not available (IsSmbusHwFound = %d) !\n", (int)(jiffies-jiffies0), IsSmbusHwFound); } while (0);
    return -ENXIO;
   }
   parg = (BYTE *) (unsigned long) arg;
   if (parg == NULL) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: arg pointer is NULL !!! (0x%p) \n", (int)(jiffies-jiffies0), parg); } while (0);
    return -EINVAL;
   }
   err = copy_from_user(&DeviceHandle, (BYTE *)parg, sizeof(DWORD));
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_from_user failed err = 0x%08X, parg = 0x%p\n", (int)(jiffies-jiffies0), err, (BYTE *)parg); } while (0);
    return -EFAULT;
   }
   do { if (smbusDebug & (1 << (9))) printk(KERN_DEBUG "smbus(%d):" "SMDEV handle %d \n", (int)(jiffies-jiffies0), DeviceHandle); } while (0);
   err = smbus_CloseDevice(DeviceHandle);
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: smbus_ReadDevice() failed, err = 0x%08X\n", (int)(jiffies-jiffies0), err); } while (0);
    return -ENXIO;
   }
   return 0;
  }
  case 0x59:
  {
   BYTE *parg;
   BYTE *pInBuffer;
   BYTE *pOutBuffer;
   LA_DRIVER_IOCTRL IoCtrlBuf;
   IOCTLDATA_SMBUS_READ_DEVICE smdev;
   DWORD InBufferSize;
   DWORD OutBufferSize;
   BYTE SBuffer[sizeof(DWORD)];
   BYTE *pBuffer = SBuffer;
   BYTE *pBAlloc = NULL;
   DWORD iLength;
   if (!IsSmbusHwFound) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: WARNING: SMBUS not available (IsSmbusHwFound = %d) !\n", (int)(jiffies-jiffies0), IsSmbusHwFound); } while (0);
    return -ENXIO;
   }
   parg = (BYTE *) (unsigned long) arg;
   if (parg == NULL) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: arg pointer is NULL !!! (0x%p) \n", (int)(jiffies-jiffies0), parg); } while (0);
    return -EINVAL;
   }
   err = copy_from_user((BYTE *)&IoCtrlBuf, parg, sizeof(IoCtrlBuf));
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_from_user failed err = 0x%08X, parg = 0x%p\n", (int)(jiffies-jiffies0), err, parg); } while (0);
    return -EFAULT;
   }
   pInBuffer = (BYTE *)(unsigned long)(IoCtrlBuf.pInBuffer);
   pOutBuffer = (BYTE *)(unsigned long)(IoCtrlBuf.pOutBuffer);
   InBufferSize = IoCtrlBuf.InBufferSize;
   OutBufferSize = IoCtrlBuf.OutBufferSize;
   if ((pInBuffer == NULL) || (pOutBuffer == NULL)) {
    do { if (smbusDebug & (1 << (9))) printk(KERN_DEBUG "smbus(%d):" "SMDEV: ERROR (EINVAL) pInBuffer=0x%p, pOutBuffer=0x%p\n", (int)(jiffies-jiffies0), pInBuffer, pOutBuffer); } while (0);
    return -EINVAL;
   }
   if ((InBufferSize < sizeof(IOCTLDATA_SMBUS_READ_DEVICE)) || (OutBufferSize == 0)) {
    do { if (smbusDebug & (1 << (9))) printk(KERN_DEBUG "smbus(%d):" "SMDEV: ERROR (EINVAL) InBufferSize=%d (min %d), OutBufferSize=%d\n", (int)(jiffies-jiffies0), InBufferSize, (DWORD)sizeof(IOCTLDATA_SMBUS_READ_DEVICE), OutBufferSize); } while (0);
    return -EINVAL;
   }
   err = copy_from_user((BYTE *)&smdev, pInBuffer, sizeof(IOCTLDATA_SMBUS_READ_DEVICE));
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_from_user failed err = 0x%08X, pInBuffer = 0x%p\n", (int)(jiffies-jiffies0), err, parg); } while (0);
    return -EFAULT;
   }
   do { if (smbusDebug & (1 << (9))) printk(KERN_DEBUG "smbus(%d):" "SMDEV handle %d off %d len %d\n", (int)(jiffies-jiffies0), smdev.DeviceHandle, smdev.StartOffset, OutBufferSize); } while (0);
   if (smdev.StartOffset >= 0x100) {
    do { if (smbusDebug & (1 << (9))) printk(KERN_DEBUG "smbus(%d):" "SMDEV: ERROR (EINVAL) invalid StartOffset=%d (max 255)\n", (int)(jiffies-jiffies0), smdev.StartOffset); } while (0);
    return -EINVAL;
   }
   if (OutBufferSize > sizeof SBuffer)
   {
    pBAlloc = pBuffer = (BYTE *)kmalloc(OutBufferSize, GFP_USER);
    if (pBAlloc == NULL)
     return -EAGAIN;
   }
   err = smbus_ReadDevice(smdev.DeviceHandle, (BYTE)smdev.StartOffset, OutBufferSize, pBuffer, &iLength);
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: smbus_ReadDevice() failed, err = 0x%08X\n", (int)(jiffies-jiffies0), err); } while (0);
    if (pBAlloc != NULL)
     kfree(pBAlloc);
    return -ENXIO;
   }
   if (iLength > OutBufferSize)
    iLength = OutBufferSize;
   if (iLength > 0) {
    err = copy_to_user(pOutBuffer, pBuffer, iLength);
    if (err != 0) {
     do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_to_user failed err = 0x%08X, pOutBuffer = 0x%p\n", (int)(jiffies-jiffies0), err, pOutBuffer); } while (0);
     if (pBAlloc != NULL)
      kfree(pBAlloc);
     return -EFAULT;
    }
    IoCtrlBuf.ReturnedBytes = iLength;
    IoCtrlBuf.Success = 1;
   }
   if (pBAlloc != NULL)
    kfree(pBAlloc);
   err = copy_to_user(parg, (BYTE *)&IoCtrlBuf, sizeof(IoCtrlBuf));
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_to_user failed err = 0x%08X, parg = 0x%p\n", (int)(jiffies-jiffies0), err, parg); } while (0);
    return -EFAULT;
   }
   return iLength;
  }
  case 0x5A:
  {
   IOCTLDATA_SMBUS_WRITE_DEVICE smdev;
   BYTE *parg;
   BYTE SBuffer[sizeof(DWORD)];
   BYTE *pBuffer = SBuffer;
   BYTE *pBAlloc = NULL;
   BYTE *pProcessData;
   if (!IsSmbusHwFound) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: WARNING: SMBUS not available (IsSmbusHwFound = %d) !\n", (int)(jiffies-jiffies0), IsSmbusHwFound); } while (0);
    return -ENXIO;
   }
   parg = (BYTE *) (unsigned long) arg;
   if (parg == NULL) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: arg pointer is NULL !!! (0x%p) \n", (int)(jiffies-jiffies0), parg); } while (0);
    return -EINVAL;
   }
   err = copy_from_user((BYTE *)&smdev, parg, (sizeof (IOCTLDATA_SMBUS_WRITE_DEVICE) - sizeof (BYTE)));
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_from_user failed err = 0x%08X, parg = 0x%p\n", (int)(jiffies-jiffies0), err, (BYTE *)parg); } while (0);
    return -EFAULT;
   }
   pProcessData = parg + (sizeof (IOCTLDATA_SMBUS_WRITE_DEVICE) - sizeof (BYTE));
   do { if (smbusDebug & (1 << (5))) printk(KERN_DEBUG "smbus(%d):" "SMDEV handle %d off %d data 0x%p len %d\n", (int)(jiffies-jiffies0), smdev.DeviceHandle, smdev.StartOffset, pProcessData, smdev.BytesToWrite); } while (0);
   if ((smdev.BytesToWrite == 0) || (smdev.BytesToWrite > 256)) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: invalid BytesToWrite value !!! (%d) \n", (int)(jiffies-jiffies0), smdev.BytesToWrite); } while (0);
    return -EINVAL;
   }
   if (smdev.StartOffset >= 0x100) {
    do { if (smbusDebug & (1 << (5))) printk(KERN_DEBUG "smbus(%d):" "SMDEV: ERROR (EINVAL) invalid StartOffset=%d (max 255)\n", (int)(jiffies-jiffies0), smdev.StartOffset); } while (0);
    return -EINVAL;
   }
   if (smdev.BytesToWrite > sizeof(SBuffer)) {
    pBAlloc = pBuffer = (BYTE *) kmalloc(smdev.BytesToWrite, GFP_USER);
    if (pBAlloc == NULL)
     return -EAGAIN;
   }
   err = copy_from_user(pBuffer, pProcessData, smdev.BytesToWrite);
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_from_user failed err = 0x%08X, pProcessData = 0x%p\n", (int)(jiffies-jiffies0), err, pProcessData); } while (0);
    if (pBAlloc != NULL)
     kfree(pBAlloc);
    return -EFAULT;
   }
   err = smbus_WriteDevice(smdev.DeviceHandle, (BYTE)smdev.StartOffset, smdev.BytesToWrite, pBuffer);
   if ( err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: smbus_WriteDevice() failed, err = 0x%08X\n", (int)(jiffies-jiffies0), err); } while (0);
    if (pBAlloc != NULL)
     kfree(pBAlloc);
    return -ENXIO;
   }
   if (pBAlloc != NULL)
    kfree(pBAlloc);
   return smdev.BytesToWrite;
  }
  case 0x6C:
  {
   IOCTLDATA_INDEXED_PORT_IO portio;
   if (!IsBusIoHwFound) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: WARNING: BUS IO not available (IsBusIoHwFound = %d) !\n", (int)(jiffies-jiffies0), IsBusIoHwFound); } while (0);
    return -ENXIO;
   }
   err = copy_from_user(&portio, (IOCTLDATA_INDEXED_PORT_IO *)arg, sizeof(IOCTLDATA_INDEXED_PORT_IO));
   do { if (smbusDebug & (1 << (5))) printk(KERN_DEBUG "smbus(%d):" "PORTIO index 0x%02x=0x%02x data 0x%02x\n", (int)(jiffies-jiffies0), portio.IndexPort, portio.IndexData, portio.DataPort); } while (0);
   ReadFromIndexedPort(&portio);
   err = copy_to_user((IOCTLDATA_INDEXED_PORT_IO *)arg, &portio, sizeof(IOCTLDATA_INDEXED_PORT_IO));
   return sizeof(IOCTLDATA_INDEXED_PORT_IO);
  }
  case 0x6B:
  {
   IOCTLDATA_INDEXED_PORT_IO portio;
   if (!IsBusIoHwFound) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: WARNING: BUS IO not available (IsBusIoHwFound = %d) !\n", (int)(jiffies-jiffies0), IsBusIoHwFound); } while (0);
    return -ENXIO;
   }
   err = copy_from_user(&portio, (IOCTLDATA_INDEXED_PORT_IO *)arg, sizeof(IOCTLDATA_INDEXED_PORT_IO));
   do { if (smbusDebug & (1 << (5))) printk(KERN_DEBUG "smbus(%d):" "PORTIO index 0x%02x=0x%02x data 0x%02x=0x%02x\n", (int)(jiffies-jiffies0), portio.IndexPort, portio.IndexData, portio.DataPort, portio.DataData); } while (0);
   WriteToIndexedPort(&portio);
   err = copy_to_user((IOCTLDATA_INDEXED_PORT_IO *)arg, &portio, sizeof(IOCTLDATA_INDEXED_PORT_IO));
   return sizeof (IOCTLDATA_INDEXED_PORT_IO);
  }
  case 0x6D:
  {
   IOCTLDATA_GEN_IO genio;
   if (!IsBusIoHwFound) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: WARNING: BUS IO not available (IsBusIoHwFound = %d) !\n", (int)(jiffies-jiffies0), IsBusIoHwFound); } while (0);
    return -ENXIO;
   }
   err = copy_from_user(&genio, (IOCTLDATA_GEN_IO *)arg, sizeof(IOCTLDATA_GEN_IO));
   do { if (smbusDebug & (1 << (5))) printk(KERN_DEBUG "smbus(%d):" "GENIO-1 [%d] of 0x%08x\n", (int)(jiffies-jiffies0), genio.DataWidth, genio.Address); } while (0);
   if (genio.Address >= (1 << (sizeof(unsigned short) * 8))) return -EINVAL;
   genio.WriteData = 0L;
   switch(genio.DataWidth)
   {
    case sizeof(BYTE):
     genio.WriteData = (DWORD)inb((unsigned short)genio.Address);
     break;
    case sizeof(WORD):
     genio.WriteData = (DWORD)inw((unsigned short)genio.Address);
     break;
    case sizeof(DWORD):
     genio.WriteData = (DWORD)inl((unsigned short)genio.Address);
     break;
    default:
     return -EINVAL;
   }
   err = copy_to_user((BYTE *)arg, &genio.WriteData, genio.DataWidth);
   do { if (smbusDebug & (1 << (5))) printk(KERN_DEBUG "smbus(%d):" "GENIO-2 [%d]0x%08x from 0x%08x\n", (int)(jiffies-jiffies0), genio.DataWidth, genio.WriteData, genio.Address); } while (0);
   return genio.DataWidth;
  }
  case 0x6E:
  {
   IOCTLDATA_GEN_IO genio;
   if (!IsBusIoHwFound) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: WARNING: BUS IO not available (IsBusIoHwFound = %d) !\n", (int)(jiffies-jiffies0), IsBusIoHwFound); } while (0);
    return -ENXIO;
   }
   err = copy_from_user(&genio, (IOCTLDATA_GEN_IO *)arg, sizeof(IOCTLDATA_GEN_IO));
   do { if (smbusDebug & (1 << (5))) printk(KERN_DEBUG "smbus(%d):" "GENIO-3 [%d] 0x%08x to 0x%08x\n", (int)(jiffies-jiffies0), genio.DataWidth, genio.WriteData, genio.Address); } while (0);
   if (genio.Address >= (1 << (sizeof(unsigned short) * 8))) return -EINVAL;
   switch(genio.DataWidth)
   {
    case sizeof(BYTE):
     if (genio.WriteData >= (1 << (sizeof(unsigned char) * 8))) return -EINVAL;
     outb((BYTE)genio.WriteData, (unsigned short)genio.Address);
     break;
    case sizeof(WORD):
     if (genio.WriteData >= (1 << (sizeof(unsigned short) * 8))) return -EINVAL;
     outw((WORD)genio.WriteData, (unsigned short)genio.Address);
     break;
    case sizeof(DWORD):
     outl((DWORD)genio.WriteData, (unsigned short)genio.Address);
     break;
    default:
     return -EINVAL;
   }
   err = copy_to_user((IOCTLDATA_GEN_IO *)arg, &genio, sizeof(IOCTLDATA_GEN_IO));
   return genio.DataWidth;
  }
  case 0x6F:
  {
   BYTE *parg;
   IOCTLDATA_MULTIPORT_IO_ELEM *pElement = NULL;
   BYTE *pOutBuffer = NULL;
   DWORD NrElements;
   DWORD SizeOfOutBuffer;
   DWORD i;
   BOOL IsOutBufferAllocated = 0;
   IOCTLDATA_MULTIPORT_IO mpioHdr;
   if (!IsBusIoHwFound) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: WARNING: BUS IO not available (IsBusIoHwFound = %d) !\n", (int)(jiffies-jiffies0), IsBusIoHwFound); } while (0);
    return -ENXIO;
   }
   parg = (BYTE *) (unsigned long) arg;
   if (parg == NULL) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: arg pointer is NULL !!! (0x%p) \n", (int)(jiffies-jiffies0), parg); } while (0);
    return -EINVAL;
   }
   err = copy_from_user((BYTE *)&mpioHdr, parg, sizeof(IOCTLDATA_MULTIPORT_IO));
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_from_user failed err = 0x%08X, parg = 0x%p\n", (int)(jiffies-jiffies0), err, parg); } while (0);
    return -EFAULT;
   }
   NrElements = mpioHdr.NumberElements;
   if (NrElements == 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: WARNING: It is nothing to do !!! (NrElements=%d)\n", (int)(jiffies-jiffies0), NrElements); } while (0);
    return -EINVAL;
   }
   if (NrElements == 1)
   {
    SizeOfOutBuffer = sizeof(IOCTLDATA_MULTIPORT_IO);
    pOutBuffer = (BYTE *) &mpioHdr;
    IsOutBufferAllocated = 0;
    pElement = &(mpioHdr.Element[0]);
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: MULTI_PORT_IO-Ioctl, NrElements=%d (SizeOfOutBuffer=%d)\n", (int)(jiffies-jiffies0), NrElements, SizeOfOutBuffer); } while (0);
   }
   else
   {
    SizeOfOutBuffer = ((size_t) &((IOCTLDATA_MULTIPORT_IO *)0)->Element) + (NrElements*sizeof(IOCTLDATA_MULTIPORT_IO_ELEM));
    pOutBuffer = kmalloc(SizeOfOutBuffer, GFP_USER);
    if (pOutBuffer == NULL)
     return -EAGAIN;
    IsOutBufferAllocated = 1;
    pElement = &((IOCTLDATA_MULTIPORT_IO *)pOutBuffer)->Element[0];
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: MULTI_PORT_IO-Ioctl, NrElements=%d (SizeOfOutBuffer=%d)\n", (int)(jiffies-jiffies0), NrElements, SizeOfOutBuffer); } while (0);
    err = copy_from_user(pOutBuffer, parg, SizeOfOutBuffer);
    if (err != 0)
    {
     do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_from_user failed err=0x%08X, parg=0x%p, pOutBuffer=0x%p, size=%d\n", (int)(jiffies-jiffies0), err, parg, pOutBuffer, SizeOfOutBuffer); } while (0);
     if (IsOutBufferAllocated)
     {
      kfree(pOutBuffer);
      IsOutBufferAllocated = 0;
     }
     return -EFAULT;
    }
   }
   for (i=0; i < NrElements; i++)
   {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: MultiPortIO: Element[%d], Mode=0x%08X, Addr=0x%08X, Data=0x%08X\n", (int)(jiffies-jiffies0), i, pElement->Mode, pElement->Address, pElement->Data); } while (0);
    switch (pElement->Mode)
    {
     case 0x01:
      pElement->Data = (DWORD) inb((unsigned short)pElement->Address);
      do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: MultiPortIO: Element[%d], InByte from Addr=0x%08X, Data=0x%08X\n", (int)(jiffies-jiffies0), i, pElement->Address, pElement->Data); } while (0);
      break;
     case 0x02:
      pElement->Data = (DWORD) inw((unsigned short)pElement->Address);
      do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: MultiPortIO: Element[%d], InWord from Addr=0x%08X, Data=0x%08X\n", (int)(jiffies-jiffies0), i, pElement->Address, pElement->Data); } while (0);
      break;
     case 0x03:
      pElement->Data = (DWORD) inl((unsigned short)pElement->Address);
      do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: MultiPortIO: Element[%d], InDWord from Addr=0x%08X, Data=0x%08X\n", (int)(jiffies-jiffies0), i, pElement->Address, pElement->Data); } while (0);
      break;
     case 0x09:
      do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: MultiPortIO: Element[%d], OutByte to Addr=0x%08X, Data=0x%08X\n", (int)(jiffies-jiffies0), i, pElement->Address, pElement->Data); } while (0);
      outb((BYTE)pElement->Data, (unsigned short)pElement->Address);
      break;
     case 0x0a:
      do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: MultiPortIO: Element[%d], OutWord to Addr=0x%08X, Data=0x%08X\n", (int)(jiffies-jiffies0), i, pElement->Address, pElement->Data); } while (0);
      outw((WORD)pElement->Data, (unsigned short)pElement->Address);
      break;
     case 0x0b:
      do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: MultiPortIO: Element[%d], OutDWord to Addr=0x%08X, Data=0x%08X\n", (int)(jiffies-jiffies0), i, pElement->Address, pElement->Data); } while (0);
      outl((DWORD)pElement->Data, (unsigned short)pElement->Address);
      break;
     default:
      do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: MultiPortIO: Element[%d] ## ERROR in DeviceIoControl(): IOCTL_DEVBUSIO_MULTI_PORT_IO illegal Mode=0x%08X - fix this!\n", (int)(jiffies-jiffies0), i, pElement->Mode); } while (0);
      if (IsOutBufferAllocated)
      {
       kfree(pOutBuffer);
       IsOutBufferAllocated = 0;
      }
      return -EINVAL;
    }
    pElement++;
   }
   err = copy_to_user(parg, pOutBuffer, SizeOfOutBuffer);
   if (err != 0) {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR: copy_to_user failed err=0x%08X, parg=0x%p, pOutBuffer=0x%p, size=%d\n", (int)(jiffies-jiffies0), err, parg, pOutBuffer, SizeOfOutBuffer); } while (0);
    if (IsOutBufferAllocated)
    {
     kfree(pOutBuffer);
     IsOutBufferAllocated = 0;
    }
    return -EFAULT;
   }
   if (IsOutBufferAllocated)
   {
    kfree(pOutBuffer);
    IsOutBufferAllocated = 0;
   }
   return SizeOfOutBuffer;
  }
  case 0x5B:
  {
   IOCTLDATA_SMBUS_CHIP Chip;
   err = copy_from_user(&Chip, (IOCTLDATA_SMBUS_CHIP *)arg, sizeof(IOCTLDATA_SMBUS_CHIP));
   if (smbusDebug> 0)
   {
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "DEVSMBUS_SET_CHIP received (len = %d)\n", (int)(jiffies-jiffies0), (int)sizeof(IOCTLDATA_SMBUS_CHIP)); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "Chip: BaseAddress  : 0x%08X\n", (int)(jiffies-jiffies0), Chip.BaseAddress); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "      VendorId     : 0x%04X\n", (int)(jiffies-jiffies0), Chip.VendorId); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "      DeviceId     : 0x%04X\n", (int)(jiffies-jiffies0), Chip.DeviceId); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "      Chipset      : 0x%02X\n", (int)(jiffies-jiffies0), Chip.Chipset); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "      BusNo        : 0x%02X\n", (int)(jiffies-jiffies0), Chip.BusNo); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "      DeviceNo     : 0x%02X\n", (int)(jiffies-jiffies0), Chip.DeviceNo); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "      FunctionNo   : 0x%02X\n", (int)(jiffies-jiffies0), Chip.FunctionNo); } while (0);
   }
   my_SMBusBaseAddress = Chip.BaseAddress & 0x0000FFFC;
   my_VendorId = Chip.VendorId;
   my_DeviceId = Chip.DeviceId;
   my_Chipset = Chip.Chipset;
   my_BusNo = Chip.BusNo;
   my_DeviceNo = Chip.DeviceNo;
   my_FunctionNo = Chip.FunctionNo;
   if (my_Chipset == CS_UNKNOWN)
   {
    IsSmbusHwFound = 0;
   }
   else
   {
    IsSmbusHwFound = 1;
   }
   return 0;
  }
  case 0x70:
  {
   INT cpunr;
   CpuInfo *pentry;
   CpuErrorInfo CpuErrInfo;
   CpuErrorInfo *pCpuErrInfo = &CpuErrInfo;
   IOCTLDATA_CORR_CPU_ERROR CpuError;
   if (!IsCpuErrHwFound)
   {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: IOCTL_DEVBUSIO_GET_CPU_ERROR not supported!\n", (int)(jiffies-jiffies0)); } while (0);
    return -ENXIO;
   }
   err = copy_from_user(&CpuError, (IOCTLDATA_CORR_CPU_ERROR *)arg, sizeof(IOCTLDATA_CORR_CPU_ERROR));
   cpunr = CpuError.LogicalCpuNumber;
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: IOCTL_DEVBUSIO_GET_CPU_ERROR for CPU %02d\n", (int)(jiffies-jiffies0), cpunr); } while (0);
   if ((cpunr >= SMP_NUM_CPUS) || (cpunr >= 1024))
   {
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR !!! (geting cpu errors) invalid CPU Number=%d, SMP_NUM_CPUS=%d, SMBUS_MAX_CPUS_SUPPORTED=%d\n", (int)(jiffies-jiffies0), cpunr, SMP_NUM_CPUS, 1024); } while (0);
    return -EINVAL;
   }
   pentry = &smbus_cpuinfotable[cpunr];
   if (pentry->MachineCheckArchitectureSupported)
   {
    memset (&CpuError, 0, sizeof(IOCTLDATA_CORR_CPU_ERROR));
    CpuError.ErrorType = CPUERR_TYPE_NO_ERROR;
    pCpuErrInfo->pCpuError = &CpuError;
    pCpuErrInfo->DenseCpuNr = cpunr;
    smbus_do_GetCpuError(pCpuErrInfo);
    CpuError.LogicalCpuNumber = cpunr;
    err = copy_to_user((IOCTLDATA_CORR_CPU_ERROR *)arg, &CpuError, sizeof(IOCTLDATA_CORR_CPU_ERROR));
    return sizeof(IOCTLDATA_CORR_CPU_ERROR);
   } else {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: Machine Check Architecure not supported!\n", (int)(jiffies-jiffies0)); } while (0);
    return -ENXIO;
   }
  }
  case 0x71:
  {
   INT cpunr;
   CpuInfo *pentry;
   IOCTLDATA_CPU_APICID_BOOT_CPU ApicInfo;
   if (!IsCpuApicHwFound)
   {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: IOCTL_DEVBUSIO_GET_CPU_LOCAL_APIC_ID not supported!\n", (int)(jiffies-jiffies0)); } while (0);
    return -ENXIO;
   }
   err = copy_from_user(&ApicInfo, (IOCTLDATA_CPU_APICID_BOOT_CPU *)arg, sizeof(IOCTLDATA_CPU_APICID_BOOT_CPU));
   cpunr = ApicInfo.LogicalCpuNumber;
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: IOCTL_DEVBUSIO_GET_CPU_LOCAL_APIC_ID for CPU %02d\n", (int)(jiffies-jiffies0), cpunr); } while (0);
   if ((cpunr >= SMP_NUM_CPUS) || (cpunr >= 1024) || (cpunr >= 256))
   {
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR !!! (geting local ApicId) invalid CPU Number=%d, SMP_NUM_CPUS=%d, SMBUS_MAX_CPUS_SUPPORTED=%d (but max. 255)\n", (int)(jiffies-jiffies0), cpunr, SMP_NUM_CPUS, 1024); } while (0);
    return -EINVAL;
   }
   pentry = &smbus_cpuinfotable[cpunr];
   if (pentry->LocalApicSupported) {
    if (pentry->MachineCheckArchitectureSupported) {
     if (pentry->ApicGlobalEnable) {
      if (pentry->ApicIdValid) {
       ApicInfo.LocalApicId = (BYTE)pentry->ApicId;
       ApicInfo.IsBootCpu = pentry->BootstrapCpu ? 1 : 0;
       err = copy_to_user((IOCTLDATA_CPU_APICID_BOOT_CPU *)arg, &ApicInfo, sizeof(IOCTLDATA_CPU_APICID_BOOT_CPU));
      } else {
       do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ## ERROR: APIC Id for CPU %d not available\n", (int)(jiffies-jiffies0), cpunr); } while (0);
       return -ENXIO;
      }
     } else {
      do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ## Local APIC not enabled!\n", (int)(jiffies-jiffies0)); } while (0);
      return -ENXIO;
     }
    } else {
     do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ## Machine Check Architecture (MCA) not supported!\n", (int)(jiffies-jiffies0)); } while (0);
     return -ENXIO;
    }
   } else {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ## Local APIC not supported!\n", (int)(jiffies-jiffies0)); } while (0);
    return -ENXIO;
   }
   return sizeof(IOCTLDATA_CPU_APICID_BOOT_CPU);
  }
  case 0x72:
  {
   INT cpunr;
   CpuInfo *pentry;
   IOCTLDATA_CPU_INFO LocalData;
   if (!IsCpuInfoHwFound)
   {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: IOCTL_DEVBUSIO_GET_CPU_INFO not supported!\n", (int)(jiffies-jiffies0)); } while (0);
    return -ENXIO;
   }
   err = copy_from_user(&LocalData, (IOCTLDATA_CPU_INFO *)arg, sizeof(IOCTLDATA_CPU_INFO));
   cpunr = LocalData.LogicalCpuNumber;
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: IOCTL_DEVBUSIO_GET_CPU_INFO for CPU %02d\n", (int)(jiffies-jiffies0), cpunr); } while (0);
   if ((cpunr >= SMP_NUM_CPUS) || (cpunr >= 1024))
   {
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR !!! (geting CPU Info) invalid CPU Number=%d, SMP_NUM_CPUS=%d, SMBUS_MAX_CPUS_SUPPORTED=%d\n", (int)(jiffies-jiffies0), cpunr, SMP_NUM_CPUS, 1024); } while (0);
    return -EINVAL;
   }
   pentry = &smbus_cpuinfotable[cpunr];
   LocalData.DenseCpuNr = pentry->DenseCpuNr;
   LocalData.SparseCpuNr = pentry->SparseCpuNr;
   LocalData.regs1Valid = pentry->regs1Valid;
   LocalData.regs2Valid = pentry->regs2Valid;
   LocalData.regs3Valid = pentry->regs3Valid;
   LocalData.regs4Valid = pentry->regs4Valid;
   LocalData.BrandStringValid = pentry->BrandStringValid;
   LocalData.NrCoresAMDValid = pentry->NrCoresAMDValid;
   LocalData.MachineCheckArchitectureSupported = pentry->MachineCheckArchitectureSupported;
   LocalData.LocalApicSupported = pentry->LocalApicSupported;
   LocalData.PrimaryLogicalCpu = pentry->PrimaryLogicalCpu;
   LocalData.LocalApicIdInitial = pentry->LocalApicIdInitial;
   LocalData.Vendor = pentry->Vendor;
   LocalData.NrCores = pentry->NrCores;
   LocalData.NumberLogicalCpus = pentry->NumberLogicalCpus;
   LocalData.regs0.eax = pentry->regs0.eax;
   LocalData.regs0.ebx = pentry->regs0.ebx;
   LocalData.regs0.ecx = pentry->regs0.ecx;
   LocalData.regs0.edx = pentry->regs0.edx;
   LocalData.regs1.eax = pentry->regs1.eax;
   LocalData.regs1.ebx = pentry->regs1.ebx;
   LocalData.regs1.ecx = pentry->regs1.ecx;
   LocalData.regs1.edx = pentry->regs1.edx;
   LocalData.regs2.eax = pentry->regs2.eax;
   LocalData.regs2.ebx = pentry->regs2.ebx;
   LocalData.regs2.ecx = pentry->regs2.ecx;
   LocalData.regs2.edx = pentry->regs2.edx;
   LocalData.regs3.eax = pentry->regs3.eax;
   LocalData.regs3.ebx = pentry->regs3.ebx;
   LocalData.regs3.ecx = pentry->regs3.ecx;
   LocalData.regs3.edx = pentry->regs3.edx;
   LocalData.regs4.eax = pentry->regs4.eax;
   LocalData.regs4.ebx = pentry->regs4.ebx;
   LocalData.regs4.ecx = pentry->regs4.ecx;
   LocalData.regs4.edx = pentry->regs4.edx;
   LocalData.MaxExtentions.eax = pentry->MaxExtentions.eax;
   LocalData.MaxExtentions.ebx = pentry->MaxExtentions.ebx;
   LocalData.MaxExtentions.ecx = pentry->MaxExtentions.ecx;
   LocalData.MaxExtentions.edx = pentry->MaxExtentions.edx;
   LocalData.BrandString1.eax = pentry->BrandString1.eax;
   LocalData.BrandString1.ebx = pentry->BrandString1.ebx;
   LocalData.BrandString1.ecx = pentry->BrandString1.ecx;
   LocalData.BrandString1.edx = pentry->BrandString1.edx;
   LocalData.BrandString2.eax = pentry->BrandString2.eax;
   LocalData.BrandString2.ebx = pentry->BrandString2.ebx;
   LocalData.BrandString2.ecx = pentry->BrandString2.ecx;
   LocalData.BrandString2.edx = pentry->BrandString2.edx;
   LocalData.BrandString3.eax = pentry->BrandString3.eax;
   LocalData.BrandString3.ebx = pentry->BrandString3.ebx;
   LocalData.BrandString3.ecx = pentry->BrandString3.ecx;
   LocalData.BrandString3.edx = pentry->BrandString3.edx;
   LocalData.NrCoresAMD.eax = pentry->NrCoresAMD.eax;
   LocalData.NrCoresAMD.ebx = pentry->NrCoresAMD.ebx;
   LocalData.NrCoresAMD.ecx = pentry->NrCoresAMD.ecx;
   LocalData.NrCoresAMD.edx = pentry->NrCoresAMD.edx;
   LocalData.BootstrapCpu = pentry->BootstrapCpu;
   LocalData.ApicGlobalEnable = pentry->ApicGlobalEnable;
   LocalData.x2ApicMode = pentry->x2ApicMode;
   LocalData.ApicIdValid = pentry->ApicIdValid;
   LocalData.ApicId = pentry->ApicId;
   LocalData.ApicBaseMsr = pentry->ApicBaseMsr;
   LocalData.ApicBaseAddress = pentry->ApicBaseAddress;
   LocalData.x2ApicLocalApicId = pentry->x2ApicLocalApicId;
   err = copy_to_user((IOCTLDATA_CPU_INFO *)arg, &LocalData, sizeof(IOCTLDATA_CPU_INFO));
   return sizeof(IOCTLDATA_CPU_INFO);
  }
  case 0x73:
  {
   INT cpunr;
   CpuInfo *pentry;
   IOCTLDATA_CPU_APICID_EX ApicInfoEx;
   if (!IsCpuApicHwFound)
   {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: IOCTL_DEVBUSIO_GET_CPU_LOCAL_APIC_ID_EX not supported!\n", (int)(jiffies-jiffies0)); } while (0);
    return -ENXIO;
   }
   err = copy_from_user(&ApicInfoEx, (IOCTLDATA_CPU_APICID_EX *)arg, sizeof(IOCTLDATA_CPU_APICID_EX));
   cpunr = ApicInfoEx.LogicalCpuNumber;
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: IOCTL_DEVBUSIO_GET_CPU_LOCAL_APIC_ID_EX for CPU %02d\n", (int)(jiffies-jiffies0), cpunr); } while (0);
   if ((cpunr >= SMP_NUM_CPUS) || (cpunr >= 1024))
   {
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ERROR !!! (geting local ApicId) invalid CPU Number=%d, SMP_NUM_CPUS=%d, SMBUS_MAX_CPUS_SUPPORTED=%d\n", (int)(jiffies-jiffies0), cpunr, SMP_NUM_CPUS, 1024); } while (0);
    return -EINVAL;
   }
   pentry = &smbus_cpuinfotable[cpunr];
   if (pentry->LocalApicSupported) {
    if (pentry->MachineCheckArchitectureSupported) {
     if (pentry->ApicGlobalEnable) {
      if (pentry->ApicIdValid) {
       memset (&ApicInfoEx, 0, sizeof (IOCTLDATA_CPU_APICID_EX));
       ApicInfoEx.LogicalCpuNumber = cpunr;
       ApicInfoEx.LocalApicId = pentry->ApicId;
       ApicInfoEx.IsBootCpu = pentry->BootstrapCpu ? 1 : 0;
       ApicInfoEx.xApicGlobalEnable = pentry->ApicGlobalEnable ? 1 : 0;
       ApicInfoEx.x2ApicMode = pentry->x2ApicMode ? 1 : 0;
       err = copy_to_user((IOCTLDATA_CPU_APICID_EX *)arg, &ApicInfoEx, sizeof(IOCTLDATA_CPU_APICID_EX));
      } else {
       do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ## ERROR: APIC Id for CPU %d not available (EX)\n", (int)(jiffies-jiffies0), cpunr); } while (0);
       return -ENXIO;
      }
     } else {
      do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ## Local APIC not enabled! (EX)\n", (int)(jiffies-jiffies0)); } while (0);
      return -ENXIO;
     }
    } else {
     do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ## Machine Check Architecture (MCA) not supported! (EX)\n", (int)(jiffies-jiffies0)); } while (0);
     return -ENXIO;
    }
   } else {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: ## Local APIC not supported! (EX)\n", (int)(jiffies-jiffies0)); } while (0);
    return -ENXIO;
   }
   return sizeof(IOCTLDATA_CPU_APICID_EX);
  }
  default:
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: unsupported ioctl nr %d, size %d\n", (int)(jiffies-jiffies0), _IOC_NR(cmd), _IOC_SIZE(cmd)); } while (0);
   return -EPERM;
 }
 do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ioctl: unsupported ioctl nr %d, size %d (should not be reached!)\n", (int)(jiffies-jiffies0), _IOC_NR(cmd), _IOC_SIZE(cmd)); } while (0);
 return -EPERM;
}
static PBYTE FindSignature (PBYTE pStartAddress, DWORD Size, PBYTE pSignature, DWORD SignatureSize, BYTE ScanBoundary)
{
 PDWORD findPtr;
 BOOL b_signatureFound = 0;
 DWORD index;
 DWORD SignatureDWord = *((PDWORD)pSignature);
 for ( index = 0; index < Size; index += ScanBoundary)
 {
  findPtr = (PDWORD) (pStartAddress + index);
  if ( *findPtr == SignatureDWord )
  {
   if(memcmp(findPtr, pSignature, SignatureSize) == 0)
   {
    b_signatureFound = 1;
    break;
   }
  }
 }
 if(!b_signatureFound)
 {
  return NULL;
 }
 return (void *)findPtr;
}
static BOOL AllocateBuffer (PHYSICAL_MEMORY_DESCRIPTOR *bufferDescr, DWORD bufferSize)
{
 bufferDescr->AllocatedSize = 0;
 bufferDescr->pVirtualAddress = NULL;
 bufferDescr->PhysicalAddress = 0;
 if (bufferSize > 4*1024)
 {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "AllocateBuffer(): ## ERROR: cannot get memory greater than %d bytes (requested = %d)!\n", (int)(jiffies-jiffies0), 4*1024, bufferSize); } while (0);
  return 0;
 }
 bufferDescr->pVirtualAddress = (BYTE *) smbus_DMA_Memory_Alloc(4*1024);
 if (bufferDescr->pVirtualAddress == NULL)
 {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "AllocateBuffer(): ## ERROR! GABI static buffer allocation failed (requested=%d)!\n", (int)(jiffies-jiffies0), bufferSize); } while (0);
  return 0;
 }
 bufferDescr->AllocatedSize = bufferSize;
 if ((smbusArchXEN & 0x00000001) &&
  (smbusArchFacil & 0x00002000))
 {
  bufferDescr->PhysicalAddress = VIRT_TO_MACHINE(bufferDescr->pVirtualAddress);
 }
 else
 {
  bufferDescr->PhysicalAddress = virt_to_phys(bufferDescr->pVirtualAddress);
 }
 if (bufferDescr->PhysicalAddress > (ULONG)(0xFFFFFFFF - 0xFFFF))
 {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "AllocateBuffer(): ## ERROR: BIOS cannot handle addresses above 4GB! (0x%016llX)\n", (int)(jiffies-jiffies0), bufferDescr->PhysicalAddress); } while (0);
  FreeBuffer(bufferDescr);
  return 0;
 }
 return 1;
}
static void FreeBuffer (PHYSICAL_MEMORY_DESCRIPTOR *bufferDescr)
{
 if (bufferDescr->pVirtualAddress != NULL)
 {
  do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "FreeBuffer(): free buffer at virtual address = 0x%p\n", (int)(jiffies-jiffies0), bufferDescr->pVirtualAddress); } while (0);
  smbus_DMA_Memory_Free(bufferDescr->pVirtualAddress, 4*1024);
  bufferDescr->AllocatedSize = 0;
  bufferDescr->pVirtualAddress = NULL;
  bufferDescr->PhysicalAddress = 0;
 }
}
static BOOL FindGabi()
{
 int i;
 BYTE *pBiosMappedAddress = NULL;
 ulong high_mem_phy;
 BOOL Success = 0;
 ULONG tmp_fGabiPage = 0;
 ULONG tmp_fGabiOffset = 0;
 high_mem_phy = (ulong)virt_to_phys(high_memory);
 m_pGabiSearchAddr = ioremap(0xE0000, 0x20000);
 do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "high_mem_phy = 0x%016lX, m_pGabiSearchAddr = 0x%p\n", (int)(jiffies-jiffies0), high_mem_phy, m_pGabiSearchAddr); } while (0);
 pBiosMappedAddress = m_pGabiSearchAddr;
 do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GABISearchAddress = 0x%p (0x%016x) [+0x%016x,0x%016x]\n", (int)(jiffies-jiffies0), pBiosMappedAddress, 0xE0000, 0, 0x20000); } while (0);
 if (pBiosMappedAddress != NULL)
 {
  PBYTE pVirtualGabiStartAddr = pBiosMappedAddress;
  m_pGabiBase = (GABI_ENTRY_POINT *)FindSignature (pVirtualGabiStartAddr, 0x20000, (PBYTE)"_GABIEP_", sizeof("_GABIEP_")-1, 16);
  if (m_pGabiBase != NULL)
  {
   BYTE Checksum = 0;
   if (smbusDebug> 0)
   {
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GABIHeader     = 0x%p (0x%016lx)\n", (int)(jiffies-jiffies0), m_pGabiBase, (ULONG)((BYTE *)m_pGabiBase - pBiosMappedAddress + 0xE0000)); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "HeaderLength   = 0x%02X\n", (int)(jiffies-jiffies0), m_pGabiBase->ucLength); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "HeaderCheckSum = 0x%02X\n", (int)(jiffies-jiffies0), m_pGabiBase->ucCheckSum); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "HeaderVersion  = 0x%02X\n", (int)(jiffies-jiffies0), m_pGabiBase->ucVersion); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "BIOS_16_Offset = 0x%04X\n", (int)(jiffies-jiffies0), m_pGabiBase->usApi16Ofs); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "BIOS_16_Base   = 0x%08X\n", (int)(jiffies-jiffies0), m_pGabiBase->ulApi16Seg); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "EntryPoint32   = 0x%08X\n", (int)(jiffies-jiffies0), m_pGabiBase->ulEntryPoint32); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "EntryPoint64   = 0x%016llX\n", (int)(jiffies-jiffies0), m_pGabiBase->paEntryPoint64); } while (0);
   }
   for (i = 0; i < m_pGabiBase->ucLength; i++)
   {
    Checksum += ((PBYTE)m_pGabiBase)[i];
   }
   if (Checksum != 0)
   {
    m_pGabiBase = NULL;
    if (m_pGabiSearchAddr != NULL)
    {
     iounmap((void *) m_pGabiSearchAddr);
     m_pGabiSearchAddr = NULL;
    }
    printk(KERN_NOTICE "smbus(%d): " "WARNING: GABI HeaderChecksum ERROR, chksum = 0x%02X\n", (int)(jiffies-jiffies0), Checksum);
    return 0;
   }
   if (smbusArchMode & 0x20000000)
   {
    m_fGabiExec = (GABI_CMD_ROUTINE) (pBiosMappedAddress + m_pGabiBase->paEntryPoint64 - 0xE0000);
   }
   else
   {
    m_fGabiExec = (GABI_CMD_ROUTINE) (pBiosMappedAddress + m_pGabiBase->ulEntryPoint32 - 0xE0000);
   }
   if (m_fGabiExec == NULL)
   {
    m_pGabiBase = NULL;
    if (m_pGabiSearchAddr != NULL)
    {
     iounmap((void *) m_pGabiSearchAddr);
     m_pGabiSearchAddr = NULL;
    }
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "WARNING: GABI Service NOT available (1)!\n", (int)(jiffies-jiffies0)); } while (0);
    return 0;
   }
   if (smbusDebug> 0)
   {
    tmp_fGabiPage = (ULONG) m_fGabiExec & ~0x0FFFUL;
    DumpBytes (5, "1. GabiPage (ori):\n", (BYTE *)tmp_fGabiPage, 0x100);
    DumpBytes (5, "m_fGabiExec (ori):\n", (BYTE *)m_fGabiExec, 0x200);
    tmp_fGabiPage = tmp_fGabiPage + 4*1024;
    DumpBytes (5, "2. GabiPage (ori):\n", (BYTE *)tmp_fGabiPage, 0x100);
   }
   if ((smbusArchMode & 0x20000000) || (smbusArchMode & 0x00100000))
   {
    tmp_fGabiPage = (ULONG) m_fGabiExec & ~0x0FFFUL;
    tmp_fGabiOffset = (ULONG) m_fGabiExec & 0x0FFFUL;
    if ((m_pVirtMemoryGABI = VMALLOC_EXEC(2*4*1024)) != NULL)
    {
     memcpy(m_pVirtMemoryGABI, (void *) tmp_fGabiPage, 2*4*1024);
     do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "m_fGabiExec (ori)    = 0x%p\n", (int)(jiffies-jiffies0), m_fGabiExec); } while (0);
     do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "m_pVirtMemoryGABI    = 0x%p\n", (int)(jiffies-jiffies0), m_pVirtMemoryGABI); } while (0);
     m_fGabiExec = m_pVirtMemoryGABI + tmp_fGabiOffset;
     do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "m_fGabiExec (new)    = 0x%p\n", (int)(jiffies-jiffies0), m_fGabiExec); } while (0);
     if (smbusDebug> 0)
     {
      tmp_fGabiPage = (ULONG) m_fGabiExec & ~0x0FFFUL;
      DumpBytes (5, "1. GabiPage (new):\n", (BYTE *)tmp_fGabiPage, 0x100);
      DumpBytes (5, "m_fGabiExec (new):\n", (BYTE *)m_fGabiExec, 0x200);
      tmp_fGabiPage = tmp_fGabiPage + 4*1024;
      DumpBytes (5, "2. GabiPage (new):\n", (BYTE *)tmp_fGabiPage, 0x100);
     }
     if (m_pGabiSearchAddr != NULL)
     {
      iounmap((void *) m_pGabiSearchAddr);
      m_pGabiSearchAddr = NULL;
     }
    }
    else
    {
     do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "WARNING: Cannot get Executable-Page -> GABI Service NOT available!\n", (int)(jiffies-jiffies0)); } while (0);
     m_pGabiBase = NULL;
     m_fGabiExec = NULL;
     if (m_pGabiSearchAddr != NULL)
     {
      iounmap((void *) m_pGabiSearchAddr);
      m_pGabiSearchAddr = NULL;
     }
     return 0;
    }
   }
   Success = AllocateBuffer (&m_GabiControlBuffer, 1024);
   if (Success)
   {
    Success = AllocateBuffer (&m_GabiRequestBuffer, 4096);
    if (Success)
    {
     Success = AllocateBuffer (&m_GabiResponseBuffer, 4096);
     if (Success)
     {
      Success = AllocateBuffer (&m_pGABIStaticPage, 4*1024);
      if (Success)
      {
       m_pFreeVirtStMemGABI = m_pGABIStaticPage.pVirtualAddress;
       m_pFreePhysStMemGABI = m_pGABIStaticPage.PhysicalAddress;
       m_FreeStMemGABI = 4*1024;
       m_pInOutBufferGABI = (PBYTE) kmalloc(2 * 6*1024, GFP_USER);
       if (m_pInOutBufferGABI == NULL)
       {
        do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "AllocateBuffer(): ## ERROR: cannot get memory for In/Out-Buffer! (size=%d)\n", (int)(jiffies-jiffies0), 6*1024); } while (0);
        Success = 0;
       }
      }
     }
    }
   }
   if (!Success)
   {
    FreeBuffer (&m_GabiControlBuffer);
    FreeBuffer (&m_GabiRequestBuffer);
    FreeBuffer (&m_GabiResponseBuffer);
    FreeBuffer (&m_pGABIStaticPage);
    m_pGabiBase = NULL;
    if (m_pGabiSearchAddr != NULL)
    {
     iounmap((void *) m_pGabiSearchAddr);
     m_pGabiSearchAddr = NULL;
    }
    if (m_pVirtMemoryGABI != NULL)
    {
     vfree(m_pVirtMemoryGABI);
     m_pVirtMemoryGABI = NULL;
     m_fGabiExec = NULL;
    }
    if (m_pInOutBufferGABI != NULL)
    {
     kfree(m_pInOutBufferGABI);
     m_pInOutBufferGABI = NULL;
    }
    printk(KERN_INFO "smbus(%d): " "FindGabi(): WARNING: GABI Service NOT available (%d) !\n", (int)(jiffies-jiffies0), 3);
    return 0;
   }
   if (smbusDebug> 0)
   {
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GABI: Entry  Point (m_fGabiExec)  = 0x%p\n", (int)(jiffies-jiffies0), m_fGabiExec); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GABI: IoCtl  In/Out Buf Virt Addr = 0x%p\n", (int)(jiffies-jiffies0), m_pInOutBufferGABI); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GABI: IoCtl  In/Out Buf Size      = 0x%08x\n", (int)(jiffies-jiffies0), 6*1024); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GABI: Cntrl  Buf AllocSize        = 0x%08x\n", (int)(jiffies-jiffies0), (DWORD)m_GabiControlBuffer.AllocatedSize); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GABI: Cntrl  Buf Virt Addr        = 0x%p\n", (int)(jiffies-jiffies0), m_GabiControlBuffer.pVirtualAddress); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GABI: Cntrl  Buf Phys Addr        = 0x%016llx\n", (int)(jiffies-jiffies0), m_GabiControlBuffer.PhysicalAddress); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GABI: Input  Buf AllocSize        = 0x%08x\n", (int)(jiffies-jiffies0), (DWORD)m_GabiRequestBuffer.AllocatedSize); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GABI: Input  Buf Virt Addr        = 0x%p\n", (int)(jiffies-jiffies0), m_GabiRequestBuffer.pVirtualAddress); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GABI: Input  Buf Phys Addr        = 0x%016llx\n", (int)(jiffies-jiffies0), m_GabiRequestBuffer.PhysicalAddress); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GABI: Output Buf AllocSize        = 0x%08x\n", (int)(jiffies-jiffies0), (DWORD)m_GabiResponseBuffer.AllocatedSize); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GABI: Output Buf Virt Addr        = 0x%p\n", (int)(jiffies-jiffies0), m_GabiResponseBuffer.pVirtualAddress); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GABI: Output Buf Phys Addr        = 0x%016llx\n", (int)(jiffies-jiffies0), m_GabiResponseBuffer.PhysicalAddress); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GABI: StPage Buf AllocSize        = 0x%08x\n", (int)(jiffies-jiffies0), (DWORD)m_pGABIStaticPage.AllocatedSize); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GABI: StPage Buf Virt Addr        = 0x%p\n", (int)(jiffies-jiffies0), m_pGABIStaticPage.pVirtualAddress); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GABI: StPage Buf Phys Addr        = 0x%016llx\n", (int)(jiffies-jiffies0), m_pGABIStaticPage.PhysicalAddress); } while (0);
   }
   return 1;
  }
 }
 if (m_pGabiSearchAddr != NULL)
 {
  iounmap((void *) m_pGabiSearchAddr);
  m_pGabiSearchAddr = NULL;
 }
 return 0;
}
static void DumpBytes (BYTE traceLevel, LPSTR pTitle, BYTE *pMemory, SIZE_T nrBytes)
{
 SIZE_T offset;
 do { if (smbusDebug & (1 << (traceLevel))) printk(KERN_DEBUG "smbus(%d):" "%s\n", (int)(jiffies-jiffies0), pTitle); } while (0);
 for (offset=0; offset < nrBytes; offset += 0x10)
 {
  PBYTE pB = (PBYTE)pMemory + offset;
  do { if (smbusDebug & (1 << (traceLevel))) printk(KERN_DEBUG "smbus(%d):" "  %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x\n", (int)(jiffies-jiffies0), pB[0], pB[1], pB[2], pB[3], pB[4], pB[5], pB[6], pB[7], pB[8], pB[9], pB[10], pB[11], pB[12], pB[13], pB[14], pB[15]); } while (0);
 }
}
static BOOL GabiExecuteCommand (LPBYTE pInBuffer, DWORD InDataSize,
        LPBYTE pOutBuffer, DWORD OutBufferSize,
        DWORD *ReturnDataSize)
{
 BOOL success = 0;
 BOOL useDataDescriptorList = 0;
 GABI_CONTROL_BUFFER *pCallerControlBuffer = NULL;
 GABI_DATA_BUFFER_COMMON_HEADER *pCallerRequestBuffer = NULL;
 GABI_DATA_BUFFER_COMMON_HEADER *pCallerResponseBuffer = NULL;
 DWORD_PTR controlBufferInputSize = 0;
 DWORD_PTR responseBufferSize = 0;
 WORD allocatedControlBufferSize = 0;
 WORD allocatedRequestBufferSize = 0;
 WORD allocatedResponseBufferSize = 0;
 PHYSICAL_MEMORY_DESCRIPTOR_LIST *pRequestDescriptorList = NULL;
 PHYSICAL_MEMORY_DESCRIPTOR_LIST *pResponseDescriptorList = NULL;
 GABI_DATA_BUFFER_DESCR_HEADER responseHeader;
 GABI_CONTROL_BUFFER *pCtrl = NULL;
 ULONG ulPhysAddrCB = 0;
 ULONG ulPhysAddrINB = 0;
 ULONG ulPhysAddrOUTB = 0;
 BOOL PrepBufOK = 0;
 *ReturnDataSize = 0;
 do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "GabiExecuteCommand(): enter, InDataSize=%d, OutBufferSize=%d...\n", (int)(jiffies-jiffies0), InDataSize, OutBufferSize); } while (0);
 do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "GabiExecuteCommand():   pInBuffer=%p, pOutBuffer=%p\n", (int)(jiffies-jiffies0), pInBuffer, pOutBuffer); } while (0);
 for (;;)
 {
  if (m_GabiControlBuffer.AllocatedSize == 0 || m_GabiRequestBuffer.AllocatedSize == 0 || m_GabiResponseBuffer.AllocatedSize == 0 || m_pGABIStaticPage.AllocatedSize == 0)
  {
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GabiExecuteCommand(): ## ERROR! One of the allocated static buffers is not available! (%ld, %ld, %ld, %ld)\n", (int)(jiffies-jiffies0), m_GabiControlBuffer.AllocatedSize, m_GabiRequestBuffer.AllocatedSize, m_GabiResponseBuffer.AllocatedSize, m_pGABIStaticPage.AllocatedSize); } while (0);
   return 0;
  }
  if (smbusDebug> 0)
  {
   DumpBytes (5, "Input data dump:\n", pInBuffer, 0x80);
  }
  memset (m_GabiControlBuffer.pVirtualAddress, 0, m_GabiControlBuffer.AllocatedSize);
  memset (m_GabiRequestBuffer.pVirtualAddress, 0, m_GabiRequestBuffer.AllocatedSize);
  memset (m_GabiResponseBuffer.pVirtualAddress, 0, m_GabiResponseBuffer.AllocatedSize);
  pCallerControlBuffer = (GABI_CONTROL_BUFFER *)pInBuffer;
  pCallerRequestBuffer = (GABI_DATA_BUFFER_COMMON_HEADER *)(pInBuffer + pCallerControlBuffer->AllocatedBufferSize);
  pCallerResponseBuffer = (GABI_DATA_BUFFER_COMMON_HEADER *)(pOutBuffer + pCallerControlBuffer->AllocatedBufferSize);
  if (InDataSize < pCallerControlBuffer->AllocatedBufferSize + (((size_t) &((GABI_DATA_BUFFER_COMMON_HEADER *)0)->Data)))
  {
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GabiExecuteCommand(): ## ERROR! Input buffer too small (%d) to contain a control and a request buffer!\n", (int)(jiffies-jiffies0), InDataSize); } while (0);
   break;
  }
  if (OutBufferSize < pCallerControlBuffer->AllocatedBufferSize + (((size_t) &((GABI_DATA_BUFFER_COMMON_HEADER *)0)->Data)))
  {
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GabiExecuteCommand(): ## ERROR! Output buffer too small (%d) to contain a control and a response buffer!\n", (int)(jiffies-jiffies0), OutBufferSize); } while (0);
   break;
  }
  if (pCallerControlBuffer->AllocatedBufferSize < (((size_t) &((GABI_CONTROL_BUFFER *)0)->BiosScratchBuffer)))
  {
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GabiExecuteCommand(): ## ERROR! Input buffer smaller than minimum control buffer size (%ld)!\n", (int)(jiffies-jiffies0), (ULONG)(((size_t) &((GABI_CONTROL_BUFFER *)0)->BiosScratchBuffer))); } while (0);
   break;
  }
  if (smbusDebug> 0)
  {
   do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus(%d):" "GabiExecuteCommand(): control buffer size  : 0x%04X\n", (int)(jiffies-jiffies0), pCallerControlBuffer->AllocatedBufferSize); } while (0);
   do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus(%d):" "Gabi                  service category code: 0x%04X\n", (int)(jiffies-jiffies0), pCallerControlBuffer->ServiceCategoryCode); } while (0);
   do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus(%d):" "Gabi                  service code         : 0x%04X\n", (int)(jiffies-jiffies0), pCallerControlBuffer->ServiceCode); } while (0);
  }
  if ( pCallerControlBuffer->ServiceCategoryCode == 0x0007 ||
   (pCallerControlBuffer->ServiceCategoryCode & 0xfe00) == 0x8200)
  {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Use memory descriptor list as request/response data!\n", (int)(jiffies-jiffies0)); } while (0);
   useDataDescriptorList = 1;
  }
  else
  {
   do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus(%d):" "Use plain request/response data (no descriptor list) (%d)\n", (int)(jiffies-jiffies0), useDataDescriptorList); } while (0);
  }
  controlBufferInputSize = pCallerControlBuffer->AllocatedBufferSize;
  responseBufferSize = OutBufferSize - controlBufferInputSize;
  if (smbusDebug> 0)
  {
   do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus(%d):" "  given control buffer size = %ld\n", (int)(jiffies-jiffies0), controlBufferInputSize); } while (0);
   do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus(%d):" "  given response buffer size = %ld\n", (int)(jiffies-jiffies0), responseBufferSize); } while (0);
  }
  if (responseBufferSize > 0xffff)
  {
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GabiExecuteCommand(): ## ERROR! Supplied response buffer size (%ld) > maximum of 64kB!\n", (int)(jiffies-jiffies0), responseBufferSize); } while (0);
   responseBufferSize = 0xffff;
  }
  allocatedControlBufferSize = pCallerControlBuffer->AllocatedBufferSize;
  allocatedRequestBufferSize = pCallerRequestBuffer->AllocatedBufferSize;
  allocatedResponseBufferSize = (WORD)responseBufferSize;
  if (allocatedControlBufferSize > m_GabiControlBuffer.AllocatedSize)
  {
   allocatedControlBufferSize = (WORD)m_GabiControlBuffer.AllocatedSize;
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GabiExecuteCommand(): ## ERROR! Control buffer size (%d) > static GABI control buffer size - truncated!\n", (int)(jiffies-jiffies0), allocatedControlBufferSize); } while (0);
   break;
  }
  if (smbusDebug> 0)
  {
   do { if (smbusDebug & (1 << (5))) printk(KERN_DEBUG "smbus(%d):" "  allocated control buffer size = %d\n", (int)(jiffies-jiffies0), allocatedControlBufferSize); } while (0);
   do { if (smbusDebug & (1 << (5))) printk(KERN_DEBUG "smbus(%d):" "  allocated request buffer size = %d\n", (int)(jiffies-jiffies0), allocatedRequestBufferSize); } while (0);
  }
  pCallerControlBuffer->GeneralStatus = 0;
  pCallerControlBuffer->ErrorCode = 0;
  memcpy (m_GabiControlBuffer.pVirtualAddress, pCallerControlBuffer, allocatedControlBufferSize);
  ((GABI_DATA_BUFFER_COMMON_HEADER *)m_GabiControlBuffer.pVirtualAddress)->AllocatedBufferSize = (WORD)m_GabiControlBuffer.AllocatedSize;
  pRequestDescriptorList = NULL;
  pResponseDescriptorList = NULL;
  if (useDataDescriptorList)
  {
   pRequestDescriptorList = GabiAllocateDescriptorList();
   pResponseDescriptorList = GabiAllocateDescriptorList();
   if (pRequestDescriptorList == NULL || pResponseDescriptorList == NULL)
    break;
   if (pCallerRequestBuffer->AllocatedBufferSize < (((size_t) &((GABI_DATA_BUFFER_DESCR_HEADER *)0)->Data)))
   {
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GabiExecuteCommand(): ## ERROR! Request buffer size (%d) smaller than minimum header for buffer descriptors!\n", (int)(jiffies-jiffies0), pCallerRequestBuffer->AllocatedBufferSize); } while (0);
    break;
   }
   if (responseBufferSize < (((size_t) &((GABI_DATA_BUFFER_DESCR_HEADER *)0)->Data)))
   {
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "GabiExecuteCommand(): ## ERROR! Response buffer size (%ld) smaller than minimum header for buffer descriptors!\n", (int)(jiffies-jiffies0), responseBufferSize); } while (0);
    break;
   }
  }
  PrepBufOK = GabiPrepareGabiBuffer (&m_GabiRequestBuffer, pCallerRequestBuffer, pRequestDescriptorList, "RequestBuffer", 1);
  memset (&responseHeader, 0, sizeof (responseHeader));
  responseHeader.AllocatedBufferSize = allocatedResponseBufferSize;
  if (useDataDescriptorList)
  {
   responseHeader.StructureVersion = (WORD)1;
   responseHeader.TransactionHandle = 0;
   responseHeader.DataSize = allocatedResponseBufferSize - (((size_t) &((GABI_DATA_BUFFER_DESCR_HEADER *)0)->Data));
  }
  PrepBufOK = GabiPrepareGabiBuffer (&m_GabiResponseBuffer, (GABI_DATA_BUFFER_COMMON_HEADER *)&responseHeader, pResponseDescriptorList, "ResponseBuffer", 0);
  if (smbusDebug> 0)
  {
   do { if (smbusDebug & (1 << (5))) printk(KERN_DEBUG "smbus(%d):" "Request buffer virtual addr = 0x%p, phys addr = 0x%016llx, alloc size = %ld\n", (int)(jiffies-jiffies0), m_GabiRequestBuffer.pVirtualAddress, m_GabiRequestBuffer.PhysicalAddress, m_GabiRequestBuffer.AllocatedSize); } while (0);
   do { if (smbusDebug & (1 << (5))) printk(KERN_DEBUG "smbus(%d):" "Response buffer virtual addr = 0x%p, phys addr = 0x%016llx, alloc size = %ld\n", (int)(jiffies-jiffies0), m_GabiResponseBuffer.pVirtualAddress, m_GabiResponseBuffer.PhysicalAddress, m_GabiResponseBuffer.AllocatedSize); } while (0);
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "----------------------------------------------------", (int)(jiffies-jiffies0)); } while (0);
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Dumps of GABI buffers before request...", (int)(jiffies-jiffies0)); } while (0);
   DumpBytes (6, "Control buffer:\n", m_GabiControlBuffer.pVirtualAddress, 0x20);
   DumpBytes (6, "Request buffer:\n", m_GabiRequestBuffer.pVirtualAddress, 0x20);
   DumpBytes (6, "Response buffer:\n", m_GabiResponseBuffer.pVirtualAddress, 0x20);
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "----------------------------------------------------", (int)(jiffies-jiffies0)); } while (0);
  }
  do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "GabiExecuteCommand(): call GABI...(0x%p)\n", (int)(jiffies-jiffies0), m_fGabiExec); } while (0);
  ulPhysAddrINB = (ULONG) m_GabiRequestBuffer.PhysicalAddress;
  ulPhysAddrOUTB = (ULONG) m_GabiResponseBuffer.PhysicalAddress;
  ulPhysAddrCB = (ULONG) m_GabiControlBuffer.PhysicalAddress;
  smbus_CallGabi(ulPhysAddrINB, ulPhysAddrOUTB, ulPhysAddrCB, (GABI_CMD_ROUTINE_VOID)m_fGabiExec);
  do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus(%d):" "GabiExecuteCommand(): ...back from GABI (0x%p)\n", (int)(jiffies-jiffies0), m_fGabiExec); } while (0);
  if (smbusDebug> 0)
  {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "----------------------------------------------------", (int)(jiffies-jiffies0)); } while (0);
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Dumps of GABI buffers after request...", (int)(jiffies-jiffies0)); } while (0);
   DumpBytes (6, "Control buffer:\n", m_GabiControlBuffer.pVirtualAddress, 0x20);
   DumpBytes (6, "Response buffer:\n", m_GabiResponseBuffer.pVirtualAddress, 0x20);
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "----------------------------------------------------", (int)(jiffies-jiffies0)); } while (0);
  }
  pCtrl = (GABI_CONTROL_BUFFER *)m_GabiControlBuffer.pVirtualAddress;
  if (smbusDebug> 0)
  {
   do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "GabiExecuteCommand(): control buffer size  : %04X\n", (int)(jiffies-jiffies0), pCtrl->AllocatedBufferSize); } while (0);
   do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "Gabi                  service category code: %04X\n", (int)(jiffies-jiffies0), pCtrl->ServiceCategoryCode); } while (0);
   do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "Gabi                  service code         : %04X\n", (int)(jiffies-jiffies0), pCtrl->ServiceCode); } while (0);
   do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus(%d):" "Gabi                  general status       : %04X\n", (int)(jiffies-jiffies0), pCtrl->GeneralStatus); } while (0);
   do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus(%d):" "Gabi                  error code           : %04X\n", (int)(jiffies-jiffies0), pCtrl->ErrorCode); } while (0);
   do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus(%d):" "Gabi                  action code          : %04X\n", (int)(jiffies-jiffies0), pCtrl->ActionCode); } while (0);
  }
  pCallerControlBuffer = (GABI_CONTROL_BUFFER *)pOutBuffer;
  memcpy (pCallerControlBuffer, m_GabiControlBuffer.pVirtualAddress, allocatedControlBufferSize);
  pCallerControlBuffer->AllocatedBufferSize = allocatedControlBufferSize;
  pCallerResponseBuffer->AllocatedBufferSize = allocatedResponseBufferSize;
  PrepBufOK = GabiReturnGabiBuffer (&m_GabiResponseBuffer, pCallerResponseBuffer, pResponseDescriptorList);
  *ReturnDataSize = controlBufferInputSize + pCallerResponseBuffer->AllocatedBufferSize;
  do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "GabiExecuteCommand(): %d bytes copied to output buffer\n", (int)(jiffies-jiffies0), *ReturnDataSize); } while (0);
  success = 1;
  if (useDataDescriptorList)
  {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "GabiExecuteCommand(): free allocated descriptor lists\n", (int)(jiffies-jiffies0)); } while (0);
   GabiFreeDescriptorLists (pRequestDescriptorList);
   pRequestDescriptorList = NULL;
   GabiFreeDescriptorLists (pResponseDescriptorList);
   pResponseDescriptorList = NULL;
   m_pFreeVirtStMemGABI = m_pGABIStaticPage.pVirtualAddress;
   m_pFreePhysStMemGABI = m_pGABIStaticPage.PhysicalAddress;
   m_FreeStMemGABI = 4*1024;
  }
  break;
 }
 if (useDataDescriptorList)
 {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "GabiExecuteCommand(): free allocated descriptor lists\n", (int)(jiffies-jiffies0)); } while (0);
  if (pRequestDescriptorList != NULL)
  {
   GabiFreeDescriptorLists (pRequestDescriptorList);
   pRequestDescriptorList = NULL;
  }
  if (pResponseDescriptorList != NULL)
  {
   GabiFreeDescriptorLists (pResponseDescriptorList);
   pResponseDescriptorList = NULL;
  }
  m_pFreeVirtStMemGABI = m_pGABIStaticPage.pVirtualAddress;
  m_pFreePhysStMemGABI = m_pGABIStaticPage.PhysicalAddress;
  m_FreeStMemGABI = 4*1024;
 }
 return success;
}
static BOOL GabiPrepareGabiBuffer (PHYSICAL_MEMORY_DESCRIPTOR *bufferDescr, GABI_DATA_BUFFER_COMMON_HEADER *pInputDataBuffer, PHYSICAL_MEMORY_DESCRIPTOR_LIST *pDescriptorList, LPCSTR pBufferName, BOOL copyRequestData)
{
 BOOL success = 1;
 if (pDescriptorList == NULL)
 {
  do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "PrepareGabiBuffer \"%s\" - with flat data\n", (int)(jiffies-jiffies0), pBufferName); } while (0);
  if (copyRequestData)
  {
   do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "  copy header and data (%d bytes)\n", (int)(jiffies-jiffies0), pInputDataBuffer->AllocatedBufferSize); } while (0);
   memcpy (bufferDescr->pVirtualAddress, pInputDataBuffer, pInputDataBuffer->AllocatedBufferSize);
  }
  else
  {
   do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "  copy header only (%ld bytes)\n", (int)(jiffies-jiffies0), (ULONG)(((size_t) &((GABI_DATA_BUFFER_COMMON_HEADER *)0)->Data))); } while (0);
   memcpy (bufferDescr->pVirtualAddress, pInputDataBuffer, (((size_t) &((GABI_DATA_BUFFER_COMMON_HEADER *)0)->Data)));
  }
  if (smbusDebug> 0)
  {
   DumpBytes (6, "Input data:\n", bufferDescr->pVirtualAddress, 0x30);
  }
 }
 else
 {
  GABI_DATA_BUFFER_DESCR_HEADER *pInputData = NULL;
  GABI_DATA_BUFFER_DESCR_HEADER *pGabiBuffer = NULL;
  DWORD requiredDataSize = 0;
  do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "PrepareGabiBuffer \"%s\" - with descriptor list\n", (int)(jiffies-jiffies0), pBufferName); } while (0);
  pInputData = (GABI_DATA_BUFFER_DESCR_HEADER *)pInputDataBuffer;
  pGabiBuffer = (GABI_DATA_BUFFER_DESCR_HEADER *)bufferDescr->pVirtualAddress;
  memcpy (pGabiBuffer, pInputData, (((size_t) &((GABI_DATA_BUFFER_DESCR_HEADER *)0)->Data)));
  pGabiBuffer->AllocatedBufferSize = (((size_t) &((GABI_DATA_BUFFER_DESCR_HEADER *)0)->Data)) + (sizeof (GABISYS_DATA_DESCRIPTOR));
  requiredDataSize = (DWORD)pInputData->DataSize;
  do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "  required data size = 0x%04x\n", (int)(jiffies-jiffies0), requiredDataSize); } while (0);
  if (requiredDataSize > 0)
  {
   GABISYS_DATA_DESCRIPTOR *pCurrentGabiDescriptor = NULL;
   DWORD_PTR dataStartOffset = 0;
   DWORD_PTR freeSpaceInDataBuffer = 0;
   DWORD nrGabiDecriptorBlocks = 0;
   dataStartOffset = pGabiBuffer->AllocatedBufferSize + (sizeof (GABISYS_DATA_DESCRIPTOR));
   freeSpaceInDataBuffer = bufferDescr->AllocatedSize - dataStartOffset;
   do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "  data offset = 0x%08x\n", (int)(jiffies-jiffies0), (DWORD)dataStartOffset); } while (0);
   do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "  free space in data buffer = 0x%08x\n", (int)(jiffies-jiffies0), (DWORD)freeSpaceInDataBuffer); } while (0);
   nrGabiDecriptorBlocks = 0;
   pCurrentGabiDescriptor = (GABISYS_DATA_DESCRIPTOR *)pGabiBuffer->Data;
   if (requiredDataSize < freeSpaceInDataBuffer)
   {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "  -> descriptor data buffer fits in response buffer - use that buffer and create descriptor\n", (int)(jiffies-jiffies0)); } while (0);
    pDescriptorList->ActNumberOfEntries = -1;
    pDescriptorList->pNext = NULL;
    pDescriptorList->Descriptor[0].AllocatedSize = requiredDataSize;
    pDescriptorList->Descriptor[0].PhysicalAddress = bufferDescr->PhysicalAddress + dataStartOffset;
    pDescriptorList->Descriptor[0].pVirtualAddress = (PBYTE)bufferDescr->pVirtualAddress + dataStartOffset;
    do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "  descriptor[0]: size = 0x%08x, phys addr = 0x%016llx, virtual addr = 0x%p\n", (int)(jiffies-jiffies0), (DWORD) pDescriptorList->Descriptor[0].AllocatedSize, pDescriptorList->Descriptor[0].PhysicalAddress, pDescriptorList->Descriptor[0].pVirtualAddress); } while (0);
    pCurrentGabiDescriptor->BlockSize = pDescriptorList->Descriptor[0].AllocatedSize;
    pCurrentGabiDescriptor->BlockAddressPhysical = pDescriptorList->Descriptor[0].PhysicalAddress;
    nrGabiDecriptorBlocks = 1;
    if (copyRequestData)
    {
     do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "  -> copy request data into the GABI buffer\n", (int)(jiffies-jiffies0)); } while (0);
     memcpy (pDescriptorList->Descriptor[0].pVirtualAddress, pInputData->Data, requiredDataSize);
     if (smbusDebug> 0)
     {
      DumpBytes (6, "Request data:\n", pDescriptorList->Descriptor[0].pVirtualAddress, requiredDataSize);
     }
    }
    else
    {
     do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "  just create the descriptor list\n", (int)(jiffies-jiffies0)); } while (0);
    }
   }
   else
   {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "  -> descriptor data buffer does not fit into response buffer - allocate extra buffer(s)\n", (int)(jiffies-jiffies0)); } while (0);
    if ((m_pFreeVirtStMemGABI == NULL) || (m_FreeStMemGABI == 0) ||
     (requiredDataSize > (4*1024 / 2)) || (requiredDataSize > m_FreeStMemGABI))
    {
     do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "  ## WARNING: cannot fulfill this request. Not enough memory available (req=%d, avail=%d, virt=%p)\n", (int)(jiffies-jiffies0), requiredDataSize, m_FreeStMemGABI, m_pFreeVirtStMemGABI); } while (0);
     success = 0;
     return 0;
    }
    else
    {
     BYTE *pMem = NULL;
     PHYSICAL_MEMORY_DESCRIPTOR *pdescr = NULL;
     pDescriptorList->ActNumberOfEntries = 0;
     pMem = (BYTE *) m_pFreeVirtStMemGABI;
     do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "      alloc succeeded, add buffer to descriptor list\n", (int)(jiffies-jiffies0)); } while (0);
     if (pDescriptorList->ActNumberOfEntries >= pDescriptorList->MaxEntries)
     {
      PHYSICAL_MEMORY_DESCRIPTOR_LIST *pNewDescriptorList = NULL;
      do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "    internal descriptor table is full, allocate a new one...\n", (int)(jiffies-jiffies0)); } while (0);
      pNewDescriptorList = GabiAllocateDescriptorList();
      do { if (smbusDebug & (1 << (5))) printk(KERN_DEBUG "smbus(%d):" "    -> new descriptor list allocated at 0x%p\n", (int)(jiffies-jiffies0), pNewDescriptorList); } while (0);
      if (pNewDescriptorList)
      {
       pDescriptorList->pNext = pNewDescriptorList;
       pDescriptorList = pNewDescriptorList;
      }
      else
      {
       do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "\n## ERROR! CGabi::PrepareGabiBuffer(): Failed to allocate another descriptor table!!\n", (int)(jiffies-jiffies0)); } while (0);
       success = 0;
       return 0;
      }
     }
     pdescr = &(pDescriptorList->Descriptor[pDescriptorList->ActNumberOfEntries]);
     pDescriptorList->ActNumberOfEntries++;
     pdescr->AllocatedSize = requiredDataSize;
     pdescr->pVirtualAddress = pMem;
     pdescr->PhysicalAddress = m_pFreePhysStMemGABI;
     do { if (smbusDebug & (1 << (5))) printk(KERN_DEBUG "smbus(%d):" "    added memory block #%d to descriptor list; size=%ld, phys addr=0x%016llx, virt addr=0x%p\n", (int)(jiffies-jiffies0), nrGabiDecriptorBlocks, pdescr->AllocatedSize, pdescr->PhysicalAddress, pdescr->pVirtualAddress); } while (0);
     pCurrentGabiDescriptor->BlockAddressPhysical = pdescr->PhysicalAddress;
     pCurrentGabiDescriptor->BlockSize = pdescr->AllocatedSize;
     pCurrentGabiDescriptor++;
     nrGabiDecriptorBlocks++;
     if (copyRequestData)
     {
      do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "    -> copy memory block to GABI buffer", (int)(jiffies-jiffies0)); } while (0);
      memcpy (pMem, pInputData->Data, requiredDataSize);
      if (smbusDebug> 0)
      {
       DumpBytes (6, "Input data:\n", pMem, requiredDataSize);
      }
     }
     m_FreeStMemGABI = m_FreeStMemGABI - requiredDataSize;
     if (m_FreeStMemGABI > 0)
     {
      m_pFreeVirtStMemGABI = m_pFreeVirtStMemGABI + requiredDataSize;
      m_pFreePhysStMemGABI = m_pFreePhysStMemGABI + requiredDataSize;
      do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "memory of Gabi Static page still available (%d, VirtAddr=0x%p, PhysAddr = 0x%016lx\n", (int)(jiffies-jiffies0), m_FreeStMemGABI, m_pFreeVirtStMemGABI, m_pFreePhysStMemGABI); } while (0);
     }
     else
     {
      do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "## WARNING: all memory from Gabi Static page consumed !\n", (int)(jiffies-jiffies0)); } while (0);
      m_FreeStMemGABI = 0;
      m_pFreeVirtStMemGABI = NULL;
      m_pFreePhysStMemGABI = 0;
     }
    }
   }
   pGabiBuffer->AllocatedBufferSize = (WORD)((((size_t) &((GABI_DATA_BUFFER_DESCR_HEADER *)0)->Data)) + (nrGabiDecriptorBlocks * (sizeof (GABISYS_DATA_DESCRIPTOR))));
   do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "  allocated buffer size (with descriptors) = 0x%04x\n", (int)(jiffies-jiffies0), pGabiBuffer->AllocatedBufferSize); } while (0);
   if (smbusDebug> 0)
   {
    DumpBytes (6, "Descriptor table dump:\n", pGabiBuffer->Data, nrGabiDecriptorBlocks * sizeof (PHYSICAL_MEMORY_DESCRIPTOR));
   }
  }
 }
 return success;
}
static BOOL GabiReturnGabiBuffer (PHYSICAL_MEMORY_DESCRIPTOR *bufferDescr, GABI_DATA_BUFFER_COMMON_HEADER *pReturnDataBuffer, PHYSICAL_MEMORY_DESCRIPTOR_LIST *pDescriptorList)
{
 BOOL success = 0;
 if (pDescriptorList == NULL)
 {
  GABI_DATA_BUFFER_COMMON_HEADER *pGabiBuffer = NULL;
  DWORD returnBufferSize = 0;
  DWORD returnDataSize = 0;
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "ReturnGabiBuffer - with flat data\n", (int)(jiffies-jiffies0)); } while (0);
  pGabiBuffer = (GABI_DATA_BUFFER_COMMON_HEADER *)bufferDescr->pVirtualAddress;
  returnBufferSize = pReturnDataBuffer->AllocatedBufferSize;
  returnDataSize = pGabiBuffer->AllocatedBufferSize;
  do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "ReturnGabiBuffer:   return data size = %d, return buffer size = %d\n", (int)(jiffies-jiffies0), returnDataSize, returnBufferSize); } while (0);
  if (returnDataSize > returnBufferSize)
  {
   returnDataSize = returnBufferSize;
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "\n## ERROR! CGabi::ReturnGabiBuffer(): Returned data size > return buffer size - return data will be cut!!\n", (int)(jiffies-jiffies0)); } while (0);
  }
  do { if (smbusDebug & (1 << (5))) printk(KERN_DEBUG "smbus(%d):" "  return %d bytes of data directly from GABI buffer\n", (int)(jiffies-jiffies0), returnDataSize); } while (0);
  memcpy (pReturnDataBuffer, pGabiBuffer, returnDataSize);
  if (smbusDebug> 0)
  {
   DumpBytes (6, "Response data:\n", (BYTE *)pReturnDataBuffer, returnDataSize);
  }
  success = 1;
 }
 else
 {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "ReturnGabiBuffer - with descriptor list\n", (int)(jiffies-jiffies0)); } while (0);
  if (pReturnDataBuffer->AllocatedBufferSize >= (((size_t) &((GABI_DATA_BUFFER_DESCR_HEADER *)0)->Data)))
  {
   GABI_DATA_BUFFER_DESCR_HEADER *pReturnDataBufferDescr = NULL;
   GABI_DATA_BUFFER_DESCR_HEADER *pGabiBuffer = NULL;
   DWORD returnBufferSize = 0;
   DWORD returnDataSize = 0;
   pReturnDataBufferDescr = (GABI_DATA_BUFFER_DESCR_HEADER *)pReturnDataBuffer;
   pGabiBuffer = (GABI_DATA_BUFFER_DESCR_HEADER *)bufferDescr->pVirtualAddress;
   returnBufferSize = pReturnDataBuffer->AllocatedBufferSize - (((size_t) &((GABI_DATA_BUFFER_DESCR_HEADER *)0)->Data));
   returnDataSize = (DWORD)pGabiBuffer->DataSize;
   if (smbusDebug> 0)
   {
    do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "  allocated data size = 0x%04x\n", (int)(jiffies-jiffies0), pReturnDataBuffer->AllocatedBufferSize); } while (0);
    do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "  response buffer size = 0x%04x\n", (int)(jiffies-jiffies0), returnBufferSize); } while (0);
    do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "  response data size (supplied by GABI) = 0x%04x\n", (int)(jiffies-jiffies0), returnDataSize); } while (0);
   }
   memcpy (pReturnDataBufferDescr, pGabiBuffer, (((size_t) &((GABI_DATA_BUFFER_DESCR_HEADER *)0)->Data)));
   if (pDescriptorList->ActNumberOfEntries == -1)
   {
    DWORD descrDataSize = 0;
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "  -> one single data block within GABI buffer (following descriptor table)\n", (int)(jiffies-jiffies0)); } while (0);
    descrDataSize = (DWORD)pDescriptorList->Descriptor[0].AllocatedSize;
    do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "  data size (in descriptor) = 0x%08x\n", (int)(jiffies-jiffies0), descrDataSize); } while (0);
    if (returnDataSize)
    {
     if (returnDataSize > descrDataSize)
     {
      returnDataSize = descrDataSize;
      do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "\n## ERROR! CGabi::ReturnGabiBuffer(): Response data size > descriptor buffer size - return data will be cut!!\n", (int)(jiffies-jiffies0)); } while (0);
     }
     if (returnDataSize > returnBufferSize)
     {
      returnDataSize = returnBufferSize;
      do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "\n## ERROR! CGabi::ReturnGabiBuffer(): Response data size > response buffer size - return data will be cut!!\n", (int)(jiffies-jiffies0)); } while (0);
     }
     do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "  copy response data...\n", (int)(jiffies-jiffies0)); } while (0);
     memcpy (pReturnDataBufferDescr->Data, pDescriptorList->Descriptor[0].pVirtualAddress, returnDataSize);
     if (smbusDebug> 0)
     {
      DumpBytes (6, "Response data:\n", pReturnDataBufferDescr->Data, returnDataSize);
     }
     success = 1;
    }
   }
   else if (pDescriptorList->ActNumberOfEntries > 0)
   {
    SIZE_T remainingDataSize = returnDataSize;
    DWORD_PTR offset = 0;
    INT_PTR descrEntryIndex = 0;
    INT_PTR nrGabiDecriptorBlocks = 0;
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "  -> multiple allocated data blocks", (int)(jiffies-jiffies0)); } while (0);
    success = 1;
    while (remainingDataSize > 0)
    {
     PHYSICAL_MEMORY_DESCRIPTOR *pdescr = NULL;
     if (descrEntryIndex >= pDescriptorList->ActNumberOfEntries)
     {
      do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "    -> next descriptor list", (int)(jiffies-jiffies0)); } while (0);
      pDescriptorList = pDescriptorList->pNext;
      descrEntryIndex = 0;
     }
     if (pDescriptorList == NULL)
     {
      do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "\n## ERROR! CGabi::ReturnGabiBuffer(): Not enough descriptors available for returning data!!\n", (int)(jiffies-jiffies0)); } while (0);
      success = 0;
      break;
     }
     pdescr = &pDescriptorList->Descriptor[descrEntryIndex];
     do { if (smbusDebug & (1 << (5))) printk(KERN_DEBUG "smbus(%d):" "    descriptor [%d]: size = %ld, phys addr = 0x%016llx, virt addr = 0x%p", (int)(jiffies-jiffies0), nrGabiDecriptorBlocks, pdescr->AllocatedSize, pdescr->PhysicalAddress, pdescr->pVirtualAddress); } while (0);
     if (pdescr->AllocatedSize && pdescr->pVirtualAddress)
     {
      DWORD nrBytes = 0;
      nrBytes = (remainingDataSize < pdescr->AllocatedSize) ? remainingDataSize : pdescr->AllocatedSize;
      memcpy (pReturnDataBufferDescr->Data + offset, pdescr->pVirtualAddress, nrBytes);
      if (smbusDebug> 0)
      {
       DumpBytes (6, "Return data:\n", pReturnDataBufferDescr->Data + offset, nrBytes);
      }
      remainingDataSize -= nrBytes;
      offset += nrBytes;
     }
     else
     {
      do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "\n## ERROR! CGabi::ReturnGabiBuffer(): size or address in descriptor #%d is zero!!\n", (int)(jiffies-jiffies0), nrGabiDecriptorBlocks); } while (0);
      success = 0;
      break;
     }
     descrEntryIndex++;
     nrGabiDecriptorBlocks++;
    }
    do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "  total number bytes copied = %ld", (int)(jiffies-jiffies0), offset); } while (0);
   }
   else
   {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "  no return data\n", (int)(jiffies-jiffies0)); } while (0);
   }
   pReturnDataBuffer->AllocatedBufferSize = (WORD)((((size_t) &((GABI_DATA_BUFFER_DESCR_HEADER *)0)->Data)) + returnDataSize);
  }
  else
  {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "\n## ERROR! CGabi::ReturnGabiBuffer(): Response buffer size too small to keep at least response header!\n", (int)(jiffies-jiffies0)); } while (0);
  }
 }
 return success;
}
static PHYSICAL_MEMORY_DESCRIPTOR_LIST *GabiAllocateDescriptorList(void)
{
 PHYSICAL_MEMORY_DESCRIPTOR_LIST *pDescriptorList = NULL;
 pDescriptorList = (PHYSICAL_MEMORY_DESCRIPTOR_LIST *)kmalloc(sizeof(PHYSICAL_MEMORY_DESCRIPTOR_LIST), GFP_USER);
 do { if (smbusDebug & (1 << (5))) printk(KERN_DEBUG "smbus(%d):" "Allocated data descriptor list, address = 0x%p, size = %ld\n", (int)(jiffies-jiffies0), pDescriptorList, (ULONG)sizeof(PHYSICAL_MEMORY_DESCRIPTOR_LIST)); } while (0);
 if (pDescriptorList)
 {
  memset (pDescriptorList, 0, sizeof (PHYSICAL_MEMORY_DESCRIPTOR_LIST));
  pDescriptorList->MaxEntries = 3;
  pDescriptorList->ActNumberOfEntries = -1;
 }
 else
 {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "CGabi::ExecuteCommand(): ## ERROR! Failed to allocate data descriptor list!\n", (int)(jiffies-jiffies0)); } while (0);
 }
 return pDescriptorList;
}
static void GabiFreeDescriptorLists (PHYSICAL_MEMORY_DESCRIPTOR_LIST *pDescriptorList)
{
 PHYSICAL_MEMORY_DESCRIPTOR *pdescr = NULL;
 PHYSICAL_MEMORY_DESCRIPTOR_LIST *pNextList = NULL;
 DWORD nrDecriptorBlocks = 0;
 INT_PTR i;
 if ((pDescriptorList != NULL) && (pDescriptorList->ActNumberOfEntries == -1))
 {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "  -> In/Out-Buffer free space has been used in this DescriptorList, with only ony Descriptor\n", (int)(jiffies-jiffies0)); } while (0);
  pdescr = &pDescriptorList->Descriptor[0];
  pdescr->AllocatedSize = 0;
  pdescr->PhysicalAddress = 0;
  pdescr->pVirtualAddress = NULL;
  kfree (pDescriptorList);
 }
 else
 {
  while (pDescriptorList != NULL)
  {
   do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "GabiFreeDescriptorLists(): free descriptor list... 0x%p\n", (int)(jiffies-jiffies0), pDescriptorList); } while (0);
   for (i=0; i < pDescriptorList->ActNumberOfEntries; i++)
   {
    pdescr = &pDescriptorList->Descriptor[i];
    do { if (smbusDebug & (1 << (5))) printk(KERN_DEBUG "smbus(%d):" "  free descriptor [%d]: size = %ld, phys addr = 0x%016llx, virt addr = 0x%p", (int)(jiffies-jiffies0), nrDecriptorBlocks, pdescr->AllocatedSize, pdescr->PhysicalAddress, pdescr->pVirtualAddress); } while (0);
    pdescr->AllocatedSize = 0;
    pdescr->PhysicalAddress = 0;
    pdescr->pVirtualAddress = NULL;
    nrDecriptorBlocks++;
   }
   pNextList = pDescriptorList->pNext;
   do { if (smbusDebug & (1 << (5))) printk(KERN_DEBUG "smbus(%d):" "  free allocated descriptor list at address 0x%p", (int)(jiffies-jiffies0), pDescriptorList); } while (0);
   kfree (pDescriptorList);
   pDescriptorList = pNextList;
  }
 }
}
void smbus_CallGabi(ULONG InBuffer, ULONG OutBuffer, ULONG ControlBuffer, GABI_CMD_ROUTINE_VOID GabiEx)
{
 do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "CallGabi: InBuf=0x%016lX, OutBuf=0x%016lX, CntlBuf=0x%016lX, GabiEx=0x%p, *GabiEx=0x%p\n", (int)(jiffies-jiffies0), InBuffer, OutBuffer, ControlBuffer, GabiEx, *GabiEx); } while (0);
 ASMX86(PUSH_RRDX
  :
  : "d" (ControlBuffer));
 ASMX86(PUSH_RRSI
  :
  : "S" (OutBuffer));
 ASMX86(PUSH_RRDI
  :
  : "D" (InBuffer));
 (*(GABI_CMD_ROUTINE_VOID)m_fGabiExec)();
 ASMX86(POP_RRDI);
 ASMX86(POP_RRSI);
 ASMX86(POP_RRDX);
}
static BOOL FindBapi(ulong base, ulong offset, ulong size, DWORD signature)
{
 int i;
 char *pBiosMappedAddress = NULL;
 ulong high_mem_phy;
 high_mem_phy = (ulong)virt_to_phys(high_memory);
 m_pBapiSearchAddr = ioremap(base, (offset+size));
 do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "high_mem_phy = 0x%016lX, m_pBapiSearchAddr = 0x%p\n", (int)(jiffies-jiffies0), high_mem_phy, m_pBapiSearchAddr); } while (0);
 pBiosMappedAddress = m_pBapiSearchAddr;
 do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "BAPISearchAddress = 0x%p (0x%016lx) [+0x%016lx,0x%016lx]\n", (int)(jiffies-jiffies0), pBiosMappedAddress, base, offset, size); } while (0);
 if (pBiosMappedAddress != NULL)
 {
  unsigned char *Address = pBiosMappedAddress + offset;
  for (i = 0; i < size; i++)
  {
   DWORD *p_work = (DWORD *)(Address + i);
   if (*p_work == signature)
   {
    m_pBapiBase = (BIOS_API_HEADER_64 *)p_work;
    break;
   }
  }
  if (m_pBapiBase != NULL)
  {
   char Checksum = 0;
   if (smbusDebug> 0)
   {
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "BAPIHeader     = 0x%p (0x%016lx)\n", (int)(jiffies-jiffies0), m_pBapiBase, ((char *)m_pBapiBase - pBiosMappedAddress + base)); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "HeaderLength   = 0x%02X\n", (int)(jiffies-jiffies0), m_pBapiBase->Length); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "HeaderVersion  = 0x%02X\n", (int)(jiffies-jiffies0), m_pBapiBase->Version); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "HeaderReserved = 0x%02X\n", (int)(jiffies-jiffies0), m_pBapiBase->Reserved); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "BIOS_16_Offset = 0x%04X\n", (int)(jiffies-jiffies0), m_pBapiBase->BIOS_16_Offset); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "BIOS_16_Base   = 0x%08X\n", (int)(jiffies-jiffies0), m_pBapiBase->BIOS_16_Base); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "BIOS_32_Offset = 0x%04X\n", (int)(jiffies-jiffies0), m_pBapiBase->BIOS_32_Offset); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "BIOS_32_Base   = 0x%08X\n", (int)(jiffies-jiffies0), m_pBapiBase->BIOS_32_Base); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "BIOS_64_Offset = 0x%04X\n", (int)(jiffies-jiffies0), m_pBapiBase->BIOS_64_Offset); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "BIOS_64_Base   = 0x%08X\n", (int)(jiffies-jiffies0), m_pBapiBase->BIOS_64_Base); } while (0);
   }
   for (i = 0; i < m_pBapiBase->Length; i++)
   {
    Checksum += ((PBYTE)m_pBapiBase)[i];
   }
   if (Checksum != 0)
   {
    m_pBapiBase = NULL;
    if (m_pBapiSearchAddr != NULL)
    {
     iounmap((void *) m_pBapiSearchAddr);
     m_pBapiSearchAddr = NULL;
    }
    printk(KERN_NOTICE "smbus(%d): " "WARNING: BAPI HeaderChecksum ERROR, chksum = 0x%02X\n", (int)(jiffies-jiffies0), Checksum);
    return 0;
   }
   if (smbusArchMode & 0x20000000) {
    if ((m_pBapiBase->Version >= 0x01) &&
     (m_pBapiBase->Reserved == 0x00) &&
     (m_pBapiBase->Length == 0x1A)) {
      m_fBapiExec = (BAPI_CMD_ROUTINE)(pBiosMappedAddress + (m_pBapiBase->BIOS_64_Base + m_pBapiBase->BIOS_64_Offset - base));
    } else {
     m_fBapiExec = NULL;
    }
   } else {
    m_fBapiExec = (BAPI_CMD_ROUTINE)(pBiosMappedAddress + (m_pBapiBase->BIOS_32_Base + m_pBapiBase->BIOS_32_Offset - base));
   }
   if (m_fBapiExec == NULL)
   {
    m_pBapiBase = NULL;
    if (m_pBapiSearchAddr != NULL)
    {
     iounmap((void *) m_pBapiSearchAddr);
     m_pBapiSearchAddr = NULL;
    }
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "WARNING: BAPI Service NOT available (1)!\n", (int)(jiffies-jiffies0)); } while (0);
    return 0;
   }
   m_pVirtMemoryBAPI = NULL;
   if ((smbusArchMode & 0x20000000) || (smbusArchMode & 0x00100000))
   {
    if ((m_pVirtMemoryBAPI = VMALLOC_EXEC(4*1024)) != NULL)
    {
     memcpy(m_pVirtMemoryBAPI, (void *) m_fBapiExec, 4*1024);
     do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "m_fBapiExec (ori)    = 0x%p\n", (int)(jiffies-jiffies0), m_fBapiExec); } while (0);
     do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "m_pVirtMemoryBAPI    = 0x%p\n", (int)(jiffies-jiffies0), m_pVirtMemoryBAPI); } while (0);
     m_fBapiExec = m_pVirtMemoryBAPI;
     if (m_pBapiSearchAddr != NULL)
     {
      iounmap((void *) m_pBapiSearchAddr);
      m_pBapiSearchAddr = NULL;
     }
    }
    else
    {
     do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "WARNING: cannot get Executable-Page --> BAPI Service NOT available!\n", (int)(jiffies-jiffies0)); } while (0);
     m_pBapiBase = NULL;
     m_fBapiExec = NULL;
     if (m_pBapiSearchAddr != NULL)
     {
      iounmap((void *) m_pBapiSearchAddr);
      m_pBapiSearchAddr = NULL;
     }
     return 0;
    }
   }
   m_pBAPIStaticPage = (BAPI_STATIC_BUF *)__get_free_page(GFP_KERNEL|GFP_DMA);
   mem_map_reserve(virt_to_page(m_pBAPIStaticPage));
#ifdef CONFIG_XEN
   m_phys_BAPI_SP = page_to_phys(virt_to_page(m_pBAPIStaticPage));
   m_phys_BAPI_CB = m_phys_BAPI_SP + ((size_t) &((BAPI_STATIC_BUF *)0)->Control);
   m_phys_BAPI_DB = m_phys_BAPI_SP + ((size_t) &((BAPI_STATIC_BUF *)0)->Data);
   m_phys_BAPI_EvIn = m_phys_BAPI_SP + ((size_t) &((BAPI_STATIC_BUF *)0)->EventsIn);
   m_phys_BAPI_EvOut = m_phys_BAPI_SP + ((size_t) &((BAPI_STATIC_BUF *)0)->EventsOut);
   m_phys_BAPI_MemErr = m_phys_BAPI_SP + ((size_t) &((BAPI_STATIC_BUF *)0)->MemoryErrors);
#else
   m_phys_BAPI_SP = virt_to_phys(m_pBAPIStaticPage);
   m_phys_BAPI_CB = virt_to_phys(&m_pBAPIStaticPage->Control);
   m_phys_BAPI_DB = virt_to_phys(&m_pBAPIStaticPage->Data);
   m_phys_BAPI_EvIn = virt_to_phys(&m_pBAPIStaticPage->EventsIn);
   m_phys_BAPI_EvOut = virt_to_phys(&m_pBAPIStaticPage->EventsOut);
   m_phys_BAPI_MemErr = virt_to_phys(&m_pBAPIStaticPage->MemoryErrors);
#endif
   if (smbusDebug> 0)
   {
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "m_fBapiExec        = 0x%p\n", (int)(jiffies-jiffies0), m_fBapiExec); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "BAPIStaticPage     = 0x%p\n", (int)(jiffies-jiffies0), m_pBAPIStaticPage); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "phys_BAPI_Static   = 0x%016lx\n", (int)(jiffies-jiffies0), m_phys_BAPI_SP); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "phys_BAPI_Control  = 0x%016lx\n", (int)(jiffies-jiffies0), m_phys_BAPI_CB); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "phys_BAPI_Data     = 0x%016lx\n", (int)(jiffies-jiffies0), m_phys_BAPI_DB); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "pEventsIn          = 0x%p\n", (int)(jiffies-jiffies0), &m_pBAPIStaticPage->EventsIn); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "phys_BAPI_EvIn     = 0x%016lx\n", (int)(jiffies-jiffies0), m_phys_BAPI_EvIn); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "pEventsOut         = 0x%p\n", (int)(jiffies-jiffies0), &m_pBAPIStaticPage->EventsOut); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "phys_BAPI_EvOut    = 0x%016lx\n", (int)(jiffies-jiffies0), m_phys_BAPI_EvOut); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "pMemoryErrors      = 0x%p\n", (int)(jiffies-jiffies0), &m_pBAPIStaticPage->MemoryErrors); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "phys_BAPI_MemErr   = 0x%016lx\n", (int)(jiffies-jiffies0), m_phys_BAPI_MemErr); } while (0);
   }
   if ((m_phys_BAPI_SP > (ULONG)(0xFFFFFFFF - 0xFFFF)) ||
    (m_phys_BAPI_CB > (ULONG)(0xFFFFFFFF - 0xFFFF)) ||
    (m_phys_BAPI_DB > (ULONG)(0xFFFFFFFF - 0xFFFF)) ||
    (m_phys_BAPI_EvIn > (ULONG)(0xFFFFFFFF - 0xFFFF)) ||
    (m_phys_BAPI_EvOut > (ULONG)(0xFFFFFFFF - 0xFFFF)) ||
    (m_phys_BAPI_MemErr > (ULONG)(0xFFFFFFFF - 0xFFFF)))
   {
    mem_map_unreserve(virt_to_page(m_pBAPIStaticPage));
    free_page((ulong)m_pBAPIStaticPage);
    m_pBAPIStaticPage = NULL;
    m_phys_BAPI_SP = 0;
    m_phys_BAPI_CB = 0;
    m_phys_BAPI_DB = 0;
    m_phys_BAPI_EvIn = 0;
    m_phys_BAPI_EvOut = 0;
    m_phys_BAPI_MemErr = 0;
    m_pBapiBase = NULL;
    if (m_pBapiSearchAddr != NULL)
    {
     iounmap((void *) m_pBapiSearchAddr);
     m_pBapiSearchAddr = NULL;
    }
    if (m_pVirtMemoryBAPI != NULL)
    {
     vfree(m_pVirtMemoryBAPI);
     m_pVirtMemoryBAPI = NULL;
     m_fBapiExec = NULL;
    }
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "Cannot get Buffer-Addresses below 4 GB (resp. 16 MB) --> BAPI Service NOT available !\n", (int)(jiffies-jiffies0)); } while (0);
    return 0;
   }
   return 1;
  }
 }
 if (m_pBapiSearchAddr != NULL)
 {
  iounmap((void *) m_pBapiSearchAddr);
  m_pBapiSearchAddr = NULL;
 }
 return 0;
}
void smbus_CallBapi(ULONG InBuffer, ULONG OutBuffer, ULONG ControlBuffer, BAPI_CMD_ROUTINE_VOID BapiEx)
{
 do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "CallBapi: InBuf=0x%016lX, OutBuf=0x%016lX, CntlBuf=0x%016lX, BapiEx=0x%p, *BapiEx=0x%p\n", (int)(jiffies-jiffies0), InBuffer, OutBuffer, ControlBuffer, BapiEx, *BapiEx); } while (0);
 ASMX86(PUSH_RRDX
  :
  : "d" (ControlBuffer));
 ASMX86(PUSH_RRSI
  :
  : "S" (OutBuffer));
 ASMX86(PUSH_RRDI
  :
  : "D" (InBuffer));
 (*(BAPI_CMD_ROUTINE_VOID)m_fBapiExec)();
 ASMX86(POP_RRDI);
 ASMX86(POP_RRSI);
 ASMX86(POP_RRDX);
}
static void ReadFromIndexedPort(IOCTLDATA_INDEXED_PORT_IO *portio)
{
 outb_p(portio->IndexData, portio->IndexPort);
 portio->DataData = inb_p(portio->DataPort);
}
static void WriteToIndexedPort(IOCTLDATA_INDEXED_PORT_IO *portio)
{
 outb_p(portio->IndexData, portio->IndexPort);
 outb_p(portio->DataData, portio->DataPort);
}
void smbus_ReadCpuInfo_callback (void *pent)
{
 int sparse;
 int dense;
 CpuInfo *pentry = pent;
 sparse = smp_processor_id();
 dense = CPU_NUMBER_MAP(sparse);
 if (pentry->DenseCpuNr == dense)
 {
  pentry->SparseCpuNr = sparse;
  smbus_CpuId(0x00000000, &pentry->regs0);
  if (pentry->regs0.eax >= 0x00000001)
  {
   smbus_CpuId(0x00000001, &pentry->regs1);
   pentry->regs1Valid = 1;
   pentry->LocalApicSupported = !!(pentry->regs1.edx & (1<<9));
   pentry->MachineCheckArchitectureSupported = !!(pentry->regs1.edx & (1<<14));
   pentry->NumberLogicalCpus = (DWORD)(((pentry->regs1.ebx) >> 16) & 0xFF);
   pentry->LocalApicIdInitial = (DWORD)(((pentry->regs1.ebx) >> 24) & 0xFF);
   pentry->PrimaryLogicalCpu = !!(pentry->NumberLogicalCpus == 0 ||
                pentry->NumberLogicalCpus == 1 ||
                !(pentry->LocalApicIdInitial & 0x01));
   if (pentry->regs0.eax >= 0x00000002)
   {
    smbus_CpuId(0x00000002, &pentry->regs2);
    pentry->regs2Valid = 1;
    if (pentry->regs0.eax >= 0x00000003)
    {
     smbus_CpuId(0x00000003, &pentry->regs3);
     pentry->regs3Valid = 0;
     if (pentry->regs0.eax >= 0x00000004)
     {
      smbus_CpuId(0x00000004, &pentry->regs4);
      pentry->regs4Valid = 1;
     }
    }
   }
  }
  smbus_CpuId(0x80000000, &pentry->MaxExtentions);
  if (pentry->MaxExtentions.eax >= 0x80000004)
  {
   smbus_CpuId(0x80000002, &pentry->BrandString1);
   smbus_CpuId(0x80000003, &pentry->BrandString2);
   smbus_CpuId(0x80000004, &pentry->BrandString3);
   pentry->BrandStringValid = 1;
   if (pentry->MaxExtentions.eax >= 0x80000008)
   {
    smbus_CpuId(0x80000008, &pentry->NrCoresAMD);
    pentry->NrCoresAMDValid = 1;
   }
  }
  if (pentry->LocalApicSupported &&
   pentry->MachineCheckArchitectureSupported)
  {
   pentry->ApicBaseMsr = smbus_ReadMsr(0x01B);
   pentry->ApicBaseAddress = ((((pentry->ApicBaseMsr))) & ((DWORD64)0xffffff)<<12);
   pentry->BootstrapCpu = !!((BYTE)((((pentry->ApicBaseMsr)) >> 8) & 1));
   pentry->ApicGlobalEnable = !!((BYTE)((((pentry->ApicBaseMsr)) >> 11) & 1));
   pentry->x2ApicMode = !!((BYTE)((((pentry->ApicBaseMsr)) >> 10) & 1));
   if (pentry->ApicGlobalEnable && pentry->x2ApicMode)
   {
    pentry->x2ApicLocalApicId = smbus_ReadMsr(0x802);
    pentry->ApicId = (DWORD) pentry->x2ApicLocalApicId;
    pentry->ApicIdValid = 1;
   }
   else
   {
    pentry->ApicIdValid = 0;
   }
  }
 }
 return;
}
static void smbus_do_ReadCpuInfo(CpuInfo *pentry)
{
 int sparse;
 int dense;
 PREEMPT_DISABLE;
 sparse = smp_processor_id();
 dense = CPU_NUMBER_MAP(sparse);
 if (pentry->DenseCpuNr == dense)
 {
  pentry->SparseCpuNr = sparse;
  smbus_CpuId(0x00000000, &pentry->regs0);
  if (pentry->regs0.eax >= 0x00000001)
  {
   smbus_CpuId(0x00000001, &pentry->regs1);
   pentry->regs1Valid = 1;
   pentry->LocalApicSupported = !!(pentry->regs1.edx & (1<<9));
   pentry->MachineCheckArchitectureSupported = !!(pentry->regs1.edx & (1<<14));
   pentry->NumberLogicalCpus = (DWORD)(((pentry->regs1.ebx) >> 16) & 0xFF);
   pentry->LocalApicIdInitial = (DWORD)(((pentry->regs1.ebx) >> 24) & 0xFF);
   pentry->PrimaryLogicalCpu = !!(pentry->NumberLogicalCpus == 0 ||
                pentry->NumberLogicalCpus == 1 ||
                !(pentry->LocalApicIdInitial & 0x01));
   if (pentry->regs0.eax >= 0x00000002)
   {
    smbus_CpuId(0x00000002, &pentry->regs2);
    pentry->regs2Valid = 1;
    if (pentry->regs0.eax >= 0x00000003)
    {
     smbus_CpuId(0x00000003, &pentry->regs3);
     pentry->regs3Valid = 0;
     if (pentry->regs0.eax >= 0x00000004)
     {
      smbus_CpuId(0x00000004, &pentry->regs4);
      pentry->regs4Valid = 1;
     }
    }
   }
  }
  smbus_CpuId(0x80000000, &pentry->MaxExtentions);
  if (pentry->MaxExtentions.eax >= 0x80000004)
  {
   smbus_CpuId(0x80000002, &pentry->BrandString1);
   smbus_CpuId(0x80000003, &pentry->BrandString2);
   smbus_CpuId(0x80000004, &pentry->BrandString3);
   pentry->BrandStringValid = 1;
   if (pentry->MaxExtentions.eax >= 0x80000008)
   {
    smbus_CpuId(0x80000008, &pentry->NrCoresAMD);
    pentry->NrCoresAMDValid = 1;
   }
  }
  if (pentry->LocalApicSupported &&
   pentry->MachineCheckArchitectureSupported)
  {
   pentry->ApicBaseMsr = smbus_ReadMsr(0x01B);
   pentry->ApicBaseAddress = ((((pentry->ApicBaseMsr))) & ((DWORD64)0xffffff)<<12);
   pentry->BootstrapCpu = !!((BYTE)((((pentry->ApicBaseMsr)) >> 8) & 1));
   pentry->ApicGlobalEnable = !!((BYTE)((((pentry->ApicBaseMsr)) >> 11) & 1));
   pentry->x2ApicMode = !!((BYTE)((((pentry->ApicBaseMsr)) >> 10) & 1));
   if (pentry->ApicGlobalEnable && pentry->x2ApicMode)
   {
    pentry->x2ApicLocalApicId = smbus_ReadMsr(0x802);
    pentry->ApicId = (DWORD) pentry->x2ApicLocalApicId;
    pentry->ApicIdValid = 1;
   }
   else
   {
    pentry->ApicIdValid = 0;
   }
  }
 }
 else
 {
  SMP_CALL_FUNCTION(smbus_ReadCpuInfo_callback, (void *)pentry, 1, 1);
 }
 PREEMPT_ENABLE;
 return;
}
void smbus_ReadApicId_callback(void *pent)
{
 int sparse;
 int dense;
 CpuInfo *pentry = pent;
 sparse = smp_processor_id();
 dense = CPU_NUMBER_MAP(sparse);
 if (pentry->DenseCpuNr == dense)
 {
  pentry->ApicId = (DWORD)(readl(pentry->ApicVirtualAddress) >> 24);
 }
 return;
}
static void smbus_do_ReadApicId(CpuInfo *pentry)
{
 int sparse;
 int dense;
 PREEMPT_DISABLE;
 sparse = smp_processor_id();
 dense = CPU_NUMBER_MAP(sparse);
 if (pentry->DenseCpuNr == dense)
 {
  pentry->ApicId = (DWORD)(readl(pentry->ApicVirtualAddress) >> 24);
 } else {
  SMP_CALL_FUNCTION(smbus_ReadApicId_callback, (void *)pentry, 1, 1);
 }
 PREEMPT_ENABLE;
 return;
}
static void smbus_FillCpuInfoTable(void)
{
 int i;
 CpuInfo *pentry;
 ULONG physApicBaseAddress = 0;
 memset (&smbus_cpuinfotable, 0, sizeof(smbus_cpuinfotable));
 if (SMP_NUM_CPUS > 1024) {
  do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "smbus_FillCpuInfoTable: ERROR !!! current CPUs number exceeds the max. supported value (current = %d, max = %d)\n", (int)(jiffies-jiffies0), (int)SMP_NUM_CPUS, 1024); } while (0);
  return;
 }
 for (i=0; i < SMP_NUM_CPUS; i++)
 {
  pentry = &smbus_cpuinfotable[i];
  pentry->DenseCpuNr = i;
  pentry->regs1Valid = 0;
  pentry->regs2Valid = 0;
  pentry->regs3Valid = 0;
  pentry->regs4Valid = 0;
  pentry->BrandStringValid = 0;
  pentry->NrCoresAMDValid = 0;
  pentry->LocalApicSupported = 0;
  pentry->MachineCheckArchitectureSupported = 0;
  pentry->PrimaryLogicalCpu = 0;
  pentry->BootstrapCpu = 0;
  pentry->ApicGlobalEnable = 0;
  pentry->x2ApicMode = 0;
  pentry->ApicIdValid = 0;
  smbus_do_ReadCpuInfo(pentry);
  if (pentry->regs0.ebx == 0x756E6547)
  {
   pentry->Vendor = 0x01;
   if (pentry->regs4Valid)
   {
    pentry->NrCores = (WORD) (1 + (((pentry->regs4.eax) >> 26) & 0x3F));
   }
  }
  else
  {
   pentry->Vendor = 0x02;
   if (pentry->NrCoresAMDValid)
   {
    pentry->NrCores = (WORD) (1 + (((pentry->NrCoresAMD.ecx) >> 0) & 0xFF));
   }
  }
  if (!pentry->ApicIdValid)
  {
   if (pentry->LocalApicSupported)
   {
    if (pentry->MachineCheckArchitectureSupported)
    {
     if (pentry->ApicGlobalEnable)
     {
      if ((smbusArchMode & 0x10000000) &&
       (((pentry->ApicBaseAddress + 0x00000020) >> 32) != 0))
      {
       do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "CPU%02d: ERROR !!! APIC base address to high ! Cannot map it !\n", (int)(jiffies-jiffies0), pentry->DenseCpuNr); } while (0);
      }
      else
      {
       physApicBaseAddress = (ULONG)(pentry->ApicBaseAddress + 0x00000020);
       pentry->ApicVirtualAddress = ioremap_nocache(physApicBaseAddress, 0x10);
       if (smbusDebug> 0)
       {
        do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "CPU %d: ApicBaseAddress           = 0x%016lX\n", (int)(jiffies-jiffies0), i, (unsigned long)pentry->ApicBaseAddress); } while (0);
        do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "CPU %d: physApicBaseAddress       = 0x%016lX\n", (int)(jiffies-jiffies0), i, (unsigned long)physApicBaseAddress); } while (0);
        do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "CPU %d: MappedVirtualAddress      = 0x%p\n", (int)(jiffies-jiffies0), i, pentry->ApicVirtualAddress); } while (0);
       }
       if (pentry->ApicVirtualAddress == NULL)
       {
        do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "CPU%02d: ERROR !!! No Virtual Pointer to local APIC Id\n", (int)(jiffies-jiffies0), pentry->DenseCpuNr); } while (0);
       }
       else
       {
        smbus_do_ReadApicId(pentry);
        pentry->ApicIdValid = 1;
        iounmap((void *)pentry->ApicVirtualAddress);
       }
      }
     }
     else
     {
      do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus(%d):" "CPU%02d: INFO: Sorry ApicGlobalEnable is not enabled for this CPU\n", (int)(jiffies-jiffies0), pentry->DenseCpuNr); } while (0);
     }
    }
    else
    {
     do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus(%d):" "CPU%02d: INFO: Sorry MachineCheckArchitectureSupported not supported for this CPU\n", (int)(jiffies-jiffies0), pentry->DenseCpuNr); } while (0);
    }
   }
   else
   {
    do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus(%d):" "CPU%02d: INFO: Sorry LocalApicSupported not supported for this CPU\n", (int)(jiffies-jiffies0), pentry->DenseCpuNr); } while (0);
   }
  }
 }
 if (smbusDebug> 0)
 {
  for (i=0; i < SMP_NUM_CPUS; i++)
  {
   pentry = &smbus_cpuinfotable[i];
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "CPU%02d: sparse CPU# = %02d, dense CPU# = %02d\n", (int)(jiffies-jiffies0), i, pentry->SparseCpuNr, pentry->DenseCpuNr); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       regs1Valid             = %d\n", (int)(jiffies-jiffies0), pentry->regs1Valid); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       regs2Valid             = %d\n", (int)(jiffies-jiffies0), pentry->regs2Valid); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       regs3Valid             = %d\n", (int)(jiffies-jiffies0), pentry->regs3Valid); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       regs4Valid             = %d\n", (int)(jiffies-jiffies0), pentry->regs4Valid); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       BrandStringValid       = %d\n", (int)(jiffies-jiffies0), pentry->BrandStringValid); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       NrCoresAMDValid        = %d\n", (int)(jiffies-jiffies0), pentry->NrCoresAMDValid); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       CheckArchSupported     = %d\n", (int)(jiffies-jiffies0), pentry->MachineCheckArchitectureSupported); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       LocalApicSupported     = %d\n", (int)(jiffies-jiffies0), pentry->LocalApicSupported); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       PrimaryLogicalCpu      = %d\n", (int)(jiffies-jiffies0), pentry->PrimaryLogicalCpu); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       LocalApicIdInitial     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->LocalApicIdInitial); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       Vendor                 = %d\n", (int)(jiffies-jiffies0), pentry->Vendor); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       NrCores                = %d\n", (int)(jiffies-jiffies0), pentry->NrCores); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       NumberLogicalCpus      = %d\n", (int)(jiffies-jiffies0), pentry->NumberLogicalCpus); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       Regs 0 (cpuid) EAX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs0.eax); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EBX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs0.ebx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      ECX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs0.ecx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EDX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs0.edx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       Regs 1 (cpuid) EAX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs1.eax); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EBX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs1.ebx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      ECX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs1.ecx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EDX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs1.edx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       Regs 2 (cpuid) EAX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs2.eax); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EBX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs2.ebx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      ECX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs2.ecx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EDX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs2.edx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       Regs 3 (cpuid) EAX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs3.eax); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EBX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs3.ebx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      ECX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs3.ecx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EDX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs3.edx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       Regs 4 (cpuid) EAX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs4.eax); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EBX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs4.ebx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      ECX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs4.ecx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EDX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->regs4.edx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       NrCoresAMD     EAX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->NrCoresAMD.eax); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EBX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->NrCoresAMD.ebx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      ECX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->NrCoresAMD.ecx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EDX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->NrCoresAMD.edx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       MaxExtentions  EAX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->MaxExtentions.eax); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EBX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->MaxExtentions.ebx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      ECX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->MaxExtentions.ecx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EDX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->MaxExtentions.edx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       BrandString1   EAX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->BrandString1.eax); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EBX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->BrandString1.ebx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      ECX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->BrandString1.ecx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EDX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->BrandString1.edx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       BrandString2   EAX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->BrandString2.eax); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EBX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->BrandString2.ebx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      ECX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->BrandString2.ecx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EDX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->BrandString2.edx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       BrandString3   EAX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->BrandString3.eax); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EBX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->BrandString3.ebx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      ECX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->BrandString3.ecx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "                      EDX     = 0x%08X\n", (int)(jiffies-jiffies0), pentry->BrandString3.edx); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       ApicBaseMsr register   = 0x%016lX\n", (int)(jiffies-jiffies0), (unsigned long)pentry->ApicBaseMsr); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       ApicBaseAddress        = 0x%016lX\n", (int)(jiffies-jiffies0), (unsigned long)pentry->ApicBaseAddress); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       x2ApicLocalApicId      = 0x%016lX\n", (int)(jiffies-jiffies0), (unsigned long)pentry->x2ApicLocalApicId); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       MappedVirtualAddress   = 0x%p\n", (int)(jiffies-jiffies0), pentry->ApicVirtualAddress); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       BootstrapCpu           = %d\n", (int)(jiffies-jiffies0), pentry->BootstrapCpu); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       ApicGlobalEnable       = %d\n", (int)(jiffies-jiffies0), pentry->ApicGlobalEnable); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       x2ApicMode             = %d\n", (int)(jiffies-jiffies0), pentry->x2ApicMode); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       ApicId is valid        = %d\n", (int)(jiffies-jiffies0), pentry->ApicIdValid); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "       ApicId                 = 0x%08X\n", (int)(jiffies-jiffies0), pentry->ApicId); } while (0);
  }
 }
 return;
}
void smbus_GetCpuError_callback(void *pCpuErrInfo)
{
 int sparse;
 int dense;
 sparse = smp_processor_id();
 dense = CPU_NUMBER_MAP(sparse);
 if (((CpuErrorInfo *)pCpuErrInfo)->DenseCpuNr == dense)
 {
  smbus_ReadCpuErrorInfo((CpuErrorInfo *)pCpuErrInfo);
 }
 return;
}
static void smbus_do_GetCpuError(CpuErrorInfo *pCpuErrInfo)
{
 int sparse;
 int dense;
 PREEMPT_DISABLE;
 sparse = smp_processor_id();
 dense = CPU_NUMBER_MAP(sparse);
 if (pCpuErrInfo->DenseCpuNr == dense)
 {
  smbus_ReadCpuErrorInfo((CpuErrorInfo *)pCpuErrInfo);
 } else {
  SMP_CALL_FUNCTION(smbus_GetCpuError_callback, (void *)pCpuErrInfo, 1, 1);
 }
 PREEMPT_ENABLE;
 return;
}
static void smbus_ReadCpuErrorInfo(CpuErrorInfo *pCpuErrInfo)
{
 INT i;
 IOCTLDATA_CORR_CPU_ERROR *pError = (IOCTLDATA_CORR_CPU_ERROR *)(pCpuErrInfo->pCpuError);
 DWORD64 IA32_MCi_STATUS;
 DWORD64 IA32_MCi_ADDR;
 WORD MCAErrorCode;
 pCpuErrInfo->McgCap = smbus_ReadMsr (0x179);
 pCpuErrInfo->McgStatus = smbus_ReadMsr (0x17A);
 pCpuErrInfo->NrErrorBanks = ((BYTE)(((pCpuErrInfo->McgCap) >> 0) & 0xff));
 pCpuErrInfo->ErrorAvailable = 0;
 for (i=0; i < pCpuErrInfo->NrErrorBanks; i++)
 {
  pCpuErrInfo->MsrAddrMCiStatus = (0x401+((i)*4));
  pCpuErrInfo->MsrAddrMCiAddr = (0x402+((i)*4));
  IA32_MCi_STATUS = smbus_ReadMsr ((0x401+((i)*4)));
  if (((BYTE)(((IA32_MCi_STATUS) >> 63) & 1)))
  {
   pCpuErrInfo->ErrorAvailable = 1;
   pError->IA32MCiStatus = IA32_MCi_STATUS;
   pError->Bank = i;
   pError->ErrorCode = ((WORD)(((IA32_MCi_STATUS) >> 0) & 0xffff));
   pError->Overflow = ((BYTE)(((IA32_MCi_STATUS) >> 62) & 1));
   pError->Uncorrectable = ((BYTE)(((IA32_MCi_STATUS) >> 61) & 1));
   MCAErrorCode = pError->ErrorCode;
   if (((BYTE)(((IA32_MCi_STATUS) >> 58) & 1)))
   {
    IA32_MCi_ADDR = smbus_ReadMsr ((0x402+((i)*4)));
    pError->AddressLow = (DWORD) (IA32_MCi_ADDR & 0xffffffff);
    pError->AddressHigh = (DWORD) (IA32_MCi_ADDR >> 32);
   } else {
    pError->AddressLow = pError->AddressHigh = 0xffffffff;
   }
   pError->CacheLevel = (BYTE)((((MCAErrorCode) >> 0) & 0x3));
   pError->RequestType = (BYTE)((((MCAErrorCode) >> 4) & 0xf));
   pError->TransactionType = (BYTE)((((MCAErrorCode) >> 2) & 0x3));
   pError->ParticipationLevel = (BYTE)((((MCAErrorCode) >> 9) & 0x3));
   pError->Timeout = (BYTE)((((MCAErrorCode) >> 8) & 0x1));
   pError->MemIo = (BYTE)((((MCAErrorCode) >> 2) & 0x3));
   if ((((MCAErrorCode) & 0xff00) == 0x0100))
   {
    pError->ErrorType = CPUERR_TYPE_CACHE_ERROR;
    smbus_WriteMsr ((0x401+((i)*4)), 0);
   }
   else if ((((MCAErrorCode) & 0xf800) == 0x0800))
   {
    pError->ErrorType = CPUERR_TYPE_BUS_ERROR;
    smbus_WriteMsr ((0x401+((i)*4)), 0);
   }
   else if ((((MCAErrorCode) & 0xfff0) == 0x0010))
   {
    pError->ErrorType = CPUERR_TYPE_TLB_ERROR;
    smbus_WriteMsr ((0x401+((i)*4)), 0);
   }
   else
   {
    pError->ErrorType = CPUERR_TYPE_UNCLASSIFIED;
    smbus_WriteMsr ((0x401+((i)*4)), 0);
   }
   break;
  }
 }
 return;
}
static DWORD64 smbus_ReadMsr (DWORD address)
{
 volatile DWORD reg_eax;
 volatile DWORD reg_edx;
 ASMX86("rdmsr"
  : "=a" (reg_eax), "=d" (reg_edx)
  : "c" (address));
 return (((DWORD64)reg_edx << 32) | (DWORD64)reg_eax);
}
static void smbus_WriteMsr (DWORD address, DWORD64 data)
{
 volatile DWORD DataLow;
 volatile DWORD DataHigh;
 DataLow = (DWORD) (data & (DWORD64)0x0FFFFFFFF);
 DataHigh = (DWORD) (data >> 32);
 ASMX86("wrmsr"
  :
  : "c" (address), "a" (DataLow), "d" (DataHigh));
}
static void smbus_CpuId (DWORD address, CpuIdRegs *regs)
{
 ASMX86(PUSH_RAX);
 ASMX86(PUSH_RBX);
 ASMX86(PUSH_RCX);
 ASMX86(PUSH_RDX);
 ASMX86(RESET_RCX);
 ASMX86("cpuid"
  : "=a" (regs->eax), "=b" (regs->ebx), "=c" (regs->ecx), "=d" (regs->edx)
  : "a" (address));
 ASMX86(POP_RDX);
 ASMX86(POP_RCX);
 ASMX86(POP_RBX);
 ASMX86(POP_RAX);
}
static INT smbus_SwitchMux(DWORD DeviceHandle, PBYTE pDeviceAddress);
static BOOL smbus_ClearStatus(void);
static BOOL smbus_WaitHostBusy(void);
static BOOL smbus_WaitCmdDone(void);
static void smbus_ReleaseBus(void);
DWORD smbus_ReadData(BYTE DeviceAddress, BYTE StartOffset, PBYTE pReturnBuffer, DWORD BytesToRead)
{
 DWORD ReturnDataSize = 0;
 BYTE Data = 0;
 do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus(%d):" "smbus_ReadData: read %d SM bus data bytes from %02X:%02X\n", (int)(jiffies-jiffies0), BytesToRead, DeviceAddress, StartOffset); } while (0);
 if (my_Chipset == CS_UNKNOWN || 0 == BytesToRead || NULL == pReturnBuffer)
  return 0;
 if (smbus_ReadByte (DeviceAddress, StartOffset, &Data, 0))
 {
  PBYTE pData = (PBYTE)pReturnBuffer;
  DWORD Offset = StartOffset+1;
  *pData++ = Data;
  ReturnDataSize = 1;
  BytesToRead--;
  while (BytesToRead)
  {
   if (!(Offset < 256))
   {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "## FATAL ERROR: smbus_ReadData: Offset exceeds 255 while reading data!\n", (int)(jiffies-jiffies0)); } while (0);
    break;
   }
   if (!smbus_ReadByte (DeviceAddress, (BYTE)Offset, &Data, 1))
   {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ReadData: ERROR while reading data bytes, abort loop\n", (int)(jiffies-jiffies0)); } while (0);
    break;
   }
   *pData++ = Data;
   Offset++;
   ReturnDataSize++;
   BytesToRead--;
  }
 }
 do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus(%d):" "smbus_ReadData: %d bytes read from SM bus\n", (int)(jiffies-jiffies0), ReturnDataSize); } while (0);
 return ReturnDataSize;
}
DWORD smbus_WriteData(BYTE DeviceAddress, BYTE StartOffset, PBYTE pWriteData, DWORD BytesToWrite)
{
 DWORD WriteDataSize = 0;
 DWORD Offset = StartOffset;
 do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus(%d):" "smbus_WriteData: write %d SM bus data bytes to %02X:%02X...\n", (int)(jiffies-jiffies0), BytesToWrite, DeviceAddress, StartOffset); } while (0);
 if (my_Chipset == CS_UNKNOWN || 0 == BytesToWrite || NULL == pWriteData)
  return WriteDataSize;
 while (BytesToWrite)
 {
  if (!(Offset < 256))
  {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "## FATAL ERROR: smbus_WriteData: Offset exceeds 255 while writing data!\n", (int)(jiffies-jiffies0)); } while (0);
   break;
  }
  if (smbus_WriteByte (DeviceAddress, (BYTE)Offset, *pWriteData, 0))
  {
   WriteDataSize++;
   BytesToWrite--;
   Offset++;
   pWriteData++;
  }
  else
  {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_WriteData: ERROR while writing data bytes, abort loop\n", (int)(jiffies-jiffies0)); } while (0);
   break;
  }
 }
 if (0 == BytesToWrite)
  do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus(%d):" "smbus_WriteData: %d bytes written to SM bus\n", (int)(jiffies-jiffies0), WriteDataSize); } while (0);
 else
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "## ERROR: smbus_WriteData: Failed to write data byte 0x%02X:0x%02X!\n", (int)(jiffies-jiffies0), DeviceAddress, Offset); } while (0);
 return WriteDataSize;
}
INT smbus_OpenDevice(PDWORD pDeviceHandle, SMBUS_DEVICE_ADDRESS_DATA_ST *psmdev, DWORD size)
{
#ifdef KERNEL30
 static DEFINE_SPINLOCK(smbus_handle_lock);
#else
 static spinlock_t smbus_handle_lock = SPIN_LOCK_UNLOCKED;
#endif
 SMBUS_DEVICE_ADDRESS_DATA_ST *ptmp;
 DWORD Handle;
 INT Status = 0;
 BOOL Found = 0;
 *pDeviceHandle = (DWORD)-1;
 if ((pDeviceHandle == NULL) || (psmdev == NULL) || (size == 0))
  return 1;
 spin_lock(&smbus_handle_lock);
 do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_OpenDevice: look whether device already exists in handle table\n", (int)(jiffies-jiffies0)); } while (0);
 for (Handle=0; !Found && Handle < 256; Handle++)
 {
  if (OpenDevices[Handle] != NULL)
  {
   ptmp = (SMBUS_DEVICE_ADDRESS_DATA_ST *) OpenDevices[Handle];
   do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "smbus_OpenDevice:   check device at handle %04X (addr 0x%02X)...\n", (int)(jiffies-jiffies0), Handle, ptmp->iod_open.DeviceAddress); } while (0);
   if (0 == memcmp ((BYTE *)psmdev, (BYTE *)ptmp, size))
   {
    Found = 1;
    *pDeviceHandle = Handle;
    do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus(%d):" "smbus_OpenDevice: device already exists, return handle %04X\n", (int)(jiffies-jiffies0), *pDeviceHandle); } while (0);
   }
  }
 }
 do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_OpenDevice: create new entry\n", (int)(jiffies-jiffies0)); } while (0);
 if (!Found)
 {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_OpenDevice: device not yet existing in handle table, create new entry\n", (int)(jiffies-jiffies0)); } while (0);
  for (Handle=0; !Found && Handle < 256; Handle++)
  {
   if (OpenDevices[Handle] == NULL)
   {
    OpenDevices[Handle] = OpenDevicesPersist[Handle];
    memcpy (OpenDevices[Handle], psmdev, size);
    *pDeviceHandle = Handle;
    Found = 1;
    do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus(%d):" "smbus_OpenDevice: new handle %04X assigned\n", (int)(jiffies-jiffies0), *pDeviceHandle); } while (0);
   }
  }
  if (Handle >= 256)
  {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_OpenDevice: ## ERROR! OpenDevices table overflow!\n", (int)(jiffies-jiffies0)); } while (0);
   Status = 3;
  }
 }
 spin_unlock(&smbus_handle_lock);
 return Status;
}
INT smbus_CloseDevice(DWORD DeviceHandle)
{
 do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "smbus_CloseDevice: close device handle %d\n", (int)(jiffies-jiffies0), DeviceHandle); } while (0);
 if (DeviceHandle >= 256)
 {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_CloseDevice: ## ERROR! illegal device handle (%d)!\n", (int)(jiffies-jiffies0), DeviceHandle); } while (0);
  return 2;
 }
 else if (OpenDevices[DeviceHandle] == NULL)
 {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_CloseDevice: ## ERROR! no device opened with handle %d!\n", (int)(jiffies-jiffies0), DeviceHandle); } while (0);
  return 2;
 }
 else
 {
  memset(OpenDevices[DeviceHandle], 0, sizeof(SMBUS_DEVICE_ADDRESS_DATA_ST));
  OpenDevices[DeviceHandle] = NULL;
  return 0;
 }
}
INT smbus_ReadDevice(DWORD DeviceHandle, BYTE Offset, DWORD BytesToRead, PBYTE pReturnBuffer, PDWORD pBytesRead)
{
 INT Status = 0;
 BYTE DeviceAddress;
 *pBytesRead = 0;
 Status = smbus_SwitchMux (DeviceHandle, &DeviceAddress);
 if (0 == Status)
 {
  *pBytesRead = smbus_ReadData (DeviceAddress, Offset, pReturnBuffer, BytesToRead);
  if (0 == *pBytesRead)
   Status = 1;
 }
 return Status;
}
INT smbus_WriteDevice (DWORD DeviceHandle, BYTE Offset, DWORD BytesToWrite, PBYTE pWriteBuffer)
{
 INT Status = 0;
 BYTE DeviceAddress;
 Status = smbus_SwitchMux (DeviceHandle, &DeviceAddress);
 if (0 == Status)
 {
  DWORD BytesWritten = smbus_WriteData (DeviceAddress, Offset, pWriteBuffer, BytesToWrite);
  if (BytesToWrite != BytesWritten)
   Status = 1;
 }
 return Status;
}
BOOL smbus_ReadByte(BYTE DeviceAddress, BYTE Offset, PBYTE pData, BOOL NotUseOffset)
{
 BYTE ControlCmd;
 BOOL Success = 0;
 DWORD RetryCnt;
 if (!my_SMBusBaseAddress || !pData)
  return 0;
 ControlCmd = NotUseOffset ? ((BYTE)(1<<2)) : ((BYTE)(2<<2));
 do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus(%d):" "smbus_ReadByte: read data byte from 0x%02X:0x%02X%s\n", (int)(jiffies-jiffies0), DeviceAddress, Offset, NotUseOffset ? " - without offset" : ""); } while (0);
 for (RetryCnt=0; !Success && RetryCnt < 3; RetryCnt++)
 {
 if (!smbus_WaitHostBusy())
  {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "## ERROR: smbus_ReadByte: WaitHostBusy() failed!\n", (int)(jiffies-jiffies0)); } while (0);
  }
  else if (!smbus_ClearStatus())
  {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "## ERROR: smbus_ReadByte: ClearStatus() failed!\n", (int)(jiffies-jiffies0)); } while (0);
  }
  else
  {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ReadByte: reading data byte...\n", (int)(jiffies-jiffies0)); } while (0);
   outb_p(((DeviceAddress | ((BYTE)(1<<0)))), (int)(my_SMBusBaseAddress + (((BYTE)0x04))));
   if (!NotUseOffset)
    outb_p((Offset), (int)(my_SMBusBaseAddress + (((BYTE)0x03))));
   outb_p((ControlCmd | ((BYTE)(1<<6))), (int)(my_SMBusBaseAddress + (((BYTE)0x02))));
   Success = smbus_WaitCmdDone();
   if (Success)
   {
    *pData = inb_p((int)(my_SMBusBaseAddress + (((BYTE)0x05))));
    do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus(%d):" "smbus_ReadByte: data byte successfully read: 0x%02X!!\n", (int)(jiffies-jiffies0), *pData); } while (0);
   }
   else
   {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "## WARNING: smbus_ReadByte: WaitCmdDone() failed!\n", (int)(jiffies-jiffies0)); } while (0);
    NotUseOffset = 0;
    if(0 != Offset)
    ControlCmd = ((BYTE)(2<<2));
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "## RETRY\n", (int)(jiffies-jiffies0)); } while (0);
   }
  }
 smbus_ReleaseBus();
 }
 return Success;
}
BOOL smbus_WriteByte(BYTE DeviceAddress, BYTE Offset, BYTE Data, BOOL NotUseOffset)
{
 BYTE ControlCmd;
 BOOL Success = 0;
 DWORD RetryCnt;
 if (!my_SMBusBaseAddress)
  return 0;
 do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus(%d):" "smbus_WriteByte: write data byte 0x%02X to 0x%02X:0x%02X%s\n", (int)(jiffies-jiffies0), Data, DeviceAddress, Offset, NotUseOffset ? " - without offset" : ""); } while (0);
 ControlCmd = NotUseOffset ? ((BYTE)(1<<2)) : ((BYTE)(2<<2));
 for (RetryCnt = 0; !Success && RetryCnt < 3; RetryCnt++)
 {
  if (RetryCnt)
   do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus(%d):" "## WARNING: smbus_WriteByte: RETRY %d!!!\n", (int)(jiffies-jiffies0),RetryCnt); } while (0);
  if (!smbus_WaitHostBusy())
  {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "## ERROR: smbus_WriteByte: WaitHostBusy() failed!\n", (int)(jiffies-jiffies0)); } while (0);
  }
  else if (!smbus_ClearStatus())
  {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "## ERROR: smbus_WriteByte: ClearStatus() failed!\n", (int)(jiffies-jiffies0)); } while (0);
  }
  else
  {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_WriteByte: writing data byte...\n", (int)(jiffies-jiffies0)); } while (0);
   outb_p(((DeviceAddress | ((BYTE)(0<<0)))), (int)(my_SMBusBaseAddress + (((BYTE)0x04))));
   if (!NotUseOffset)
   {
    do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus(%d):" "smbus_WriteByte: Set Offset %02x\n", (int)(jiffies-jiffies0),Offset); } while (0);
    outb_p((Offset), (int)(my_SMBusBaseAddress + (((BYTE)0x03))));
   }
   else
   {
    do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus(%d):" "smbus_WriteByte: Set (data) %02x\n", (int)(jiffies-jiffies0),Data); } while (0);
    outb_p((Data), (int)(my_SMBusBaseAddress + (((BYTE)0x03))));
   }
   do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus(%d):" "smbus_WriteByte: Set Data   %02x\n", (int)(jiffies-jiffies0),Data); } while (0);
   outb_p((Data), (int)(my_SMBusBaseAddress + (((BYTE)0x05))));
   do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus(%d):" "smbus_WriteByte: Set Cmd    %02x\n", (int)(jiffies-jiffies0), ControlCmd | ((BYTE)(1<<6))); } while (0);
   outb_p((ControlCmd | ((BYTE)(1<<6))), (int)(my_SMBusBaseAddress + (((BYTE)0x02))));
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_WriteByte: START sleep\n", (int)(jiffies-jiffies0)); } while (0);
   set_current_state(TASK_UNINTERRUPTIBLE);
   schedule_timeout((10*HZ)/1000);
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_WriteByte: STOP  sleep\n", (int)(jiffies-jiffies0)); } while (0);
   Success = smbus_WaitCmdDone();
   if (Success) do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_WriteByte: Data byte successfully written\n", (int)(jiffies-jiffies0)); } while (0);
   smbus_ReleaseBus();
  }
 }
 if(!Success)
 {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "## ERROR: smbus_WriteByte: failed after retries!\n", (int)(jiffies-jiffies0)); } while (0);
 }
 return Success;
}
INT smbus_SwitchMux(DWORD DeviceHandle, PBYTE pDeviceAddress)
{
 INT Status = 0;
 BOOL Abort = 0;
 DWORD i;
 IOCTLDATA_SMBUS_OPEN_DEVICE *pAddr;
 if (DeviceHandle >= 256)
 {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_SwitchMux: ## ERROR! Illegal device handle (exceeds MAX_OPEN_DEVICES)!\n", (int)(jiffies-jiffies0)); } while (0);
  Status = 2;
 }
 else if ((pAddr = (IOCTLDATA_SMBUS_OPEN_DEVICE *)OpenDevices[DeviceHandle]) == NULL)
 {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_SwitchMux: ## ERROR! Illegal device handle (device not opened)!\n", (int)(jiffies-jiffies0)); } while (0);
  Status = 2;
 }
 else
 {
  *pDeviceAddress = pAddr->DeviceAddress;
  do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "smbus_SwitchMux: found DeviceAddress = 0x%02X\n", (int)(jiffies-jiffies0), *pDeviceAddress); } while (0);
  for (i = 0; !Abort && (i < 10) && (pAddr->MuxAddr[i].Address != 0xFF); i++)
  {
   SMBUS_MUX_ADDR *pMuxAddr = &pAddr->MuxAddr[i];
   do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "                    MUX detected: Addr=0x%02X, Prot=%d, AndMask=0x%02X, OrMask=0x%02X\n", (int)(jiffies-jiffies0), pMuxAddr->Address, pMuxAddr->Protocol, pMuxAddr->AndMask, pMuxAddr->OrMask); } while (0);
   switch (pMuxAddr->Protocol)
   {
   case 0:
    {
     BYTE MuxByte;
     do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "                    MUX protocol is \"WriteByte\"\n", (int)(jiffies-jiffies0)); } while (0);
     if (!smbus_ReadByte (pMuxAddr->Address, 0, &MuxByte, 1))
      Abort = 1;
     else
     {
      MuxByte = (MuxByte & pMuxAddr->AndMask) | pMuxAddr->OrMask;
      if (!smbus_WriteByte (pMuxAddr->Address, 0, MuxByte, 1))
       Abort = 1;
     }
     do { if (smbusDebug & (1 << (4))) printk(KERN_DEBUG "smbus(%d):" "smbus_SwitchMux: MUX at level %d (addr 0x%02X) switched\n", (int)(jiffies-jiffies0), i+1, pMuxAddr->Address); } while (0);
    }
    break;
   default:
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_SwitchMux: ## FATAL ERROR: Unsupported MUX protocol (%d)\n", (int)(jiffies-jiffies0), pMuxAddr->Protocol); } while (0);
    Abort = 1;
    break;
   }
  }
 }
 if (Abort)
  Status = 1;
 return Status;
}
BOOL smbus_ClearStatus(void)
{
 BYTE Status = inb_p((int)(my_SMBusBaseAddress + (((BYTE)0x00)))) & ~((BYTE)(1<<6));
 DWORD RetryCnt, WaitCnt;
 do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus(%d):" "smbus_ClearStatus: Status = 0x%02X\n", (int)(jiffies-jiffies0), Status); } while (0);
 Status &= ((((BYTE)(1<<2)) | ((BYTE)(1<<3)) | ((BYTE)(1<<4))) | ((BYTE)(1<<0)) | ((BYTE)(1<<1)));
 for (RetryCnt = 0; Status && (RetryCnt < 3); RetryCnt++)
 {
  if (RetryCnt)
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ClearStatus: ## WARNING: RETRY!!\n", (int)(jiffies-jiffies0)); } while (0);
  for (WaitCnt = 0; Status && WaitCnt < 100; WaitCnt++)
  {
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ClearStatus: Status not zero, reset it...\n", (int)(jiffies-jiffies0)); } while (0);
   outb_p(((((((BYTE)(1<<2)) | ((BYTE)(1<<3)) | ((BYTE)(1<<4))) | ((BYTE)(1<<0)) | ((BYTE)(1<<1))))), (int)(my_SMBusBaseAddress + (((BYTE)0x00))));
   udelay (10);
   Status = inb_p((int)(my_SMBusBaseAddress + (((BYTE)0x00))));
   do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus(%d):" "smbus_ClearStatus: Status after reset = 0x%02X\n", (int)(jiffies-jiffies0), Status); } while (0);
   Status &= ((((BYTE)(1<<2)) | ((BYTE)(1<<3)) | ((BYTE)(1<<4))) | ((BYTE)(1<<0)) | ((BYTE)(1<<1)));
   if (Status & ((BYTE)(1<<0)))
   {
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_ClearStatus: ## WARNING: BUSY while clearing status - send KILL command\n", (int)(jiffies-jiffies0)); } while (0);
    outb_p((((BYTE)(1<<1))), (int)(my_SMBusBaseAddress + (((BYTE)0x02))));
    set_current_state(TASK_UNINTERRUPTIBLE);
    schedule_timeout((100*HZ)/1000);
    outb_p((0), (int)(my_SMBusBaseAddress + (((BYTE)0x02))));
    break;
   }
   if (Status)
   {
    set_current_state(TASK_UNINTERRUPTIBLE);
    schedule_timeout((1*HZ)/1000);
   }
  }
 }
 return (Status == 0);
}
BOOL smbus_WaitHostBusy(void)
{
 BYTE Status;
 DWORD i;
 BYTE StatusMask = (my_Chipset == CS_INTEL_ICH) ? (((BYTE)(1<<6)) | ((BYTE)(1<<0)))
             : ((BYTE)(1<<0));
 for (i = 0; i < 35; i++)
 {
  Status = inb_p((int)(my_SMBusBaseAddress + (((BYTE)0x00))));
  if (Status & StatusMask)
  {
   set_current_state(TASK_UNINTERRUPTIBLE);
   schedule_timeout((1*HZ)/1000);
  }
  else
  {
   return 1;
  }
 }
 do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_WaitHostBusy: ## ERROR: Timeout while waiting host busy, status=0x%02X!\n", (int)(jiffies-jiffies0), Status); } while (0);
 return 0;
}
BOOL smbus_WaitCmdDone(void)
{
 BOOL Done = 0;
 BOOL Success = 0;
 BYTE Status = 0;
 DWORD i;
 int k;
 do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_WaitCmdDone: waiting until command done...\n", (int)(jiffies-jiffies0)); } while (0);
 for (i = 0; !Done && i < ((1000/50)*35); i++)
 {
 do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus(%d):" "CSmbus::WaitCmdDone: sleep %d usec.\n", (int)(jiffies-jiffies0), 50); } while (0);
 udelay (50);
  Status = inb_p((int)(my_SMBusBaseAddress + (((BYTE)0x00))));
  do { if (smbusDebug & (1 << (3))) printk(KERN_DEBUG "smbus(%d):" "smbus_WaitCmdDone: Status = 0x%02X, retry count = %d\n", (int)(jiffies-jiffies0), Status, i); } while (0);
  if (Status & (((BYTE)(1<<1)) | ((BYTE)(1<<2)) | ((BYTE)(1<<3)) | ((BYTE)(1<<4))))
  {
   Done = 1;
   if (!(Status & (((BYTE)(1<<2)) | ((BYTE)(1<<3)) | ((BYTE)(1<<4)))))
    Success = 1;
   else
   {
    LPSTR pErrMsg;
    if (Status & ((BYTE)(1<<2)))
     pErrMsg = "device error";
    else if (Status & ((BYTE)(1<<3)))
     pErrMsg = "bus error";
    else if (Status & ((BYTE)(1<<4)))
     pErrMsg = "kill";
    else
    {
     pErrMsg = "## Unknown error ##";
    }
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_WaitCmdDone: SM BUS ERROR <<%s>>, status=0x%02X!\n", (int)(jiffies-jiffies0), pErrMsg, Status); } while (0);
  for (k=0;k<50;k++)
  {
   if(Status & ((BYTE)(1<<0)))
   {
    Status = inb_p((int)(my_SMBusBaseAddress + (((BYTE)0x00))));
    do { if (smbusDebug & (1 << (2))) printk(KERN_DEBUG "smbus(%d):" "CSmbus::WaitCmdDone: wait for Status not busy (%d 0x%02X)\n", (int)(jiffies-jiffies0),k,Status); } while (0);
    udelay (5);
   }
   else break;
  }
   }
  }
 }
 if (!Done)
 {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "smbus_WaitHostBusy: ## ERROR: timeout while waiting for transaction done (status=0x%02X)!\n", (int)(jiffies-jiffies0), Status); } while (0);
 }
 return Success;
}
void smbus_ReleaseBus(void)
{
 if(CS_INTEL_ICH == my_Chipset)
 {
    outb_p((((BYTE)(1<<6))), (int)(my_SMBusBaseAddress + (((BYTE)0x00))));
    do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "CSmbus::ReleaseBus: Release ICH Semaphore\n", (int)(jiffies-jiffies0)); } while (0);
 }
}
static BOOL FindSmbi(ulong base, ulong offset, ulong size, char *signature, size_t SignatureSize)
{
 int i;
 char *pBiosMappedAddress;
 m_pSmbiSearchAddr = ioremap(base, (offset+size));
 pBiosMappedAddress = m_pSmbiSearchAddr;
 do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "SmbiSearchAddress = 0x%p (0x%016lx) [+0x%016lx,0x%016lx]\n", (int)(jiffies-jiffies0), pBiosMappedAddress, base, offset, size); } while (0);
 if (pBiosMappedAddress != NULL)
 {
  unsigned char *Address = pBiosMappedAddress + offset;
  for (i = 0; i < size; i++)
  {
   char *p_work = (char *)(Address + i);
   if (memcmp(p_work, signature, SignatureSize) == 0)
   {
    m_pSmbiBase = (SMBI_HEADER *)p_work;
    break;
   }
  }
  if (m_pSmbiBase != NULL)
  {
   if (smbusDebug> 0)
   {
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "SMBIHeader           = 0x%p (0x%016lx)\n", (int)(jiffies-jiffies0), m_pSmbiBase, ((char *)m_pSmbiBase - pBiosMappedAddress + base)); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "HeaderVersion        = 0x%02X\n", (int)(jiffies-jiffies0), m_pSmbiBase->version); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "HeaderRevision       = 0x%02X\n", (int)(jiffies-jiffies0), m_pSmbiBase->revision); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "CMD pointer          = 0x%08X\n", (int)(jiffies-jiffies0), m_pSmbiBase->CMD_Pointer); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "CMD size             = 0x%04X\n", (int)(jiffies-jiffies0), m_pSmbiBase->CMD_size); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "Result pointer       = 0x%08X\n", (int)(jiffies-jiffies0), m_pSmbiBase->Result_Pointer); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "Result size          = 0x%04X\n", (int)(jiffies-jiffies0), m_pSmbiBase->Result_size); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "SMBI command32       = 0x%08X\n", (int)(jiffies-jiffies0), m_pSmbiBase->SMB_command32); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "SMBI command32near   = 0x%08X\n", (int)(jiffies-jiffies0), m_pSmbiBase->SMB_command32near); } while (0);
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "SMBI command16       = 0x%08X\n", (int)(jiffies-jiffies0), m_pSmbiBase->SMB_command16); } while (0);
    if(0x20 == m_pSmbiBase->version)
    {
     do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "SMBI command64       = 0x%016LX\n", (int)(jiffies-jiffies0), ((SMBI_HEADER_64 *)m_pSmbiBase)->SMB_command64); } while (0);
     do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "SMBI command64near   = 0x%016LX\n", (int)(jiffies-jiffies0), ((SMBI_HEADER_64 *)m_pSmbiBase)->SMB_command64near); } while (0);
    }
   }
   if (smbusArchMode & 0x20000000)
   {
    if (0x20 == m_pSmbiBase->version)
    {
     m_fSmbiExec = (SMBI_CMD_ROUTINE)(pBiosMappedAddress + (((SMBI_HEADER_64 *)m_pSmbiBase)->SMB_command64near - base));
     do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "SMBI Exec 64-Bit     = 0x%p\n", (int)(jiffies-jiffies0), m_fSmbiExec); } while (0);
    }
    else
    {
     if (m_pSmbiSearchAddr != NULL)
     {
      iounmap((void *) m_pSmbiSearchAddr);
      m_pSmbiSearchAddr = NULL;
     }
     printk(KERN_INFO "smbus(%d): " "init_module: WARNING: SMBI 64-Bit Service NOT available (%d) !\n", (int)(jiffies-jiffies0), 1);
     return 0;
    }
   }
   else
   {
    m_fSmbiExec = (SMBI_CMD_ROUTINE)(pBiosMappedAddress + (m_pSmbiBase->SMB_command32near - base));
    do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "SMBI Exec 32-Bit     = 0x%p\n", (int)(jiffies-jiffies0), m_fSmbiExec); } while (0);
   }
   if ((smbusArchMode & 0x20000000) || (smbusArchMode & 0x00100000))
   {
    if ((pVirtMemorySmbi = VMALLOC_EXEC(4*1024)) != NULL)
    {
     memcpy(pVirtMemorySmbi, (void *) m_fSmbiExec, 4*1024);
     do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "m_fSmbiExec (ori)    = 0x%p\n", (int)(jiffies-jiffies0), m_fSmbiExec); } while (0);
     do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "pVirtMemorySmbi      = 0x%p\n", (int)(jiffies-jiffies0), pVirtMemorySmbi); } while (0);
     m_fSmbiExec = pVirtMemorySmbi;
     if (m_pSmbiSearchAddr != NULL)
     {
      iounmap((void *) m_pSmbiSearchAddr);
      m_pSmbiSearchAddr = NULL;
     }
    }
    else
    {
     do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "WARNING: cannot get Executable-Page --> SMBI 64-Bit Service NOT available!\n", (int)(jiffies-jiffies0)); } while (0);
     m_pSmbiBase = NULL;
     m_fSmbiExec = NULL;
     if (m_pSmbiSearchAddr != NULL)
     {
      iounmap((void *) m_pSmbiSearchAddr);
      m_pSmbiSearchAddr = NULL;
     }
     return 0;
    }
   }
   ulSmbiCmdBuffer = pBiosMappedAddress + (m_pSmbiBase->CMD_Pointer - base);
   ulSmbiResultBuffer = pBiosMappedAddress + (m_pSmbiBase->Result_Pointer - base);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "SMBI Command Buffer  = 0x%p\n", (int)(jiffies-jiffies0), ulSmbiCmdBuffer); } while (0);
   do { if (smbusDebug & (1 << (1))) printk(KERN_DEBUG "smbus(%d):" "SMBI Result  Buffer  = 0x%p\n", (int)(jiffies-jiffies0), ulSmbiResultBuffer); } while (0);
   return 1;
  }
  else
  {
   if (m_pSmbiSearchAddr != NULL)
   {
    iounmap((void *) m_pSmbiSearchAddr);
    m_pSmbiSearchAddr = NULL;
   }
   do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "init_module: WARNING: SMBI Service NOT available (%d) !\n", (int)(jiffies-jiffies0), 2); } while (0);
   return 0;
  }
 }
 else
 {
  do { if (smbusDebug) printk(KERN_DEBUG "smbus(%d):" "init_module: WARNING: SMBI Service NOT available (%d) !\n", (int)(jiffies-jiffies0), 3); } while (0);
  return 0;
 }
 return 0;
}
  
